using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using Terraria.DataStructures;
using TAPI;

namespace Bluemagic {
public class BluemagicPlayer : ModPlayer
{
    public bool paladinMinion = false;
    public int liquified = 0;
    private int transformFrameCounter = 0;
    public bool purityMinion = false;
    public int customMeleeEnchant = 0;
    private int customSuffocateDelay = 0;
    public bool ghoulMinion = false;
    public int numGhouls = 0;
    public float ghoulRotate = 0f;
    public int lockTime = 0;
    public bool puppet = false;
    public int rotting = 0;
    public bool fleshy = false;

    public override void PreUpdate()
    {
        ghoulRotate += 0.03f;
        if(ghoulRotate > 2f * (float)Math.PI)
        {
            ghoulRotate -= 2f * (float)Math.PI;
        }
        numGhouls = 0;
        for(int k = 0; k < 1000; k++)
        {
            Projectile proj = Main.projectile[k];
            if(proj.active && proj.owner == player.whoAmI && proj.type == ProjDef.byName["Bluemagic:Ghoul"].type)
            {
                numGhouls++;
            }
        }
        if(lockTime > 0)
        {
            lockTime--;
        }
    }

    public override void MidUpdate()
    {
        Vector2 playerPos = player.position;
        int left = (int)(player.position.X / 16f) - 1;
        int right = (int)((player.position.X + (float)player.width) / 16f) + 2;
        int up = (int)(player.position.Y / 16f) - 1;
        int down = (int)((player.position.Y + (float)player.height) / 16f) + 2;
        if (left < 0)
        {
            left = 0;
        }
        if (right > Main.maxTilesX)
        {
            right = Main.maxTilesX;
        }
        if (up < 0)
        {
            up = 0;
        }
        if (down > Main.maxTilesY)
        {
            down = Main.maxTilesY;
        }
        bool suffocating = false;
        for (int i = left; i < right; i++)
        {
            for (int j = up; j < down; j++)
            {
                if (Main.tile[i, j] != null && Main.tile[i, j].slope() == 0 && !Main.tile[i, j].inActive() && Main.tile[i, j].active())
                {
                    int type = Main.tile[i, j].type;
                    Vector2 tilePos;
                    tilePos.X = (float)(i * 16);
                    tilePos.Y = (float)(j * 16);
                    int tileHeight = 16;
                    if (Main.tile[i, j].halfBrick())
                    {
                        tilePos.Y += 8f;
                        tileHeight -= 8;
                    }
                    if (type == TileDef.byName["Bluemagic:Shroomsand"] && playerPos.X + (float)player.width - 2f >= tilePos.X && playerPos.X + 2f <= tilePos.X + 16f && playerPos.Y + (float)player.height - 2f >= tilePos.Y && playerPos.Y + 2f <= tilePos.Y + (float)tileHeight)
                    {
                        if(customSuffocateDelay < 5)
                        {
                            customSuffocateDelay += 1;
                        }
                        else
                        {
                            player.AddBuff(68, 1, true);
                        }
                        suffocating = true;
                    }
                    if (type == TileDef.byName["Bluemagic:MoltenBar"] && playerPos.X + (float)player.width >= tilePos.X && playerPos.X <= tilePos.X + 16f && playerPos.Y + (float)player.height >= tilePos.Y && (double)playerPos.Y <= (double)(tilePos.Y + (float)tileHeight) + 0.01)
                    {
                        if (!player.fireWalk)
                        {
                            player.AddBuff(67, 20, true);
                        }
                    }
                }
            }
        }
        if(!suffocating)
        {
            customSuffocateDelay = 0;
        }
        Tile floor = null;
        int bottomX = (int)(player.Bottom.X / 16f);
        int bottomY = (int)(player.Bottom.Y / 16f);
        if(Main.tile[bottomX, bottomY] != null && Main.tile[bottomX, bottomY].nactive() && TileDef.solid[Main.tile[bottomX, bottomY].type])
        {
            floor = Main.tile[bottomX, bottomY];
        }
        if(Main.tile[bottomX + 1, bottomY] != null && Main.tile[bottomX + 1, bottomY].nactive() && TileDef.solid[Main.tile[bottomX + 1, bottomY].type])
        {
            floor = Main.tile[bottomX + 1, bottomY];
        }
        if(Main.tile[bottomX - 1, bottomY] != null && Main.tile[bottomX - 1, bottomY].nactive() && TileDef.solid[Main.tile[bottomX - 1, bottomY].type])
        {
            floor = Main.tile[bottomX - 1, bottomY];
        }
        if(floor != null && floor.type == TileDef.byName["Bluemagic:DarkBlueIce"])
        {
            player.slippy = true;
        }

        if(liquified > 0)
        {
            if(player.velocity.Y == 0 || player.sliding)
            {
                if(player.velocity.X != 0f)
                {
                    player.velocity.X *= 0.8f;
                    if(player.velocity.X < 0.1f && player.velocity.X > -0.1f)
                    {
                        player.velocity.X = 0f;
                    }
                    transformFrameCounter++;
                }
            }
            else
            {
                if(player.velocity.X > 0.1f)
                {
                    player.velocity.X = 4f;
                }
                if(player.velocity.X < -0.1f)
                {
                    player.velocity.X = -4f;
                }
            }
            transformFrameCounter++;
            transformFrameCounter %= 16;
        }
        else if(rotting > 0)
        {
            if(player.moveSpeed > 0.5f)
            {
                player.moveSpeed = 0.5f;
            }
            if(player.moveSpeedMod > 1f)
            {
                player.moveSpeedMod = 1f;
            }
            if(player.velocity.Y == 0f)
            {
                if(player.velocity.X == 0f)
                {
                    transformFrameCounter = 0;
                }
                else
                {
                    transformFrameCounter += Math.Max(1, (int)Math.Abs(player.velocity.X));
                    transformFrameCounter %= 32;
                }
            }
            else
            {
                transformFrameCounter = 16;
            }
        }
        else if(fleshy)
        {
            if(player.moveSpeed > 0.5f)
            {
                player.moveSpeed = 0.5f;
            }
            if(player.moveSpeedMod > 1f)
            {
                player.moveSpeedMod = 1f;
            }
            if(player.velocity.Y == 0f)
            {
                if(player.velocity.X == 0f)
                {
                    transformFrameCounter = 0;
                }
                else
                {
                    transformFrameCounter += 1 + (int)(2f * Math.Abs(player.velocity.X));
                    if(transformFrameCounter / 6 >= Main.npcFrameCount[181])
                    {
                        transformFrameCounter = 12;
                    }
                }
            }
            else
            {
                transformFrameCounter = 6 * 14;
            }
        }
        else
        {
            transformFrameCounter = 0;
        }
    }

    public override void PostItemCheck()
    {
        if(player.frozen)
        {
            return;
        }

        Item selectedItem = player.inventory[player.selectedItem];
        if(selectedItem.type == ItemDef.byName["Bluemagic:MoltenBar"].type && !player.pulley && !player.mount.Active)
        {
            float offset = 10f * player.direction;
            Lighting.AddLight((int)((player.itemLocation.X + offset + player.velocity.X) / 16f), (int)((player.itemLocation.Y - 10f + player.velocity.Y) / 16f), 0.7f, 0.4f, 0f);
        }

        if(selectedItem.damage >= 0 && selectedItem.type > 0 && !selectedItem.noMelee && player.itemAnimation > 0)
        {
            bool flag16 = false;
            Rectangle rect = new Rectangle((int)player.itemLocation.X, (int)player.itemLocation.Y, 32, 32);
            if (!Main.dedServ)
            {
                rect.Width = Main.itemTexture[selectedItem.type].Width;
                rect.Height = Main.itemTexture[selectedItem.type].Height;
            }
            rect.Width = (int)((float)rect.Width * selectedItem.scale);
            rect.Height = (int)((float)rect.Height * selectedItem.scale);
            if (player.direction == -1)
            {
                rect.X -= rect.Width;
            }
            if (player.gravDir == 1f)
            {
                rect.Y -= rect.Height;
            }
            if (selectedItem.useStyle == 1)
            {
                if ((double)player.itemAnimation < (double)player.itemAnimationMax * 0.333)
                {
                    if (player.direction == -1)
                    {
                        rect.X -= (int)((double)rect.Width * 1.4 - (double)rect.Width);
                    }
                    rect.Width = (int)((double)rect.Width * 1.4);
                    rect.Y += (int)((double)rect.Height * 0.5 * (double)player.gravDir);
                    rect.Height = (int)((double)rect.Height * 1.1);
                }
                else
                {
                    if ((double)player.itemAnimation >= (double)player.itemAnimationMax * 0.666)
                    {
                        if (player.direction == 1)
                        {
                            rect.X -= (int)((double)rect.Width * 1.2);
                        }
                        rect.Width *= 2;
                        rect.Y -= (int)(((double)rect.Height * 1.4 - (double)rect.Height) * (double)player.gravDir);
                        rect.Height = (int)((double)rect.Height * 1.4);
                    }
                }
            }
            else
            {
                if (selectedItem.useStyle == 3)
                {
                    if ((double)player.itemAnimation > (double)player.itemAnimationMax * 0.666)
                    {
                        flag16 = true;
                    }
                    else
                    {
                        if (player.direction == -1)
                        {
                            rect.X -= (int)((double)rect.Width * 1.4 - (double)rect.Width);
                        }
                        rect.Width = (int)((double)rect.Width * 1.4);
                        rect.Y += (int)((double)rect.Height * 0.6);
                        rect.Height = (int)((double)rect.Height * 0.6);
                    }
                }
            }
            if (selectedItem.subClass != null)
            {
                rect = selectedItem.subClass.SetUseHitbox(player, rect);
            }
            if(!flag16 && selectedItem.melee && !selectedItem.noUseGraphic && customMeleeEnchant > 0)
            {
                if(customMeleeEnchant == 1)
                {
                    if(Main.rand.Next(2) == 0)
                    {
                        int dust = BluemagicDust.CreateEFlameDust(rect.X, rect.Y, rect.Width, rect.Height, player.velocity, player.direction);
                        Main.dust[dust].velocity *= 0.7f;
                        Main.dust[dust].velocity.Y += 0.5f;
                    }
                }
            }
        }
    }

    public override void PostResetEffects()
    {
        paladinMinion = false;
        if(liquified < 0)
        {
            liquified = 0;
            player.position.Y += player.height - Player.defaultHeight;
            player.width = Player.defaultWidth;
            player.height = Player.defaultHeight;
        }
        else
        {
            liquified *= -1;
        }
        purityMinion = false;
        customMeleeEnchant = 0;
        ghoulMinion = false;
        puppet = false;
        if(rotting < 0)
        {
            rotting = 0;
        }
        else
        {
            rotting *= -1;
        }
        fleshy = false;
    }

    public override void PreHurt(bool pvp, bool quiet, ref bool getHurt, ref bool playSound, ref bool genGore, ref int damage, ref int hitDirection, ref string deathText, ref bool crit, ref float critMultiplier)
    {
        if(liquified != 0)
        {
            genGore = false;
            for(int k = 0; k < damage / (double)player.statLifeMax2 * 100.0; k++)
            {
                Color color = new Color(0, 220, 40, 100);
                if(liquified == 2)
                {
                    color = new Color(0, 80, 255, 100);
                }
                Dust.NewDust(player.position, player.width, player.height, 4, hitDirection, -1f, 175, color, 1f);
            }
            playSound = false;
            Main.PlaySound(3, (int)player.position.X, (int)player.position.Y, 1);
            int choice = Main.rand.Next(3);
            if(choice == 0)
            {
                deathText = " was reduced to a puddle of gel.";
            }
            else if(choice == 1)
            {
                deathText = " was squished.";
            }
            else
            {
                deathText = " was not a very good slime.";
            }
        }
        else if(rotting != 0)
        {
            genGore = false;
            for(int k = 0; k < damage / (double)player.statLifeMax2 * 100.0; k++)
            {
                Dust.NewDust(player.position, player.width, player.height, 5, hitDirection, -1f, 0, default(Color), 1f);
            }
            playSound = false;
            Main.PlaySound(3, (int)player.position.X, (int)player.position.Y, 1);
            int choice = Main.rand.Next(3);
            if(choice == 0)
            {
                deathText = " fell apart.";
            }
            else if(choice == 1)
            {
                deathText = " was too distracted by brains.";
            }
            else
            {
                deathText = " forgot the 'un' in 'undead'.";
            }
        }
        else if(fleshy)
        {
            genGore = false;
            for(int k = 0; k < damage / (double)player.statLifeMax2 * 100.0; k++)
            {
                Dust.NewDust(player.position, player.width, player.height, 5, hitDirection, -1f, 0, default(Color), 1f);
            }
            playSound = false;
            Main.PlaySound(3, (int)player.position.X, (int)player.position.Y, 1);
            if(Main.rand.Next(2) == 0)
            {
                deathText = " was making an angry face at the monsters too much.";
            }
            else
            {
                deathText = "'s face made a good target.";
            }
        }
    }

    public bool CustomDamage(Projectile projectile, int damage, bool vary = false, bool breakImmune = false)
    {
        if(breakImmune)
        {
            player.immune = false;
            player.immuneTime = 0;
        }
        else if(player.immune)
        {
            return false;
        }
        bool crit = false;
        float critMult = 1f;
        int direction = (player.Center.X < projectile.Center.X) ? -1 : 1;
        player.ProjectileDamagePlayer(projectile, direction, ref damage, ref crit, ref critMult);
        projectile.DamagePlayer(player, direction, ref damage, ref crit, ref critMult);
        if(vary)
        {
            damage = Main.DamageVar((float)damage, projectile.player);
        }
        int defense = player.statDefense;
        player.statDefense = 0;
        int dmgDealt = (int)player.Hurt(damage, direction, false, false, Lang.deathMsg(-1, -1, projectile.whoAmI, -1), false, 1f);
        player.statDefense = defense;
        player.ProjectileDealtPlayer(projectile, direction, dmgDealt, false);
        projectile.DealtPlayer(player, direction, dmgDealt, false);
        return true;
    }

    [CallPriority(1000000f)]
    public override void ModifyDrawLayerList(List<PlayerLayer> list)
    {
        for(int k = 0; k < list.Count; k++)
        {
            if(list[k] == PlayerLayer.LayerHeldItem)
            {
                if(player.inventory[player.selectedItem].type == Bluemagic.ItemID("RuneStaff"))
                {
                    list[k] = LayerHeldItemUse5;
                }
            }
        }
        if(!player.dead && (liquified > 0 || rotting > 0 || fleshy))
        {
            foreach(PlayerLayer layer in list)
            {
                if(layer != PlayerLayer.LayerMiscEffects)
                {
                    layer.visible = false;
                }
            }
            list.Add(LayerTransform);
        }
        list.Insert(0, LayerBackSpecialFX);
        list.Add(LayerSpecialFX);
    }

    public static readonly PlayerLayer LayerTransform = new PlayerLayer.Action("Bluemagic:Transform", delegate(PlayerLayer layer, Player drawPlayer, SpriteBatch spriteBatch)
    {
        BluemagicPlayer modPlayer = drawPlayer.GetSubClass<BluemagicPlayer>();
        if(modPlayer.liquified > 0)
        {
            if(!Main.NPCLoaded[1])
            {
                Main.LoadNPC(1);
            }
            Color color = new Color(0, 220, 40, 100);
            if(modPlayer.liquified == 2)
            {
                color = new Color(0, 80, 255, 100);
            }
            int frame = 0;
            if(modPlayer.transformFrameCounter >= 8)
            {
                frame = 26;
            }
            float alpha = 175f;
            Color lightColor = Lighting.GetColor((int)(drawPlayer.Center.X / 16), (int)(drawPlayer.Center.Y / 16));
            float transp = (255f - alpha) / 255f;
            int r = (int)(lightColor.R * transp);
            int g = (int)(lightColor.G * transp);
            int b = (int)(lightColor.B * transp);
            int a = (int)(lightColor.A - alpha);
            if(a < 0)
            {
                a = 0;
            }
            DrawData item = new DrawData(Main.npcTexture[1], drawPlayer.position - Main.screenPosition, new Rectangle(0, frame, 32, 26), new Color(r, g, b, a));
            Main.playerDrawData.Add(item);
            r = (int)(lightColor.R - (255 - color.R));
            g = (int)(lightColor.G - (255 - color.G));
            b = (int)(lightColor.B - (255 - color.B));
            a = (int)(lightColor.A - (255 - color.A));
            if(r < 0)
            {
                r = 0;
            }
            if(g < 0)
            {
                g = 0;
            }
            if(b < 0)
            {
                b = 0;
            }
            if(a < 0)
            {
                a = 0;
            }
            item = new DrawData(Main.npcTexture[1], drawPlayer.position - Main.screenPosition, new Rectangle(0, frame, 32, 26), new Color(r, g, b, a));
            Main.playerDrawData.Add(item);
        }
        else if(modPlayer.rotting > 0)
        {
            int textureID = 132;
            if(modPlayer.rotting == 1)
            {
                textureID = drawPlayer.male ? 3 : 200;
            }
            if(!Main.NPCLoaded[textureID])
            {
                Main.LoadNPC(textureID);
            }
            Texture2D texture = Main.npcTexture[textureID];
            int drawX = (int)(drawPlayer.position.X + drawPlayer.width / 2 - Main.screenPosition.X);
            int drawY = (int)(drawPlayer.position.Y + drawPlayer.height - Main.screenPosition.Y) + 4;
            int frameSize = texture.Height / Main.npcFrameCount[textureID];
            int frame = modPlayer.transformFrameCounter / 8;
            if(frame > 2)
            {
                frame = 1;
            }
            SpriteEffects effects = drawPlayer.direction == -1 ? SpriteEffects.None : SpriteEffects.FlipHorizontally;
            Color color = Lighting.GetColor((int)(drawPlayer.Center.X / 16f), (int)(drawPlayer.Center.Y / 16f));
            DrawData item = new DrawData(texture, new Vector2(drawX, drawY), new Rectangle(0, frame * frameSize, texture.Width, frameSize), color, 0f, new Vector2(texture.Width / 2, frameSize), 1f, effects, 0);
            Main.playerDrawData.Add(item);
        }
        else if(modPlayer.fleshy)
        {
            if(!Main.NPCLoaded[181])
            {
                Main.LoadNPC(181);
            }
            Texture2D texture = Main.npcTexture[181];
            int drawX = (int)(drawPlayer.position.X + drawPlayer.width / 2 - Main.screenPosition.X);
            int drawY = (int)(drawPlayer.position.Y + drawPlayer.height - Main.screenPosition.Y) + 4;
            int frameSize = texture.Height / Main.npcFrameCount[181];
            int frame = modPlayer.transformFrameCounter / 6;
            SpriteEffects effects = drawPlayer.direction == -1 ? SpriteEffects.None : SpriteEffects.FlipHorizontally;
            Color color = Lighting.GetColor((int)(drawPlayer.Center.X / 16f), (int)(drawPlayer.Center.Y / 16f));
            DrawData item = new DrawData(texture, new Vector2(drawX, drawY), new Rectangle(0, frame * frameSize, texture.Width, frameSize), color, 0f, new Vector2(texture.Width / 2, frameSize), 1f, effects, 0);
            Main.playerDrawData.Add(item);
        }
    }, true);

    public static readonly PlayerLayer LayerSpecialFX = new PlayerLayer.Action("Bluemagic:SpecialFX", delegate(PlayerLayer layer, Player drawPlayer, SpriteBatch spriteBatch)
    {
        BluemagicPlayer modPlayer = drawPlayer.GetSubClass<BluemagicPlayer>();
        PlayerLayer.ExtraDrawInfo extraDrawInfo = PlayerLayer.extraDrawInfo;
        if(modPlayer.lockTime > 0)
        {
            int frame = 2;
            if(modPlayer.lockTime > 50)
            {
                frame = 0;
            }
            else if(modPlayer.lockTime > 40)
            {
                frame = 1;
            }
            Texture2D texture = Bluemagic.instance.textures["NPCs/Desert/Lock"];
            int frameSize = texture.Height / 3;
            int drawX = (int)(extraDrawInfo.Position.X + drawPlayer.width / 2f - Main.screenPosition.X);
            int drawY = (int)(extraDrawInfo.Position.Y + drawPlayer.height / 2f - Main.screenPosition.Y);
            DrawData item = new DrawData(texture, new Vector2(drawX, drawY), new Rectangle(0, frameSize * frame, texture.Width, frameSize), Lighting.GetColor((int)(drawPlayer.Center.X / 16f), (int)(drawPlayer.Center.Y / 16f)), 0f, new Vector2(texture.Width / 2f, frameSize / 2f), 1f, SpriteEffects.None, 0);
            Main.playerDrawData.Add(item);
        }
    }, true);

    public static readonly PlayerLayer LayerBackSpecialFX = new PlayerLayer.Action("Bluemagic:BackSpecialFX", delegate(PlayerLayer layer, Player drawPlayer, SpriteBatch spriteBatch)
    {
        BluemagicPlayer modPlayer = drawPlayer.GetSubClass<BluemagicPlayer>();
        PlayerLayer.ExtraDrawInfo extraDrawInfo = PlayerLayer.extraDrawInfo;
        if(modPlayer.puppet)
        {
            Texture2D texture = Bluemagic.instance.textures["NPCs/Horror/Strings"];
            int drawX = (int)(extraDrawInfo.Position.X + drawPlayer.width / 2f - Main.screenPosition.X);
            int drawY = (int)(extraDrawInfo.Position.Y - Main.screenPosition.Y);
            DrawData item = new DrawData(texture, new Vector2(drawX, drawY), null, Lighting.GetColor((int)(drawPlayer.Center.X / 16f), (int)(drawPlayer.Center.Y / 16f)), 0f, new Vector2(texture.Width / 2f, texture.Height / 2f), 1f, SpriteEffects.None, 0);
            Main.playerDrawData.Add(item);
        }
    }, true);

    public static readonly PlayerLayer LayerHeldItemUse5 = new PlayerLayer.Action("TAPI:HeldItem", delegate(PlayerLayer layer, Player drawPlayer, SpriteBatch spriteBatch)
    {
        PlayerLayer.ExtraDrawInfo extraDrawInfo = PlayerLayer.extraDrawInfo;
        if (drawPlayer.heldProj >= 0)
        {
            extraDrawInfo.drawDataCount = Main.playerDrawData.Count;
        }
        if (!drawPlayer.frozen && (drawPlayer.itemAnimation > 0 || (drawPlayer.inventory[drawPlayer.selectedItem].holdStyle > 0 && !drawPlayer.pulley && !drawPlayer.mount.Active)) && drawPlayer.inventory[drawPlayer.selectedItem].type > 0 && !drawPlayer.dead && !drawPlayer.inventory[drawPlayer.selectedItem].noUseGraphic && (!drawPlayer.wet || !drawPlayer.inventory[drawPlayer.selectedItem].noWet))
        {
            string arg_C5_0 = drawPlayer.name;
            float num = drawPlayer.itemRotation + 0.785f * (float)drawPlayer.direction;
            int num2 = 0;
            int num3 = 0;
            Vector2 origin = new Vector2(0f, (float)Main.itemTexture[drawPlayer.inventory[drawPlayer.selectedItem].type].Height);
            if (drawPlayer.gravDir == -1f)
            {
                if (drawPlayer.direction == -1)
                {
                    num += 1.57f;
                    origin = new Vector2((float)Main.itemTexture[drawPlayer.inventory[drawPlayer.selectedItem].type].Width, 0f);
                    num2 -= Main.itemTexture[drawPlayer.inventory[drawPlayer.selectedItem].type].Width;
                }
                else
                {
                    num -= 1.57f;
                    origin = Vector2.Zero;
                }
            }
            else
            {
                if (drawPlayer.direction == -1)
                {
                    origin = new Vector2((float)Main.itemTexture[drawPlayer.inventory[drawPlayer.selectedItem].type].Width, (float)Main.itemTexture[drawPlayer.inventory[drawPlayer.selectedItem].type].Height);
                    num2 -= Main.itemTexture[drawPlayer.inventory[drawPlayer.selectedItem].type].Width;
                }
            }
            if (ItemDef.holdoutOrigin.ContainsKey(drawPlayer.heldItem.type))
            {
                origin = ItemDef.holdoutOrigin[drawPlayer.heldItem.type] * new Vector2((float)Main.itemTexture[drawPlayer.heldItem.type].Width, (float)Main.itemTexture[drawPlayer.heldItem.type].Height);
                origin.X -= (float)num2;
                if (drawPlayer.direction == -1)
                {
                    origin.X = -origin.X + (float)Main.itemTexture[drawPlayer.heldItem.type].Width;
                }
            }
            DrawData item = new DrawData(Main.itemTexture[drawPlayer.inventory[drawPlayer.selectedItem].type], new Vector2((float)((int)(extraDrawInfo.Position.X + (float)(drawPlayer.width / 2) - Main.screenPosition.X + origin.X + (float)num2)), (float)((int)(extraDrawInfo.Position.Y + (float)(drawPlayer.height / 2) - Main.screenPosition.Y + (float)num3))), new Rectangle?(new Rectangle(0, 0, Main.itemTexture[drawPlayer.inventory[drawPlayer.selectedItem].type].Width, Main.itemTexture[drawPlayer.inventory[drawPlayer.selectedItem].type].Height)), drawPlayer.inventory[drawPlayer.selectedItem].GetAlpha(extraDrawInfo.colorItem), num, origin, drawPlayer.inventory[drawPlayer.selectedItem].scale, extraDrawInfo.effectsItem, 0);
            Main.playerDrawData.Add(item);
        }
    }, true);
}}