using System;
using System.Collections.Generic;
using Terraria;
using TAPI;

namespace Bluemagic {
public class BluemagicRecipes
{
    public static void AddRecipes()
    {
        if(!Recipe.fromMod.ContainsKey("Bluemagic"))
        {
            Recipe.fromMod["Bluemagic"] = new List<Recipe>();
        }
        AddDimChestRecipes();
        AddClentamistationRecipes();
    }

    private static void AddDimChestRecipes()
    {
        Recipe.newRecipe.createItem.SetDefaults(1571, false); //scourge of the corruptor
        Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(1534, false));
        Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(Bluemagic.ItemID("DimensionalChest"), false));
        Recipe.fromMod["Bluemagic"].Add(Recipe.newRecipe);
        Recipe.AddRecipe();

        Recipe.newRecipe.createItem.SetDefaults(1569, false); //vampire knives
        Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(1535, false));
        Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(Bluemagic.ItemID("DimensionalChest"), false));
        Recipe.fromMod["Bluemagic"].Add(Recipe.newRecipe);
        Recipe.AddRecipe();

        Recipe.newRecipe.createItem.SetDefaults(1156, false); //piranha gun
        Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(1533, false));
        Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(Bluemagic.ItemID("DimensionalChest"), false));
        Recipe.fromMod["Bluemagic"].Add(Recipe.newRecipe);
        Recipe.AddRecipe();

        Recipe.newRecipe.createItem.SetDefaults(1260, false); //rainbow gun
        Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(1536, false));
        Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(Bluemagic.ItemID("DimensionalChest"), false));
        Recipe.fromMod["Bluemagic"].Add(Recipe.newRecipe);
        Recipe.AddRecipe();

        Recipe.newRecipe.createItem.SetDefaults(1572, false); //staff of the frost hydra
        Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(1537, false));
        Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(Bluemagic.ItemID("DimensionalChest"), false));
        Recipe.fromMod["Bluemagic"].Add(Recipe.newRecipe);
        Recipe.AddRecipe();
    }

    private static void AddClentamistationRecipes()
    {
        int greenDroplet = Bluemagic.ItemID("GreenDroplet");
        int blueDroplet = Bluemagic.ItemID("BlueDroplet");
        int purpleDroplet = Bluemagic.ItemID("PurpleDroplet");
        int darkBlueDroplet = Bluemagic.ItemID("DarkBlueDroplet");
        int redDroplet = Bluemagic.ItemID("RedDroplet");

        int[] solutionIDs = {780, 781, 782, 783, 784};
        int[] dropletIDs = {greenDroplet, blueDroplet, purpleDroplet, darkBlueDroplet, redDroplet};
        for(int k = 0; k < 5; k++)
        {
            Recipe.newRecipe.createItem.SetDefaults(solutionIDs[k], false);
            Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(dropletIDs[k], false));
            Recipe.newRecipe.requiredItem[0].stack = 100;
            Recipe.AddRecipe();
        }

        int[] stoneIDs = {3, 409, 61, Bluemagic.ItemID("Shroomstone"), 836};
        int[] sandIDs = {169, 408, 370, Bluemagic.ItemID("Shroomsand"), 1246};
        int[] iceIDs = {664, 834, 833, Bluemagic.ItemID("DarkBlueIce"), 835};
        int[] woodIDs = {9, 621, 619, -1, 911};
        int[][] itemIDs = {stoneIDs, sandIDs, iceIDs, woodIDs};
        for(int j = 0; j < 5; j++)
        {
            for(int k = 0; k < 5; k++)
            {
                if(j != k)
                {
                    for(int x = 0; x < itemIDs.Length; x++)
                    {
                        if(itemIDs[x][j] > 0 && itemIDs[x][k] > 0)
                        {
                            AddClentaminationRecipe(itemIDs[x][j], itemIDs[x][k], solutionIDs[j], dropletIDs[j]);
                        }
                    }
                }
            }
        }
        AddClentaminationRecipe(620, 183, solutionIDs[0], dropletIDs[0]);
        AddClentaminationRecipe(183, 620, solutionIDs[3], dropletIDs[3]);
    }

    private static void AddClentaminationRecipe(int result, int ingredient, int solution, int droplet)
    {
        Recipe.newRecipe.createItem.SetDefaults(result, false);
        Recipe.newRecipe.createItem.stack = 100;
        Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(ingredient, false));
        Recipe.newRecipe.requiredItem[0].stack = 100;
        Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(solution, false));
        Recipe.newRecipe.requiredTile.Add(TileDef.byName["Bluemagic:Clentamistation"]);
        Recipe.fromMod["Bluemagic"].Add(Recipe.newRecipe);
        Recipe.AddRecipe();

        Recipe.newRecipe.createItem.SetDefaults(result, false);
        Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(ingredient, false));
        Recipe.newRecipe.requiredItem.Add(new Item().SetDefaults(droplet, false));
        Recipe.newRecipe.requiredTile.Add(TileDef.byName["Bluemagic:Clentamistation"]);
        Recipe.fromMod["Bluemagic"].Add(Recipe.newRecipe);
        Recipe.AddRecipe();
    }
}}