using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Buffs {
public class EtherealFlames : ModBuff
{
    public override void Effects(Player player, int index)
    {
        if(player.lifeRegen > 0)
        {
            player.lifeRegen = 0;
        }
        player.lifeRegenTime = 0;
        player.lifeRegen -= 16;
    }

    public override void Effects(NPC npc, int index)
    {
        if(!npc.dontTakeDamage)
        {
            if(npc.lifeRegen > 0)
            {
                npc.lifeRegen = 0;
            }
            npc.lifeRegen -= 16;
        }

        if (Main.rand.Next(4) < 3)
        {
            int dust = BluemagicDust.CreateEFlameDust(npc.position.X - 2f, npc.position.Y - 2f, npc.width, npc.height);
            Main.dust[dust].velocity += npc.velocity * 0.4f;
            Main.dust[dust].velocity *= 1.8f;
            Main.dust[dust].velocity.Y -= 0.5f;
            if (Main.rand.Next(4) == 0)
            {
                Main.dust[dust].scale *= 0.5f;
            }
        }
    }

    public override void ModifyDrawLayerList(Player drawPlayer, List<PlayerLayer> list)
    {
        if (Main.rand.Next(4) == 0)
        {
            PlayerLayer.ExtraDrawInfo extraDrawInfo = PlayerLayer.extraDrawInfo;
            int dust = BluemagicDust.CreateEFlameDust(extraDrawInfo.Position.X - 2f, extraDrawInfo.Position.Y - 2f, drawPlayer.width, drawPlayer.height);
            Main.dust[dust].velocity += drawPlayer.velocity * 0.4f;
            Main.dust[dust].velocity *= 1.8f;
            Main.dust[dust].velocity.Y -= 0.5f;
            Main.playerDrawDust.Add(dust);
        }
    }

    public override Color ModifyDrawColor(Player player, Color color)
    {
        color.R = (byte)(color.R * 0.5f);
        color.G = (byte)(color.G * 0.7f);
        return color;
    }

    public override Color ModifyDrawColor(NPC npc, Color color)
    {
        color.R = (byte)(color.R * 0.5f);
        color.G = (byte)(color.G * 0.7f);
        return color;
    }
}}