using System;
using Terraria;
using TAPI;

namespace Bluemagic.Buffs {
public class EtherealFlamesEnchant : ModBuff
{
    public override void Effects(Player player, int index)
    {
        player.GetSubClass<BluemagicPlayer>().customMeleeEnchant = 1;
    }

    public override void DealtPVP(Player player, Player victim, int hitDir, int dmgDealt, bool crit)
    {
        victim.AddBuff("Bluemagic:EtherealFlames", 60 * Main.rand.Next(3, 7), true);
    }

    public override void DealtPVP(Projectile projectile, Player victim, int hitDir, int dmgDealt, bool crit)
    {
        if(projectile.melee && !projectile.noEnchantments)
        {
            victim.AddBuff("Bluemagic:EtherealFlames", 60 * Main.rand.Next(3, 7), true);
        }
    }

    public override void DealtNPC(Player player, NPC npc, int hitDir, int dmgDealt, float knockback, bool crit)
    {
        npc.AddBuff("Bluemagic:EtherealFlames", 60 * Main.rand.Next(3, 7), false);
    }

    public override void DealtNPC(Projectile projectile, NPC npc, int hitDir, int dmgDealt, float knockback, bool crit)
    {
        if(projectile.melee && !projectile.noEnchantments)
        {
            npc.AddBuff("Bluemagic:EtherealFlames", 60 * Main.rand.Next(3, 7), false);
        }
    }
}}