using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Buffs {
public class Shadow : ModBuff
{
    public override void Effects(Player player, int index)
    {
        Color color = Lighting.GetColor((int)(player.Center.X / 16f), (int)(player.Center.Y / 16f));
        int loss = (int)(Math.Max(color.R, Math.Max(color.G, color.B)) * 20f / 255f);
        if(loss > 0)
        {
            if(player.lifeRegen > 0)
            {
                player.lifeRegen = 0;
            }
            player.lifeRegenTime = 0;
            player.lifeRegen -= loss;
            if((player.lifeRegenCount + player.lifeRegen) / 120f <= -player.statLife)
            {
                player.KillMe(10.0, 0, false, " was dissolved by the light.");
            }
        }
    }

    public override Color ModifyDrawColor(Player player, Color color)
    {
        color.R = (byte)(color.R * 0.04f);
        color.G = (byte)(color.G * 0.02f);
        color.B = (byte)(color.B * 0.04f);
        return color;
    }
}}