using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Items {
[GlobalMod]
public class GlobalItem : ModItem
{
    public override void UseItemEffects(Player player, Rectangle rect)
    {
        BluemagicPlayer modPlayer = player.GetSubClass<BluemagicPlayer>();
        if(item.melee && !item.noMelee && !item.noUseGraphic && modPlayer.customMeleeEnchant > 0)
        {
            if(modPlayer.customMeleeEnchant == 1)
            {
                if(Main.rand.Next(2) == 0)
                {
                    int dust = BluemagicDust.CreateEFlameDust(rect.X, rect.Y, rect.Width, rect.Height, player.velocity, player.direction);
                    Main.dust[dust].velocity *= 0.7f;
                    Main.dust[dust].velocity.Y += 0.5f;
                }
            }
        }
    }

    public override bool PreShoot(Player player, Vector2 position, Vector2 velocity, int projType, int damage, float knockback)
    {
        if(projType == 42)
        {
            Item sand = null;
            for(int k = 54; k < 58 && sand == null; k++)
            {
                if(player.inventory[k].ammo == 42)
                {
                    sand = player.inventory[k];
                }
            }
            for(int k = 0; k < 54 && sand == null; k++)
            {
                if(player.inventory[k].ammo == 42)
                {
                    sand = player.inventory[k];
                }
            }
            if(sand.type == Bluemagic.ItemID("Shroomsand"))
            {
                bool consumeAmmo = true;
                if(player.ammoBox && Main.rand.Next(5) == 0)
                {
                    consumeAmmo = false;
                }
                if(player.ammoPotion && Main.rand.Next(5) == 0)
                {
                    consumeAmmo = false;
                }
                if(player.ammoCost80 && Main.rand.Next(5) == 0)
                {
                    consumeAmmo = false;
                }
                if(player.ammoCost75 && Main.rand.Next(4) == 0)
                {
                    consumeAmmo = false;
                }
                if(!player.inventory[player.selectedItem].ConsumeAmmo(player))
                {
                    consumeAmmo = false;
                }
                if(consumeAmmo)
                {
                    sand.stack--;
                    if(sand.stack <= 0)
                    {
                        sand.active = false;
                        sand.name = "";
                        sand.type = 0;
                    }
                }
                projType = ProjDef.byName["Bluemagic:ShroomsandGunBall"].type;
                damage += 10;
                Vector2 direction = velocity;
                direction.Normalize();
                position += direction * item.width;
                Projectile.NewProjectile(position, velocity, projType, damage, knockback, player.whoAmI, 1f, 0f);
                return false;
            }
        }
        return base.PreShoot(player, position, velocity, projType, damage, knockback);
    }
}}