using System;
using Microsoft.Xna.Framework;

namespace Bluemagic {
/*
 * Represents a linear function on the xy plane. f(x) = mx + b
 */
public struct Line
{
    public double m;
    public double b;

    public Line(float m0, float b0)
    {
        m = m0;
        b = b0;
    }

    public Line(Vector2 pos, float angle)
    {
        m = Math.Tan(angle);
        b = (double)pos.Y - (double)pos.X * m;
    }

    public float f(float x)
    {
        return (float)(m * x + b);
    }

    public override string ToString()
    {
        return "{" + m + " x + " + b + "}";
    }
}}