using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class Abomination : ModNPC
{
    //ai[0] = attackCool
    //ai[1] = moveCool
    //ai[2] = rotation speed
    //ai[3] = captive rotation
    public int moveTime = 300;
    private int moveTimer = 60;

    public override void OnSpawn()
    {
        npc.localAI[0] = -1f;
    }

    public override void AI()
    {
        if(Main.netMode != 1 && npc.localAI[0] < 0f)
        {
            for(int x = 0; x < 5; x++)
            {
                int captive = NPC.NewNPC(npc.position, NPCDef.byName["Bluemagic:CaptiveElement"].type);
                Main.npc[captive].ai[0] = npc.whoAmI;
                Main.npc[captive].ai[1] = x;
                Main.npc[captive].ai[2] = 50 * (x + 1);
                if(x == 2)
                {
                    Main.npc[captive].damage += 20;
                }
                CaptiveElement.SetPosition(Main.npc[captive]);
                Main.npc[captive].netUpdate = true;
            }
            npc.localAI[0] = 0f;
        }
        Player player = Main.player[npc.target];
        if(!player.active || player.dead || player.position.Y < Main.hellLayer * 16)
        {
            npc.TargetClosest(false);
            player = Main.player[npc.target];
            if(!player.active || player.dead || player.position.Y < Main.hellLayer * 16)
            {
                npc.velocity = new Vector2(0f, 10f);
                if(npc.timeLeft > 10)
                {
                    npc.timeLeft = 10;
                }
                return;
            }
        }
        npc.ai[1] -= 1f;
        if(Main.netMode != 1 && npc.ai[1] <= 0f)
        {
            npc.TargetClosest(false);
            player = Main.player[npc.target];
            double angle = Main.rand.NextDouble() * 2.0 * Math.PI;
            int distance = 300 + Main.rand.Next(200);
            Vector2 moveTo = player.Center + (float)distance * new Vector2((float)Math.Cos(angle), (float)Math.Sin(angle));
            npc.ai[1] = (float)moveTime + (float)Main.rand.Next(100);
            npc.velocity = (moveTo - npc.Center) / npc.ai[1];

            npc.ai[2] = (float)(Main.rand.NextDouble() + Main.rand.NextDouble());
            if(npc.ai[2] > 1f)
            {
                npc.ai[2] = 1f + (npc.ai[2] - 1f) / 2f;
            }
            if(Main.rand.Next(2) == 0)
            {
                npc.ai[2] *= -1;
            }
            npc.ai[2] *= 0.01f;
            npc.netUpdate = true;
        }
        if(Vector2.Distance(Main.player[npc.target].position, npc.position) > 300f)
        {
            moveTimer--;
        }
        else
        {
            moveTimer += 3;
            if(moveTime >= 300 && moveTimer > 60)
            {
                moveTimer = 60;
            }
        }
        if(moveTimer <= 0)
        {
            moveTimer += 60;
            moveTime -= 3;
            if(moveTime < 99)
            {
                moveTime = 99;
                moveTimer = 0;
            }
            if(Main.netMode == 2)
            {
                BluemagicNet.SendAbominationData(npc.whoAmI);
            }
        }
        else if(moveTimer > 60)
        {
            moveTimer -= 60;
            moveTime += 3;
            if(Main.netMode == 2)
            {
                BluemagicNet.SendAbominationData(npc.whoAmI);
            }
        }
        npc.ai[3] += npc.ai[2];
        if(npc.ai[3] < 0f)
        {
            npc.ai[3] += 2f * (float)Math.PI;
        }
        if(npc.ai[3] >= (float)Math.PI)
        {
            npc.ai[3] -= 2f * (float)Math.PI;
        }

        npc.ai[0] -= 1f;
        if(Main.netMode != 1 && npc.ai[0] <= 0f)
        {
            npc.ai[0] = 200f + 200f * (float)npc.life / (float)npc.lifeMax + (float)Main.rand.Next(200);
            Vector2 delta = player.Center - npc.Center;
            float magnitude = (float)Math.Sqrt(delta.X * delta.X + delta.Y * delta.Y);
            if(magnitude > 0)
            {
                delta *= 5f / magnitude;
            }
            else
            {
                delta = new Vector2(0f, 5f);
            }
            Projectile.NewProjectile(npc.Center.X, npc.Center.Y, delta.X, delta.Y, ProjDef.byName["Bluemagic:ElementBall"].type, (npc.damage - 30) / 2, 3f, Main.myPlayer, 24f, 600f);
            npc.netUpdate = true;
        }

        for(int k = 0; k < 3; k++)
        {
            float radius = (float)Math.Sqrt(Main.rand.Next(300 * 300));
            double angle = Main.rand.NextDouble() * 2.0 * Math.PI;
            BluemagicDust.CreateSparkle(npc.Center.X + radius * (float)Math.Cos(angle), npc.Center.Y + radius * (float)Math.Sin(angle));
        }
    }

    public override void DealtPlayer(Player player, int hitDir, int dmgDealt, bool crit)
    {
        if(Main.rand.Next(2) == 0)
        {
            player.AddBuff(24, 600, true);
        }
    }

    public override void DamageNPC(Player player, int hitDir, ref int damage, ref float knockback, ref bool crit, ref float critMult)
    {
        Vector2 distance = player.Center - npc.Center;
        if(Math.Sqrt(distance.X * distance.X + distance.Y * distance.Y) > 300)
        {
            damage = 1;
            crit = true;
            critMult = 0f;
        }
    }

    public override void DamageNPC(Projectile projectile, int hitDir, ref int damage, ref float knockback, ref bool crit, ref float critMult)
    {
        Vector2 distance = Main.player[projectile.owner].Center - npc.Center;
        if(Math.Sqrt(distance.X * distance.X + distance.Y * distance.Y) > 300)
        {
            damage = 1;
            crit = true;
            critMult = 0f;
        }
    }

    public override bool PreNPCLoot()
    {
        return false;
    }

    public override void HitEffect(int hitDirection, double damage, bool isDead)
    {
        int count = 0;
        while((double)count < damage / (double)npc.lifeMax * 100.0)
        {
            Dust.NewDust(npc.position, npc.width, npc.height, 5, (float)hitDirection, -1f, 0, Color.White, 1f);
            count++;
        }
        if(Main.netMode != 1 && isDead)
        {
            NPC.NewNPC(npc.Center + new Vector2(0f, (float)npc.height / 2f), NPCDef.byName["Bluemagic:AbominationRun"].type);
            if(Main.netMode == 0)
            {
                Main.PlaySound(15, (int)npc.position.X, (int)npc.position.Y, 0);
            }
            else
            {
                BluemagicNet.SendSound(15, (int)npc.position.X, (int)npc.position.Y, 0);
            }
        }
    }

    public override void SelectFrame(int frameSize)
    {
        if(npc.ai[0] < 50f)
        {
            npc.frame.Y = frameSize;
        }
        else
        {
            npc.frame.Y = 0;
        }
    }

    public override bool PreDraw(SpriteBatch sb)
    {
        sb.Draw(modBase.textures["NPCs/Abomination/HolySphere"], npc.Center - Main.screenPosition, null, Color.White * (70f / 255f), 0f, new Vector2(300, 300), 1f, SpriteEffects.None, 0f);
        sb.Draw(modBase.textures["NPCs/Abomination/HolySphereBorder"], npc.Center - Main.screenPosition, null, Color.White * 0.5f, 0f, new Vector2(300, 300), 1f, SpriteEffects.None, 0f);
        return true;
    }
}}