using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class CaptiveElement2 : ModNPC
{
    //ai[0] = type
    //ai[1] = attackCool
    //ai[2] = run
    //ai[3] = jungle ai

    public override void AI()
    {
        Player player = Main.player[npc.target];
        if(npc.localAI[0] == 0f)
        {
            if(GetDebuff() >= 0f)
            {
                if(GetDebuff() >= npc.buffImmune.Length)
                {
                    Array.Resize<bool>(ref npc.buffImmune, GetDebuff() + 1);
                }
                npc.buffImmune[GetDebuff()] = true;
            }
            if(npc.ai[0] == 3f)
            {
                npc.buffImmune[20] = true;
                npc.ai[3] = 1f;
            }
            if(npc.ai[0] == 0f)
            {
                npc.coldDamage = true;
            }
            if(npc.ai[0] == 1f)
            {
                npc.alpha = 100;
            }
            npc.localAI[0] = 1f;
            BluemagicNet.PlaySound(4, (int)npc.position.X, (int)npc.position.Y, 7);
        }

        //run away
        if((!player.active || player.dead || player.position.Y + player.height < Main.hellLayer * 16) && npc.ai[2] < 2f)
        {
            npc.TargetClosest(false);
            player = Main.player[npc.target];
            if(!player.active || player.dead || player.position.Y + player.height < Main.hellLayer * 16)
            {
                npc.ai[2] = 1f;
            }
            else
            {
                npc.ai[2] = 0f;
            }
        }
        if(npc.ai[2] > 0f)
        {
            bool flag = true;
            if(npc.ai[2] == 1f)
            {
                for(int k = 0; k < 200; k++)
                {
                    if(Main.npc[k].active && Main.npc[k].type == NPCDef.byName["Bluemagic:CaptiveElement2"].type && Main.npc[k].ai[2] == 0f)
                    {
                        flag = false;
                        break;
                    }
                }
            }
            if(flag)
            {
                npc.ai[2] = 2f;
                npc.velocity = new Vector2(0f, 10f);
                npc.rotation = 0.5f * (float)Math.PI;
                CreateDust();
                if(npc.timeLeft > 10)
                {
                    npc.timeLeft = 10;
                }
                npc.netUpdate = true;
                return;
            }
        }
        if(npc.ai[2] < 2f && npc.timeLeft < 750)
        {
            npc.timeLeft = 750;
        }

        //move
        int count = 0;
        for(int k = 0; k < 200; k++)
        {
            if(Main.npc[k].active && Main.npc[k].type == NPCDef.byName["Bluemagic:CaptiveElement2"].type)
            {
                count++;
            }
        }
        if(npc.ai[0] != 1 && npc.ai[0] != 4)
        {
            Vector2 moveTo = player.Center;
            if(npc.ai[0] == 0f)
            {
                moveTo.Y -= 320f;
            }
            if(npc.ai[0] == 2f)
            {
                moveTo.Y += 320f;
            }
            if(npc.ai[0] == 3f)
            {
                if(npc.ai[3] < 0f)
                {
                    moveTo.X -= 320f;
                }
                else
                {
                    moveTo.X += 320f;
                }
            }
            float minX = moveTo.X - 50f;
            float maxX = moveTo.X + 50f;
            float minY = moveTo.Y;
            float maxY = moveTo.Y;
            if(npc.ai[0] == 0f)
            {
                minY -= 50f;
            }
            if(npc.ai[0] == 2f)
            {
                maxY += 50f;
            }
            if(npc.ai[0] == 3f)
            {
                minY -= 240f;
                maxY += 240f;
            }
            if(npc.Center.X >= minX && npc.Center.X <= maxX && npc.Center.Y >= minY && npc.Center.Y <= maxY)
            {
                npc.velocity *= 0.98f;
            }
            else
            {
                Vector2 move = moveTo - npc.Center;
                float magnitude = (float)Math.Sqrt(move.X * move.X + move.Y * move.Y);
                float speed = 10f;
                if(npc.ai[0] == 3f && (npc.ai[3] == -5f || npc.ai[3] == 1f))
                {
                    speed = 8f;
                }
                if(magnitude > speed)
                {
                    move *= speed / magnitude;
                }
                float inertia = 10f;
                if(speed == 8f)
                {
                    inertia = 20f;
                }
                npc.velocity = (inertia * npc.velocity + move) / (inertia + 1);
                magnitude = (float)Math.Sqrt(npc.velocity.X * npc.velocity.X + npc.velocity.Y + npc.velocity.Y);
                if(magnitude > speed)
                {
                    npc.velocity *= speed / magnitude;
                }
            }
        }
        if(npc.ai[0] == 1f)
        {
            Vector2 move = player.Center - npc.Center;
            float magnitude = (float)Math.Sqrt(move.X * move.X + move.Y * move.Y);
            if(magnitude > 3.5f)
            {
                move *= 3.5f / magnitude;
            }
            npc.velocity = move;
        }

        //look and shoot
        if(npc.ai[0] != 4f)
        {
            LookToPlayer();
            npc.ai[1] -= 1f;
            if(npc.ai[1] <= 0f && Main.netMode != 1)
            {
                if(npc.ai[0] == 3f)
                {
                    npc.ai[3] += 1f;
                    if(npc.ai[3] == 0f)
                    {
                        npc.ai[3] = 1f;
                    }
                    if(npc.ai[3] == 6f)
                    {
                        npc.ai[3] = -5f;
                    }
                }
                npc.ai[1] = 150f + 100f * (float)npc.life / (float)npc.lifeMax + (float)Main.rand.Next(50);
                npc.ai[1] *= (float)count / 5f;
                if(npc.ai[0] != 3f || (npc.ai[3] != -5f && npc.ai[3] != 1f))
                {
                    Projectile.NewProjectile(npc.Center.X, npc.Center.Y, 5f * (float)Math.Cos(npc.rotation), 5f * (float)Math.Sin(npc.rotation), ProjDef.byName["Bluemagic:PixelBall"].type, (npc.damage - 30) / 2, 3f, Main.myPlayer, GetDebuff(), GetDebuffTime());
                }
                npc.TargetClosest(false);
                npc.netUpdate = true;
            }
        }
        else
        {
            npc.ai[1] -= 1f;
            if(npc.ai[1] <= 0f)
            {
                npc.ai[1] = 80f + 40f * (float)npc.life / (float)npc.lifeMax;
                npc.ai[1] *= (float)count / 5f;
                npc.TargetClosest(false);
                LookToPlayer();
                float speed = 12.5f - 2.5f * (float)npc.life / (float)npc.lifeMax;
                npc.velocity = speed * new Vector2((float)Math.Cos(npc.rotation), (float)Math.Sin(npc.rotation));
                npc.netUpdate = true;
            }
            else
            {
                npc.velocity *= 0.995f;
            }
        }

        CreateDust();
    }

    private void CreateDust()
    {
        Color? color = GetColor();
        if(color.HasValue)
        {
            for(int k = 0; k < 4; k++)
            {
                int dust = BluemagicDust.CreatePixel(npc.position, npc.width, npc.height, npc.rotation, color.Value);
                Main.dust[dust].velocity += npc.velocity;
            }
        }
    }

    private void LookToPlayer()
    {
        Vector2 look = Main.player[npc.target].Center - npc.Center;
        float angle = 0.5f * (float)Math.PI;
        if(look.X != 0f)
        {
            angle = (float)Math.Atan(look.Y / look.X);
        }
        else if(look.Y < 0f)
        {
            angle += (float)Math.PI;
        }
        if(look.X < 0f)
        {
            angle += (float)Math.PI;
        }
        npc.rotation = angle;
    }

    public override void DealtPlayer(Player player, int hitDir, int dmgDealt, bool crit)
    {
        if(Main.rand.Next(2) == 0)
        {
            int debuff = GetDebuff();
            if(debuff >= 0)
            {
                player.AddBuff(GetDebuff(), GetDebuffTime(), true);
            }
        }
    }

    public int GetDebuff()
    {
        switch((int)npc.ai[0])
        {
        case 0:
            return 44;
        case 1:
            return BuffDef.byName["Bluemagic:EtherealFlames"];
        case 3:
            return 70;
        case 4:
            return 69;
        default:
            return -1;
        }
    }

    public int GetDebuffTime()
    {
        switch((int)npc.ai[0])
        {
        case 0:
            return 400;
        case 1:
            return 300;
        case 3:
            return 400;
        case 4:
            return 600;
        default:
            return -1;
        }
    }

    public Color? GetColor()
    {
        switch((int)npc.ai[0])
        {
        case 0:
            return new Color(0, 230, 230);
        case 1:
            return new Color(0, 153, 230);
        case 3:
            return new Color(0, 178, 0);
        case 4:
            return new Color(230, 192, 0);
        default:
            return null;
        }
    }

    public override bool PreNPCLoot()
    {
        for(int k = 0; k < 200; k++)
        {
            if(Main.npc[k].active && k != npc.whoAmI && Main.npc[k].type == npc.type)
            {
                return false;
            }
        }
        return true;
    }

    public override void SetupLootRules(NPC unused)
    {
        bool flag = LootRule.settingUp;
        LootRule.settingUp = true;
        LootRule[] rules = new LootRule[9];
        rules[0] = new LootRule(null).Item("Greater Healing Potion").Stack(7, 15);
        rules[1] = new LootRule(null).Times((NPC npc) => 10 + Main.rand.Next(5)).Item("Heart");
        rules[2] = new LootRule(null).Chance(0.14285714285714285).Item("Bluemagic:AbominationMask");
        rules[3] = new LootRule(null).Chance(0.1).Item("Bluemagic:AbominationTrophy");
        rules[4] = new LootRule(null).Item("Bluemagic:MoltenDrill");
        rules[5] = new LootRule(null).Item("Bluemagic:DimensionalChest");
        rules[6] = new LootRule("Loot Cage").Code(delegate(NPC npc)
        {
            if (Main.netMode != 1)
            {
                int centerX = (int)(npc.position.X + (float)(npc.width / 2)) / 16;
                int centerY = (int)(npc.position.Y + (float)(npc.height / 2)) / 16;
                int halfLength = npc.width / 2 / 16 + 1;
                for (int x = centerX - halfLength; x <= centerX + halfLength; x++)
                {
                    for (int y = centerY - halfLength; y <= centerY + halfLength; y++)
                    {
                        if ((x == centerX - halfLength || x == centerX + halfLength || y == centerY - halfLength || y == centerY + halfLength) && !Main.tile[x, y].active())
                        {
                            Main.tile[x, y].type = 76;
                            Main.tile[x, y].active(true);
                        }
                        Main.tile[x, y].lava(false);
                        Main.tile[x, y].liquid = 0;
                        if (Main.netMode == 2)
                        {
                            NetMessage.SendTileSquare(-1, x, y, 1);
                        }
                        else
                        {
                            WorldGen.SquareTileFrame(x, y, true);
                        }
                    }
                }
            }
        });
        rules[7] = new LootRule("Message").Code(delegate(NPC npc)
        {
            LootRule.DownedBossMessage("The abomination " + Lang.misc[17], 200, 0, 0);
        });
        rules[8] = new LootRule("Purium Ore").Rules(new Func<NPC, bool>[]{(NPC npc) => Main.netMode != 1}).Code(delegate(NPC npc)
        {
            BluemagicWorld.GenPurium();
        });
        LootRule.AddFor("Bluemagic:CaptiveElement2", rules);
        LootRule.settingUp = flag;
    }

    public override void HitEffect(int hitDirection, double damage, bool isDead)
    {
        if(isDead)
        {
            Color? color = GetColor();
            if(color.HasValue)
            {
                for(int k = 0; k < 75; k++)
                {
                    int dust = BluemagicDust.CreatePixelHurt(npc.position, npc.width, npc.height, color.Value);
                }
            }
        }
    }

    public override void SelectFrame(int frameSize)
    {
        npc.frame.Y = (int)npc.ai[0] * frameSize;
    }
}}