using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class Caster : ModNPC
{
    //ai[0] = timeSinceTeleport
    //ai[1] = shootCounter
    //ai[2] = teleportX
    //ai[3] = teleportY
    private int teleportTime;
    private int[] shootTimes;
    private float projectileSpeed;
    private string projectileType;
    private int projectileDamage;
    private int shootSound;
    public Caster(int teleport, int[] shoots, float speed, string type, int damage, int ss = -1)
    {
        teleportTime = teleport;
        shootTimes = shoots;
        projectileSpeed = speed;
        projectileType = type;
        projectileDamage = damage;
        shootSound = ss;
    }

    public override void AI()
    {
        npc.TargetClosest(true);
        npc.velocity.X *= 0.93f;
        if ((double)npc.velocity.X > -0.1 && (double)npc.velocity.X < 0.1)
        {
            npc.velocity.X = 0f;
        }
        if (npc.ai[0] == 0f)
        {
            npc.ai[0] = teleportTime - 150f;
        }
        if (npc.ai[2] != 0f && npc.ai[3] != 0f)
        {
            Main.PlaySound(2, (int)npc.position.X, (int)npc.position.Y, 8);
            TeleportDust();
            npc.position.X = npc.ai[2] * 16f - (float)(npc.width / 2) + 8f;
            npc.position.Y = npc.ai[3] * 16f - (float)npc.height;
            npc.velocity.X = 0f;
            npc.velocity.Y = 0f;
            npc.ai[2] = 0f;
            npc.ai[3] = 0f;
            Main.PlaySound(2, (int)npc.position.X, (int)npc.position.Y, 8);
            TeleportDust();
        }

        npc.ai[0] += 1f;
        bool flag = false;
        for(int k = 0; k < shootTimes.Length; k++)
        {
            if((int)npc.ai[0] == shootTimes[k])
            {
                flag = true;
                break;
            }
        }
        if(flag)
        {
            npc.ai[1] = 30f;
            npc.netUpdate = true;
        }
        if (npc.ai[0] >= teleportTime && Main.netMode != 1)
        {
            npc.ai[0] = 1f;
            int num233 = (int)Main.player[npc.target].position.X / 16;
            int num234 = (int)Main.player[npc.target].position.Y / 16;
            int num235 = (int)npc.position.X / 16;
            int num236 = (int)npc.position.Y / 16;
            int num237 = 20;
            int num238 = 0;
            bool flag28 = false;
            if (System.Math.Abs(npc.position.X - Main.player[npc.target].position.X) + System.Math.Abs(npc.position.Y - Main.player[npc.target].position.Y) > 2000f)
            {
                num238 = 100;
                flag28 = true;
            }
            while (!flag28 && num238 < 100)
            {
                num238++;
                int num239 = Main.rand.Next(num233 - num237, num233 + num237);
                int num240 = Main.rand.Next(num234 - num237, num234 + num237);
                for (int num241 = num240; num241 < num234 + num237; num241++)
                {
                    if ((num241 < num234 - 4 || num241 > num234 + 4 || num239 < num233 - 4 || num239 > num233 + 4) && (num241 < num236 - 1 || num241 > num236 + 1 || num239 < num235 - 1 || num239 > num235 + 1) && Main.tile[num239, num241].nactive())
                    {
                        Tile tile = Main.tile[num239, num241 - 1];
                        if (IsTileValid(tile) && !tile.lava() && TileDef.solid[(int)Main.tile[num239, num241].type] && !Collision.SolidTiles(num239 - 1, num239 + 1, num241 - 4, num241 - 1))
                        {
                            npc.ai[1] = 20f;
                            npc.ai[2] = (float)num239;
                            npc.ai[3] = (float)num241;
                            flag28 = true;
                            break;
                        }
                    }
                }
            }
            npc.netUpdate = true;
        }
        if (npc.ai[1] > 0f)
        {
            npc.ai[1] -= 1f;
            if (npc.ai[1] == 25f)
            {
                if (Main.netMode != 1)
                {
                    Vector2 vector19 = ShootPos();
                    float num243 = Main.player[npc.target].position.X + (float)Main.player[npc.target].width * 0.5f - vector19.X;
                    float num244 = Main.player[npc.target].position.Y + (float)Main.player[npc.target].height * 0.5f - vector19.Y;
                    float num245 = (float)System.Math.Sqrt((double)(num243 * num243 + num244 * num244));
                    num245 = projectileSpeed / num245;
                    num243 *= num245;
                    num244 *= num245;
                    int proj = Projectile.NewProjectile(vector19.X, vector19.Y, num243, num244, ProjDef.byName[projectileType].type, projectileDamage, 0f, Main.myPlayer, 0f, 0f);
                    Main.projectile[proj].timeLeft = 300;
                    if(shootSound >= 0)
                    {
                        Main.PlaySound(2, (int)npc.position.X, (int)npc.position.Y, shootSound);
                    }
                }
            }
        }
        IdleDust();
    }

    public virtual void TeleportDust() {}

    public virtual void IdleDust() {}

    public virtual bool IsTileValid(Tile tile)
    {
        return true;
    }

    public virtual Vector2 ShootPos()
    {
        return new Vector2(npc.position.X + (float)npc.width * 0.5f, npc.position.Y);
    }
}}