using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class FatGlobule : ModNPC
{
    public override bool CanSpawn(int x, int y, int type, Player spawnedOn)
    {
        int tile = (int)Main.tile[x, y].type;
        int wall = (int)Main.tile[x, y].wall;
        return Bluemagic.NoZoneNormalSpawnAllowWater(spawnedOn, tile, wall, y) && Bluemagic.IsBiomeBlock("Crimson", tile) && y > Main.worldSurface && y < Main.hellLayer && !NPC.areaTown && Bluemagic.downedAbomination > 0 && Main.rand.Next(2) == 0;
    }

    public override bool PreAI()
    {
        RealAI();
        return false;
    }

    public void RealAI()
    {
        float speed = 1f;
        if (npc.ai[0] == 0f)
        {
            npc.TargetClosest(true);
            npc.directionY = 1;
            npc.ai[0] = 1f;
        }
        else
        {
            npc.TargetClosest(false);
        }
        bool flag70 = false;
        if (Main.netMode != 1)
        {
            if (!npc.collideX && !npc.collideY)
            {
                npc.localAI[3] += 1f;
                if (npc.localAI[3] > 5f)
                {
                    npc.ai[2] = 2f;
                    npc.netUpdate = true;
                }
            }
            else
            {
                npc.localAI[3] = 0f;
            }
        }
        if (npc.ai[2] > 0f)
        {
            npc.ai[1] = 0f;
            npc.ai[0] = 1f;
            npc.directionY = 1;
            if (npc.velocity.Y > speed)
            {
                npc.rotation += (float)npc.direction * 0.1f;
            }
            else
            {
                npc.rotation = 0f;
            }
            npc.spriteDirection = npc.direction;
            npc.velocity.X = speed * (float)npc.direction;
            npc.noGravity = false;
            int num1046 = (int)(npc.center().X + (float)(npc.width / 2) * -(float)npc.direction) / 16;
            int num1047 = (int)(npc.position.Y + (float)npc.height + 8f) / 16;
            if (Main.tile[num1046, num1047] != null && !Main.tile[num1046, num1047].topSlope() && npc.collideY)
            {
                npc.ai[2] -= 1f;
            }
            num1047 = (int)(npc.position.Y + (float)npc.height - 4f) / 16;
            num1046 = (int)(npc.center().X + (float)(npc.width / 2 * npc.direction)) / 16;
            if (Main.tile[num1046, num1047] != null && Main.tile[num1046, num1047].bottomSlope())
            {
                npc.direction *= -1;
            }
            if (npc.collideX && npc.velocity.Y == 0f)
            {
                flag70 = true;
                npc.ai[2] = 0f;
                npc.directionY = -1;
                npc.ai[1] = 1f;
            }
            if (npc.velocity.Y == 0f)
            {
                if (npc.localAI[1] == npc.position.X)
                {
                    npc.localAI[2] += 1f;
                    if (npc.localAI[2] > 10f)
                    {
                        npc.direction = 1;
                        npc.velocity.X = speed;
                        npc.localAI[2] = 0f;
                    }
                }
                else
                {
                    npc.localAI[2] = 0f;
                    npc.localAI[1] = npc.position.X;
                }
            }
        }
        if (npc.ai[2] == 0f)
        {
            npc.noGravity = true;
            if (npc.ai[1] == 0f)
            {
                if (npc.collideY)
                {
                    npc.ai[0] = 2f;
                }
                if (!npc.collideY && npc.ai[0] == 2f)
                {
                    npc.direction = -npc.direction;
                    npc.ai[1] = 1f;
                    npc.ai[0] = 1f;
                }
                if (npc.collideX)
                {
                    npc.directionY = -npc.directionY;
                    npc.ai[1] = 1f;
                }
            }
            else
            {
                if (npc.collideX)
                {
                    npc.ai[0] = 2f;
                }
                if (!npc.collideX && npc.ai[0] == 2f)
                {
                    npc.directionY = -npc.directionY;
                    npc.ai[1] = 0f;
                    npc.ai[0] = 1f;
                }
                if (npc.collideY)
                {
                    npc.direction = -npc.direction;
                    npc.ai[1] = 0f;
                }
            }
            if (!flag70)
            {
                float num1048 = npc.rotation;
                if (npc.directionY < 0)
                {
                    if (npc.direction < 0)
                    {
                        if (npc.collideX)
                        {
                            npc.rotation = 1.57f;
                        }
                        else if (npc.collideY)
                        {
                            npc.rotation = 3.14f;
                        }
                    }
                    else
                    {
                        if (npc.collideY)
                        {
                            npc.rotation = 3.14f;
                        }
                        else if (npc.collideX)
                        {
                            npc.rotation = 4.71f;
                        }
                    }
                }
                else
                {
                    if (npc.direction < 0)
                    {
                        if (npc.collideY)
                        {
                            npc.rotation = 0f;
                        }
                        else if (npc.collideX)
                        {
                            npc.rotation = 1.57f;
                        }
                    }
                    else
                    {
                        if (npc.collideX)
                        {
                            npc.rotation = 4.71f;
                        }
                        else if (npc.collideY)
                        {
                            npc.rotation = 0f;
                        }
                    }
                }
                float num1049 = npc.rotation;
                npc.rotation = num1048;
                if ((double)npc.rotation > 6.28)
                {
                    npc.rotation -= 6.28f;
                }
                if (npc.rotation < 0f)
                {
                    npc.rotation += 6.28f;
                }
                float num1050 = System.Math.Abs(npc.rotation - num1049);
                float num1051 = 0.1f;
                if (npc.rotation > num1049)
                {
                    if ((double)num1050 > 3.14)
                    {
                        npc.rotation += num1051;
                    }
                    else
                    {
                        npc.rotation -= num1051;
                        if (npc.rotation < num1049)
                        {
                            npc.rotation = num1049;
                        }
                    }
                }
                if (npc.rotation < num1049)
                {
                    if ((double)num1050 > 3.14)
                    {
                        npc.rotation -= num1051;
                    }
                    else
                    {
                        npc.rotation += num1051;
                        if (npc.rotation > num1049)
                        {
                            npc.rotation = num1049;
                        }
                    }
                }
            }
            npc.velocity.X = speed * (float)npc.direction;
            npc.velocity.Y = speed * (float)npc.directionY;
        }

        Player player = Main.player[npc.target];
        if(Vector2.Distance(player.Center, npc.Center) < 500f)
        {
            npc.ai[3] += 1f;
            if(npc.ai[3] >= 240f)
            {
                npc.ai[3] = 0f;
                if(Main.netMode != 1)
                {
                    Vector2 direction = (player.Center - npc.Center);
                    if(direction == Vector2.Zero)
                    {
                        direction = new Vector2(0f, 1f);
                    }
                    else
                    {
                        direction.Normalize();
                    }
                    Projectile.NewProjectile(npc.Center, 6f * direction, "Bluemagic:FatGlobulet", npc.damage / 2, 0f, Main.myPlayer);
                }
            }
        }
        else
        {
            npc.Transform(NPCDef.byName["Bluemagic:FatGlobule2"].type);
        }
    }

    public override void SelectFrame(int frameSize)
    {
        if(npc.ai[2] == 0f)
        {
            if(npc.frameCounter < 0.0)
            {
                npc.frameCounter = 0.0;
                npc.frame.Y = 0;
            }
            npc.frameCounter += Math.Abs(npc.velocity.X) + Math.Abs(npc.velocity.Y);
            if(npc.frameCounter >= 6.0)
            {
                npc.frame.Y = frameSize - npc.frame.Y;
                npc.frameCounter -= 6.0;
            }
        }
        else
        {
            npc.frameCounter = -1.0;
            npc.frame.Y = frameSize;
        }
    }

    public override void HitEffect(int hitDirection, double damage, bool isDead)
    {
        Color color = new Color(220, 220, 90);
        if(isDead)
        {
            for(int k = 0; k < 50; k++)
            {
                Dust.NewDust(npc.position, npc.width, npc.height, 4, 2f * hitDirection, -2f, npc.alpha, color, 1f);
            }
        }
        else
        {
            for(int k = 0; k < damage / npc.lifeMax * 100; k++)
            {
                Dust.NewDust(npc.position, npc.width, npc.height, 4, hitDirection, -1f, npc.alpha, color, 1f);
            }
        }
    }

    public override void SetupLootRules(NPC unused)
    {
        bool flag = LootRule.settingUp;
        LootRule.settingUp = true;
        LootRule[] rules = new LootRule[2];
        rules[0] = new LootRule(null).Item("Ichor");
        rules[1] = new LootRule(null).Chance(0.005).Item("Bluemagic:FatGlobuleBanner");
        LootRule.AddFor("Bluemagic:FatGlobule", rules);
        LootRule.settingUp = flag;
    }
}}