using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class FatGlobule2 : Worm
{
    public override void CustomBehavior()
    {
        npc.noGravity = true;
        if(Vector2.Distance(Main.player[npc.target].Center, npc.Center) < 500f && !Collision.SolidCollision(npc.position, npc.width, npc.height))
        {
            npc.Transform(NPCDef.byName["Bluemagic:FatGlobule"].type);
        }
    }

    public override void HitEffect(int hitDirection, double damage, bool isDead)
    {
        Color color = new Color(220, 220, 90);
        if(isDead)
        {
            for(int k = 0; k < 50; k++)
            {
                Dust.NewDust(npc.position, npc.width, npc.height, 4, 2f * hitDirection, -2f, npc.alpha, color, 1f);
            }
        }
        else
        {
            for(int k = 0; k < damage / npc.lifeMax * 100; k++)
            {
                Dust.NewDust(npc.position, npc.width, npc.height, 4, hitDirection, -1f, npc.alpha, color, 1f);
            }
        }
    }

    public override void SetupLootRules(NPC unused)
    {
        bool flag = LootRule.settingUp;
        LootRule.settingUp = true;
        LootRule[] rules = new LootRule[2];
        rules[0] = new LootRule(null).Item("Ichor");
        rules[1] = new LootRule(null).Chance(0.005).Item("Bluemagic:FatGlobuleBanner");
        LootRule.AddFor("Bluemagic:FatGlobule2", rules);
        LootRule.settingUp = flag;
    }
}}