using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class ForeignEntityCursed : ForeignEntity
{
    public ForeignEntityCursed() : base("Crimson", 39, 240) {}

    public override void AddLight()
    {
        Lighting.AddLight((int)(npc.Center.X / 16f), (int)(npc.Center.Y / 16f), 0.3f, 0.5f, 0.3f);
    }

    public override void CreateDust()
    {
        if(Main.rand.Next(3) == 0)
        {
            int dust = Dust.NewDust(npc.position, npc.width, npc.height, 75, 0f, 0f, 100, default(Color), 2.5f);
            Main.dust[dust].noGravity = true;
        }
    }

    public override void HitEffect(int hitDirection, double damage, bool isDead)
    {
        int numDust = isDead ? 50 : 10;
        for(int k = 0; k < numDust; k++)
        {
            int dust = Dust.NewDust(npc.position, npc.width, npc.height, 75, 0f, 0f, 100, default(Color), 2.5f);
            Main.dust[dust].velocity *= 0.2f;
            Main.dust[dust].noGravity = true;
        }
    }

    public override void SetupLootRules(NPC unused)
    {
        bool flag = LootRule.settingUp;
        LootRule.settingUp = true;
        LootRule[] rules = new LootRule[2];
        rules[0] = new LootRule(null).Stack(2, 3).Item("Cursed Flame");
        rules[1] = new LootRule(null).Chance(0.005).Item("Bluemagic:ForeignEntityBanner");
        LootRule.AddFor("Bluemagic:ForeignEntityCursed", rules);
        LootRule.settingUp = flag;
    }
}}