using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class BlackMotherScorpion : MotherScorpion
{
    public override bool CanSpawn(int x, int y, int type, Player spawnedOn)
    {
        return false;
    }

    public override void HitEffect(int hitDirection, double damage, bool isDead)
    {
        if(isDead)
        {
            for(int k = 0; k < 20; k++)
            {
                Dust.NewDust(npc.position, npc.width, npc.height, 203, 2f * hitDirection, -2f, 0, default(Color), 1f);
            }
            Gore.NewGore(npc.position, npc.velocity, "Bluemagic:BlackMotherScorpionClaw", 1f);
            Gore.NewGore(npc.position, npc.velocity, "Bluemagic:BlackMotherScorpion", 1f);
            Gore.NewGore(npc.position, npc.velocity, "Bluemagic:BlackMotherScorpionTail", 1f);
        }
        else
        {
            for(int k = 0; k < damage / (double)npc.lifeMax * 40.0; k++)
            {
                Dust.NewDust(npc.position, npc.width, npc.height, 203, (float)hitDirection, -1f, 0, default(Color), 1f);
            }
        }
    }

    public override void SetupLootRules(NPC unused)
    {
        bool flag = LootRule.settingUp;
        LootRule.settingUp = true;
        LootRule[] rules = new LootRule[3];
        rules[0] = new LootRule(null).Chance(0.5).Item("Stinger");
        rules[1] = new LootRule(null).Chance(0.1).Item("Black Scorpion");
        rules[2] = new LootRule(null).Chance(0.005).Item("Bluemagic:MotherScorpionBanner");
        LootRule.AddFor("Bluemagic:BlackMotherScorpion", rules);
        LootRule.settingUp = flag;
    }
}}