using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class Dropper : ModNPC
{
    private float speed;
    private float acceleration;
    private float shootSpeed;
    private float dropSpeed;
    private string shoot;
    public Dropper(float s = 4f, float a = 0.25f, float ss = 8f, float ds = 5f, string sh = "Rain")
    {
        speed = s;
        acceleration = a;
        shootSpeed = ss;
        dropSpeed = ds;
        shoot = sh;
    }

    public override void AI()
    {
        npc.TargetClosest(true);
        Player player = Main.player[npc.target];
        Vector2 moveOffset = player.Center - npc.Center;
        moveOffset.Y -= 200f;
        float distance = moveOffset.Length();
        if (distance < 20f)
        {
            moveOffset = npc.velocity;
        }
        else
        {
            distance = speed / distance;
            moveOffset *= distance;
        }
        if (npc.velocity.X < moveOffset.X)
        {
            npc.velocity.X += acceleration;
            if (npc.velocity.X < 0f && moveOffset.X > 0f)
            {
                npc.velocity.X += acceleration * 2f;
            }
        }
        else if (npc.velocity.X > moveOffset.X)
        {
            npc.velocity.X -= acceleration;
            if (npc.velocity.X > 0f && moveOffset.X < 0f)
            {
                npc.velocity.X -= acceleration * 2f;
            }
        }
        if (npc.velocity.Y < moveOffset.Y)
        {
            npc.velocity.Y += acceleration;
            if (npc.velocity.Y < 0f && moveOffset.Y > 0f)
            {
                npc.velocity.Y += acceleration * 2f;
            }
        }
        else if (npc.velocity.Y > moveOffset.Y)
        {
            npc.velocity.Y -= acceleration;
            if (npc.velocity.Y > 0f && moveOffset.Y < 0f)
            {
                npc.velocity.Y -= acceleration * 2f;
            }
        }
        if (npc.position.X + (float)npc.width <= player.position.X || npc.position.X >= player.position.X + (float)player.width || npc.position.Y + (float)npc.height >= player.position.Y || !Collision.CanHit(npc.position, npc.width, npc.height, player.position, player.width, player.height) || Main.netMode == 1)
        {
            return;
        }
        npc.ai[0] += 1f;
        if (npc.ai[0] >= shootSpeed)
        {
            npc.ai[0] = 0f;
            Projectile.NewProjectile(DropPos(), new Vector2(0f, dropSpeed), shoot, npc.damage / 2, 0f, Main.myPlayer, 0f, 0f);
        }
    }

    public virtual Vector2 DropPos()
    {
        return new Vector2((int)(npc.position.X + 10f + Main.rand.Next(npc.width - 20)), (int)(npc.position.Y + npc.height + 4f));
    }
}}