using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class Fighter : ModNPC
{
    public float speed;
    public float acceleration;
    private bool alwaysAggro;
    private int aggroSound;
    private int soundStyle;
    private int soundChance;
    private bool idles;
    private bool jumpAttacks;
    public Fighter(float s, float a, bool aggro = true, int sound = -1, int style = -1, int chance = 0, bool i = true, bool jump = true)
    {
        speed = s;
        acceleration = a;
        alwaysAggro = aggro;
        aggroSound = sound;
        soundStyle = style;
        soundChance = chance;
        idles = i;
        jumpAttacks = jump;
    }

    public override void AI()
    {
        bool flag3 = npc.velocity.X == 0f && !npc.justHit;
        int num22 = 60;
        bool flag4 = false;

        if (npc.velocity.Y == 0f && ((npc.velocity.X > 0f && npc.direction < 0) || (npc.velocity.X < 0f && npc.direction > 0)))
        {
            flag4 = true;
        }
        if (npc.position.X == npc.oldPosition.X || npc.ai[3] >= (float)num22 || flag4)
        {
            npc.ai[3] += 1f;
        }
        else if ((double)System.Math.Abs(npc.velocity.X) > 0.9 && npc.ai[3] > 0f)
        {
            npc.ai[3] -= 1f;
        }
        if (npc.ai[3] > (float)(num22 * 10))
        {
            npc.ai[3] = 0f;
        }
        if (npc.justHit)
        {
            npc.ai[3] = 0f;
        }
        if (npc.ai[3] == (float)num22)
        {
            npc.netUpdate = true;
        }
        if ((alwaysAggro || Main.eclipse || !Main.dayTime || (double)npc.position.Y > Main.worldSurface * 16.0) && npc.ai[3] < (float)num22)
        {
            if(aggroSound >= 0 && soundStyle >= 0 && soundChance > 0 && Main.rand.Next(soundChance) == 0)
            {
                Main.PlaySound(aggroSound, (int)npc.position.X, (int)npc.position.Y, soundStyle);
            }
            npc.TargetClosest(true);
        }
        else if (idles || npc.ai[2] <= 0f)
        {
            if (Main.dayTime && (double)(npc.position.Y / 16f) < Main.worldSurface && npc.timeLeft > 10)
            {
                npc.timeLeft = 10;
            }
            if (npc.velocity.X == 0f)
            {
                if (npc.velocity.Y == 0f)
                {
                    npc.ai[0] += 1f;
                    if (npc.ai[0] >= 2f)
                    {
                        npc.direction *= -1;
                        npc.spriteDirection = npc.direction;
                        npc.ai[0] = 0f;
                    }
                }
            }
            else
            {
                npc.ai[0] = 0f;
            }
            if (npc.direction == 0)
            {
                npc.direction = 1;
            }
        }

        float realSpeed = speed * (2f - npc.scale);
        if (npc.velocity.X < -realSpeed || npc.velocity.X > realSpeed)
        {
            if (npc.velocity.Y == 0f)
            {
                npc.velocity *= 0.8f;
            }
        }
        else if (npc.velocity.X < realSpeed && npc.direction == 1)
        {
            npc.velocity.X += acceleration;
            if (npc.velocity.X > realSpeed)
            {
                npc.velocity.X = realSpeed;
            }
        }
        else if (npc.velocity.X > -realSpeed && npc.direction == -1)
        {
            npc.velocity.X -= acceleration;
            if (npc.velocity.X < -realSpeed)
            {
                npc.velocity.X = -realSpeed;
            }
        }

        bool flag11 = false;
        if (npc.velocity.Y == 0f)
        {
            int num93 = (int)(npc.position.Y + (float)npc.height + 7f) / 16;
            int num94 = (int)npc.position.X / 16;
            int num95 = (int)(npc.position.X + (float)npc.width) / 16;
            for (int num96 = num94; num96 <= num95; num96++)
            {
                if (Main.tile[num96, num93] == null)
                {
                    return;
                }
                if (Main.tile[num96, num93].nactive() && TileDef.solid[(int)Main.tile[num96, num93].type])
                {
                    flag11 = true;
                    break;
                }
            }
        }
        if (npc.velocity.Y >= 0f)
        {
            int num97 = 0;
            if (npc.velocity.X < 0f)
            {
                num97 = -1;
            }
            if (npc.velocity.X > 0f)
            {
                num97 = 1;
            }
            Vector2 position = npc.position;
            position.X += npc.velocity.X;
            int num98 = (int)((position.X + (float)(npc.width / 2) + (float)((npc.width / 2 + 1) * num97)) / 16f);
            int num99 = (int)((position.Y + (float)npc.height - 1f) / 16f);
            if (Main.tile[num98, num99] == null)
            {
                Main.tile[num98, num99] = new Tile();
            }
            if (Main.tile[num98, num99 - 1] == null)
            {
                Main.tile[num98, num99 - 1] = new Tile();
            }
            if (Main.tile[num98, num99 - 2] == null)
            {
                Main.tile[num98, num99 - 2] = new Tile();
            }
            if (Main.tile[num98, num99 - 3] == null)
            {
                Main.tile[num98, num99 - 3] = new Tile();
            }
            if (Main.tile[num98, num99 + 1] == null)
            {
                Main.tile[num98, num99 + 1] = new Tile();
            }
            if (Main.tile[num98 - num97, num99 - 3] == null)
            {
                Main.tile[num98 - num97, num99 - 3] = new Tile();
            }
            if ((float)(num98 * 16) < position.X + (float)npc.width && (float)(num98 * 16 + 16) > position.X && ((Main.tile[num98, num99].nactive() && !Main.tile[num98, num99].topSlope() && !Main.tile[num98, num99 - 1].topSlope() && TileDef.solid[(int)Main.tile[num98, num99].type] && !TileDef.solidTop[(int)Main.tile[num98, num99].type]) || (Main.tile[num98, num99 - 1].halfBrick() && Main.tile[num98, num99 - 1].nactive())) && (!Main.tile[num98, num99 - 1].nactive() || !TileDef.solid[(int)Main.tile[num98, num99 - 1].type] || TileDef.solidTop[(int)Main.tile[num98, num99 - 1].type] || (Main.tile[num98, num99 - 1].halfBrick() && (!Main.tile[num98, num99 - 4].nactive() || !TileDef.solid[(int)Main.tile[num98, num99 - 4].type] || TileDef.solidTop[(int)Main.tile[num98, num99 - 4].type]))) && (!Main.tile[num98, num99 - 2].nactive() || !TileDef.solid[(int)Main.tile[num98, num99 - 2].type] || TileDef.solidTop[(int)Main.tile[num98, num99 - 2].type]) && (!Main.tile[num98, num99 - 3].nactive() || !TileDef.solid[(int)Main.tile[num98, num99 - 3].type] || TileDef.solidTop[(int)Main.tile[num98, num99 - 3].type]) && (!Main.tile[num98 - num97, num99 - 3].nactive() || !TileDef.solid[(int)Main.tile[num98 - num97, num99 - 3].type]))
            {
                float num100 = (float)(num99 * 16);
                if (Main.tile[num98, num99].halfBrick())
                {
                    num100 += 8f;
                }
                if (Main.tile[num98, num99 - 1].halfBrick())
                {
                    num100 -= 8f;
                }
                if (num100 < position.Y + (float)npc.height)
                {
                    float num101 = position.Y + (float)npc.height - num100;
                    float num102 = 16.1f;
                    if (npc.type == 163 || npc.type == 164 || npc.type == 236 || npc.type == 239)
                    {
                        num102 += 8f;
                    }
                    if (num101 <= num102)
                    {
                        npc.gfxOffY += npc.position.Y + (float)npc.height - num100;
                        npc.position.Y = num100 - (float)npc.height;
                        if (num101 < 9f)
                        {
                            npc.stepSpeed = 1f;
                        }
                        else
                        {
                            npc.stepSpeed = 2f;
                        }
                    }
                }
            }
        }
        if (flag11)
        {
            int num103 = (int)((npc.position.X + (float)(npc.width / 2) + (float)(15 * npc.direction)) / 16f);
            int num104 = (int)((npc.position.Y + (float)npc.height - 15f) / 16f);
            if (npc.type == 109 || npc.type == 163 || npc.type == 164 || npc.type == 199 || npc.type == 236 || npc.type == 239 || npc.type == 257 || npc.type == 258 || npc.type == 290)
            {
                num103 = (int)((npc.position.X + (float)(npc.width / 2) + (float)((npc.width / 2 + 16) * npc.direction)) / 16f);
            }
            if (Main.tile[num103, num104] == null)
            {
                Main.tile[num103, num104] = new Tile();
            }
            if (Main.tile[num103, num104 - 1] == null)
            {
                Main.tile[num103, num104 - 1] = new Tile();
            }
            if (Main.tile[num103, num104 - 2] == null)
            {
                Main.tile[num103, num104 - 2] = new Tile();
            }
            if (Main.tile[num103, num104 - 3] == null)
            {
                Main.tile[num103, num104 - 3] = new Tile();
            }
            if (Main.tile[num103, num104 + 1] == null)
            {
                Main.tile[num103, num104 + 1] = new Tile();
            }
            if (Main.tile[num103 + npc.direction, num104 - 1] == null)
            {
                Main.tile[num103 + npc.direction, num104 - 1] = new Tile();
            }
            if (Main.tile[num103 + npc.direction, num104 + 1] == null)
            {
                Main.tile[num103 + npc.direction, num104 + 1] = new Tile();
            }
            if (Main.tile[num103 - npc.direction, num104 + 1] == null)
            {
                Main.tile[num103 - npc.direction, num104 + 1] = new Tile();
            }
            Main.tile[num103, num104 + 1].halfBrick();
            if (Main.tile[num103, num104 - 1].nactive() && Main.tile[num103, num104 - 1].type == 10)
            {
                npc.ai[2] += 1f;
                npc.ai[3] = 0f;
                if (npc.ai[2] >= 60f)
                {
                    npc.velocity.X = 0.5f * -(float)npc.direction;
                    npc.ai[1] += 11f;
                    npc.ai[2] = 0f;
                    bool flag12 = false;
                    if (npc.ai[1] >= 10f)
                    {
                        flag12 = true;
                        npc.ai[1] = 10f;
                    }
                    WorldGen.KillTile(num103, num104 - 1, true, false, false);
                    if ((Main.netMode != 1 || !flag12) && flag12 && Main.netMode != 1)
                    {
                        bool flag13 = WorldGen.OpenDoor(num103, num104 - 1, npc.direction);
                        if (!flag13)
                        {
                            npc.ai[3] = (float)num22;
                            npc.netUpdate = true;
                        }
                        if (Main.netMode == 2 && flag13)
                        {
                            NetMessage.SendData(19, -1, -1, "", 0, (float)num103, (float)(num104 - 1), (float)npc.direction, 0f);
                        }
                    }
                }
            }
            else
            {
                if ((npc.velocity.X < 0f && npc.spriteDirection == -1) || (npc.velocity.X > 0f && npc.spriteDirection == 1))
                {
                    if (Main.tile[num103, num104 - 2].nactive() && TileDef.solid[(int)Main.tile[num103, num104 - 2].type])
                    {
                        if (Main.tile[num103, num104 - 3].nactive() && TileDef.solid[(int)Main.tile[num103, num104 - 3].type])
                        {
                            npc.velocity.Y = -8f;
                            npc.netUpdate = true;
                        }
                        else
                        {
                            npc.velocity.Y = -7f;
                            npc.netUpdate = true;
                        }
                    }
                    else if (Main.tile[num103, num104 - 1].nactive() && TileDef.solid[(int)Main.tile[num103, num104 - 1].type])
                    {
                        npc.velocity.Y = -6f;
                        npc.netUpdate = true;
                    }
                    else if (npc.position.Y + (float)npc.height - (float)(num104 * 16) > 20f && Main.tile[num103, num104].nactive() && !Main.tile[num103, num104].topSlope() && TileDef.solid[(int)Main.tile[num103, num104].type])
                    {
                        npc.velocity.Y = -5f;
                        npc.netUpdate = true;
                    }
                        else if (npc.directionY < 0 && npc.type != 67 && (!Main.tile[num103, num104 + 1].nactive() || !TileDef.solid[(int)Main.tile[num103, num104 + 1].type]) && (!Main.tile[num103 + npc.direction, num104 + 1].nactive() || !TileDef.solid[(int)Main.tile[num103 + npc.direction, num104 + 1].type]))
                    {
                        npc.velocity.Y = -8f;
                        npc.velocity.X *= 1.5f;
                        npc.netUpdate = true;
                    }
                    else
                    {
                        npc.ai[1] = 0f;
                        npc.ai[2] = 0f;
                    }
                    if (npc.velocity.Y == 0f && flag3 && npc.ai[3] == 1f)
                    {
                        npc.velocity.Y = -5f;
                    }
                }
                if (jumpAttacks && npc.velocity.Y == 0f && System.Math.Abs(npc.position.X + (float)(npc.width / 2) - (Main.player[npc.target].position.X + (float)(Main.player[npc.target].width / 2))) < 100f && System.Math.Abs(npc.position.Y + (float)(npc.height / 2) - (Main.player[npc.target].position.Y + (float)(Main.player[npc.target].height / 2))) < 50f && ((npc.direction > 0 && npc.velocity.X >= 1f) || (npc.direction < 0 && npc.velocity.X <= -1f)))
                {
                    npc.velocity.X *= 2f;
                    if (npc.velocity.X > 3f)
                    {
                        npc.velocity.X = 3f;
                    }
                    if (npc.velocity.X < -3f)
                    {
                        npc.velocity.X = -3f;
                    }
                    npc.velocity.Y = -4f;
                    npc.netUpdate = true;
                }
            }
        }
        else
        {
            npc.ai[1] = 0f;
            npc.ai[2] = 0f;
        }
    }

    public override void SelectFrame(int frameSize)
    {
        if (npc.velocity.Y == 0f)
        {
            if (npc.direction == 1)
            {
                npc.spriteDirection = 1;
            }
            if (npc.direction == -1)
            {
                npc.spriteDirection = -1;
            }
            if (npc.velocity.X == 0f)
            {
                npc.frame.Y = 0;
                npc.frameCounter = 0.0;
            }
            else
            {
                if(npc.frame.Y < frameSize * 2)
                {
                     npc.frame.Y = frameSize * 2;
                }
                npc.frameCounter += (double)System.Math.Abs(npc.velocity.X) * 2.0;
                if (npc.frameCounter > 6.0)
                {
                    npc.frame.Y += frameSize;
                    npc.frameCounter = 0.0;
                }
                if (npc.frame.Y >= Main.npcFrameCount[npc.type] * frameSize)
                {
                    npc.frame.Y = frameSize * 2;
                }
            }
        }
        else
        {
            npc.frameCounter = 0.0;
            npc.frame.Y = frameSize;
        }
    }
}}