using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class Shadow : Fighter
{
    public Shadow() : base(3f, 0.15f) {}

    public override bool CanSpawn(int x, int y, int type, Player spawnedOn)
    {
        int tile = (int)Main.tile[x, y].type;
        int wall = (int)Main.tile[x, y].wall;
        return Main.eclipse && Main.dayTime && y < Main.worldSurface && Bluemagic.downedAbomination > 0 && Main.rand.Next(2) == 0;
    }

    public override void AI()
    {
        if(npc.localAI[0] == 0f)
        {
            for(int k = 0; k < 140; k++)
            {
                npc.buffImmune[k] = true;
            }
        }
        base.AI();
    }

    public override void DealtPlayer(Player player, int hitDir, int dmgDealt, bool crit)
    {
        if(Main.rand.Next(4) == 0)
        {
            player.AddBuff("Bluemagic:Shadow", 300, true);
        }
    }

    public override void HitEffect(int hitDirection, double damage, bool isDead)
    {
        if(isDead)
        {
            for(int k = 0; k < 20; k++)
            {
                int dust = BluemagicDust.CreateSmoke(npc.position, npc.width, npc.height, Color.Black);
                Main.dust[dust].velocity *= 0.5f;
                Main.dust[dust].scale = 2f;
            }
        }
    }

    public override void SetupLootRules(NPC unused)
    {
        bool flag = LootRule.settingUp;
        LootRule.settingUp = true;
        LootRule[] rules = new LootRule[2];
        rules[0] = new LootRule(null).Chance(0.01).Item("Broken Hero Sword");
        rules[1] = new LootRule(null).Chance(0.005).Item("Bluemagic:ShadowBanner");
        LootRule.AddFor("Bluemagic:Shadow", rules);
        LootRule.settingUp = flag;
    }
}}