using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class FuryNight : ModNPC
{
    private static Random swordRand = new Random();
    private int glowFrameCounter = 0;
    private int swordFrame = 0;

    public override void AI()
    {
        int num22 = 60;
        bool flag5 = true;

        bool willTurn = npc.velocity.Y == 0f && npc.velocity.X * npc.direction < 0;
        if (npc.position.X == npc.oldPosition.X || npc.ai[3] >= (float)num22 || willTurn)
        {
            npc.ai[3] += 1f;
        }
        else
        {
            if ((double)System.Math.Abs(npc.velocity.X) > 0.9 && npc.ai[3] > 0f)
            {
                npc.ai[3] -= 1f;
            }
        }
        if (npc.ai[3] > (float)(num22 * 10) || npc.justHit)
        {
            npc.ai[3] = 0f;
        }
        if (npc.ai[3] == (float)num22)
        {
            npc.netUpdate = true;
        }

        if ((Main.eclipse || !Main.dayTime || (double)npc.position.Y > Main.worldSurface * 16.0) && npc.ai[3] < (float)num22)
        {
            npc.TargetClosest(true);
        }
        else if (npc.ai[1] <= 0f)
        {
            if (Main.dayTime && (double)(npc.position.Y / 16f) < Main.worldSurface && npc.timeLeft > 10)
            {
                npc.timeLeft = 10;
            }
            if (npc.velocity.X == 0f)
            {
                if (npc.velocity.Y == 0f)
                {
                    npc.ai[0] += 1f;
                    if (npc.ai[0] >= 2f)
                    {
                        npc.direction *= -1;
                        npc.spriteDirection = npc.direction;
                        npc.ai[0] = 0f;
                    }
                }
            }
            else
            {
                npc.ai[0] = 0f;
            }
            if (npc.direction == 0)
            {
                npc.direction = 1;
            }
        }

        if (npc.ai[1] > 0f)
        {
            npc.ai[1] -= 1f;
        }
        Player player = Main.player[npc.target];
        if(npc.ai[2] <= 0f && npc.ai[1] <= 0f && player.position.Y + player.height >= npc.position.Y - npc.height / 2f && player.position.Y <= npc.position.Y + npc.height * 1.5f && Collision.CanHit(npc.position, npc.width, npc.height, player.position, player.width, player.height))
        {
            if((npc.direction == 1 && player.position.X >= npc.position.X + npc.width && player.position.X <= npc.position.X + npc.width + 60) || (npc.direction == -1 && player.position.X + player.width <= npc.position.X && player.position.X + player.width >= npc.position.X - 60))
            {
                npc.ai[1] = 60f;
                npc.netUpdate = true;
            }
        }
        if(npc.ai[1] <= 0f)
        {
            npc.knockBackResist = 0.3f;
            float speed = 2f;
            float acceleration = 0.07f;
            if (npc.velocity.X < -speed || npc.velocity.X > speed)
            {
                if (npc.velocity.Y == 0f)
                {
                    npc.velocity *= 0.8f;
                }
            }
            else if (npc.velocity.X < speed && npc.direction == 1)
            {
                npc.velocity.X += acceleration;
                if (npc.velocity.X > speed)
                {
                    npc.velocity.X = speed;
                }
            }
            else if (npc.velocity.X > -speed && npc.direction == -1)
            {
                npc.velocity.X -= acceleration;
                if (npc.velocity.X < -speed)
                {
                    npc.velocity.X = -speed;
                }
            }
        }
        else
        {
            npc.knockBackResist = 0f;
            if(npc.ai[1] % 6 == 0)
            {
                Main.PlaySound(2, (int)npc.position.X, (int)npc.position.Y, 39);
            }
            if(npc.velocity.Y == 0f)
            {
                npc.velocity.X = 0f;
            }
            if(npc.ai[1] == 1f)
            {
                npc.ai[3] = 0f;
            }
            SwordDamage();
            return;
        }

        bool flag11 = false;
        if (npc.velocity.Y == 0f)
        {
            int num93 = (int)(npc.position.Y + (float)npc.height + 7f) / 16;
            int num94 = (int)npc.position.X / 16;
            int num95 = (int)(npc.position.X + (float)npc.width) / 16;
            for (int num96 = num94; num96 <= num95; num96++)
            {
                if (Main.tile[num96, num93] == null)
                {
                    return;
                }
                if (Main.tile[num96, num93].nactive() && TileDef.solid[(int)Main.tile[num96, num93].type])
                {
                    flag11 = true;
                    break;
                }
            }
        }
        if (npc.velocity.Y >= 0f)
        {
            int num97 = 0;
            if (npc.velocity.X < 0f)
            {
                num97 = -1;
            }
            if (npc.velocity.X > 0f)
            {
                num97 = 1;
            }
            Vector2 position = npc.position;
            position.X += npc.velocity.X;
            int num98 = (int)((position.X + (float)(npc.width / 2) + (float)((npc.width / 2 + 1) * num97)) / 16f);
            int num99 = (int)((position.Y + (float)npc.height - 1f) / 16f);
            if (Main.tile[num98, num99] == null)
            {
                Main.tile[num98, num99] = new Tile();
            }
            if (Main.tile[num98, num99 - 1] == null)
            {
                Main.tile[num98, num99 - 1] = new Tile();
            }
            if (Main.tile[num98, num99 - 2] == null)
            {
                Main.tile[num98, num99 - 2] = new Tile();
            }
            if (Main.tile[num98, num99 - 3] == null)
            {
                Main.tile[num98, num99 - 3] = new Tile();
            }
            if (Main.tile[num98, num99 + 1] == null)
            {
                Main.tile[num98, num99 + 1] = new Tile();
            }
            if (Main.tile[num98 - num97, num99 - 3] == null)
            {
                Main.tile[num98 - num97, num99 - 3] = new Tile();
            }
            if ((float)(num98 * 16) < position.X + (float)npc.width && (float)(num98 * 16 + 16) > position.X && ((Main.tile[num98, num99].nactive() && !Main.tile[num98, num99].topSlope() && !Main.tile[num98, num99 - 1].topSlope() && TileDef.solid[(int)Main.tile[num98, num99].type] && !TileDef.solidTop[(int)Main.tile[num98, num99].type]) || (Main.tile[num98, num99 - 1].halfBrick() && Main.tile[num98, num99 - 1].nactive())) && (!Main.tile[num98, num99 - 1].nactive() || !TileDef.solid[(int)Main.tile[num98, num99 - 1].type] || TileDef.solidTop[(int)Main.tile[num98, num99 - 1].type] || (Main.tile[num98, num99 - 1].halfBrick() && (!Main.tile[num98, num99 - 4].nactive() || !TileDef.solid[(int)Main.tile[num98, num99 - 4].type] || TileDef.solidTop[(int)Main.tile[num98, num99 - 4].type]))) && (!Main.tile[num98, num99 - 2].nactive() || !TileDef.solid[(int)Main.tile[num98, num99 - 2].type] || TileDef.solidTop[(int)Main.tile[num98, num99 - 2].type]) && (!Main.tile[num98, num99 - 3].nactive() || !TileDef.solid[(int)Main.tile[num98, num99 - 3].type] || TileDef.solidTop[(int)Main.tile[num98, num99 - 3].type]) && (!Main.tile[num98 - num97, num99 - 3].nactive() || !TileDef.solid[(int)Main.tile[num98 - num97, num99 - 3].type]))
            {
                float num100 = (float)(num99 * 16);
                if (Main.tile[num98, num99].halfBrick())
                {
                    num100 += 8f;
                }
                if (Main.tile[num98, num99 - 1].halfBrick())
                {
                    num100 -= 8f;
                }
                if (num100 < position.Y + (float)npc.height)
                {
                    float num101 = position.Y + (float)npc.height - num100;
                    float num102 = 16.1f;
                    if (num101 <= num102)
                    {
                        npc.gfxOffY += npc.position.Y + (float)npc.height - num100;
                        npc.position.Y = num100 - (float)npc.height;
                        if (num101 < 9f)
                        {
                            npc.stepSpeed = 1f;
                        }
                        else
                        {
                            npc.stepSpeed = 2f;
                        }
                    }
                }
            }
        }
        if (flag11)
        {
            int num103 = (int)((npc.position.X + (float)(npc.width / 2) + (float)(15 * npc.direction)) / 16f);
            int num104 = (int)((npc.position.Y + (float)npc.height - 15f) / 16f);
            if (Main.tile[num103, num104] == null)
            {
                Main.tile[num103, num104] = new Tile();
            }
            if (Main.tile[num103, num104 - 1] == null)
            {
                Main.tile[num103, num104 - 1] = new Tile();
            }
            if (Main.tile[num103, num104 - 2] == null)
            {
                Main.tile[num103, num104 - 2] = new Tile();
            }
            if (Main.tile[num103, num104 - 3] == null)
            {
                Main.tile[num103, num104 - 3] = new Tile();
            }
            if (Main.tile[num103, num104 + 1] == null)
            {
                Main.tile[num103, num104 + 1] = new Tile();
            }
            if (Main.tile[num103 + npc.direction, num104 - 1] == null)
            {
                Main.tile[num103 + npc.direction, num104 - 1] = new Tile();
            }
            if (Main.tile[num103 + npc.direction, num104 + 1] == null)
            {
                Main.tile[num103 + npc.direction, num104 + 1] = new Tile();
            }
            if (Main.tile[num103 - npc.direction, num104 + 1] == null)
            {
                Main.tile[num103 - npc.direction, num104 + 1] = new Tile();
            }
            Main.tile[num103, num104 + 1].halfBrick();
            if (Main.tile[num103, num104 - 1].nactive() && Main.tile[num103, num104 - 1].type == 10 && flag5)
            {
                npc.ai[2] += 1f;
                npc.ai[3] = 0f;
                if (npc.ai[2] >= 60f)
                {
                    npc.velocity.X = 0.5f * -(float)npc.direction;
                    npc.ai[2] = 0f;
                    WorldGen.KillTile(num103, num104 - 1, true, false, false);
                    if (Main.netMode != 1)
                    {
                        bool flag13 = WorldGen.OpenDoor(num103, num104 - 1, npc.direction);
                        if (!flag13)
                        {
                            npc.ai[3] = (float)num22;
                            npc.netUpdate = true;
                        }
                        if (Main.netMode == 2 && flag13)
                        {
                            NetMessage.SendData(19, -1, -1, "", 0, (float)num103, (float)(num104 - 1), (float)npc.direction, 0f);
                        }
                    }
                }
            }
            else
            {
                if ((npc.velocity.X < 0f && npc.spriteDirection == -1) || (npc.velocity.X > 0f && npc.spriteDirection == 1))
                {
                    if (Main.tile[num103, num104 - 2].nactive() && TileDef.solid[(int)Main.tile[num103, num104 - 2].type])
                    {
                        if (Main.tile[num103, num104 - 3].nactive() && TileDef.solid[(int)Main.tile[num103, num104 - 3].type])
                        {
                            npc.velocity.Y = -8f;
                            npc.netUpdate = true;
                        }
                        else
                        {
                            npc.velocity.Y = -7f;
                            npc.netUpdate = true;
                        }
                    }
                    else if (Main.tile[num103, num104 - 1].nactive() && TileDef.solid[(int)Main.tile[num103, num104 - 1].type])
                    {
                        npc.velocity.Y = -6f;
                        npc.netUpdate = true;
                    }
                    else if (npc.position.Y + (float)npc.height - (float)(num104 * 16) > 20f && Main.tile[num103, num104].nactive() && !Main.tile[num103, num104].topSlope() && TileDef.solid[(int)Main.tile[num103, num104].type])
                    {
                        npc.velocity.Y = -5f;
                        npc.netUpdate = true;
                    }
                    else if (npc.directionY < 0 && (!Main.tile[num103, num104 + 1].nactive() || !TileDef.solid[(int)Main.tile[num103, num104 + 1].type]) && (!Main.tile[num103 + npc.direction, num104 + 1].nactive() || !TileDef.solid[(int)Main.tile[num103 + npc.direction, num104 + 1].type]))
                    {
                        npc.velocity.Y = -8f;
                        npc.velocity.X = npc.velocity.X * 1.5f;
                        npc.netUpdate = true;
                    }
                    else if (flag5)
                    {
                        npc.ai[1] = 0f;
                        npc.ai[2] = 0f;
                    }
                    if (npc.velocity.Y == 0f && npc.velocity.X == 0f && !npc.justHit && npc.ai[3] == 1f)
                    {
                        npc.velocity.Y = -5f;
                    }
                }
            }
        }
        else if (flag5)
        {
            npc.ai[1] = 0f;
            npc.ai[2] = 0f;
        }
    }

    public void SwordDamage()
    {
        Player player = Main.player[Main.myPlayer];
        if(player.active && !player.dead && !player.immune)
        {
            bool? canHit = player.NPCCanHitPlayer(npc);
            if (!canHit.HasValue || (canHit.HasValue && canHit.Value))
            {
                ItemDef.RunEquipMethod(player, delegate(Item item)
                {
                    bool? canHit2 = item.CanHitPlayer(npc, player);
                    if (canHit2.HasValue)
                    {
                        canHit = canHit2;
                    }
                }, true, true, false, true, false);
            }
            if (!canHit.HasValue || (canHit.HasValue && canHit.Value))
            {
                bool? canHit3 = npc.CanHitPlayer(player);
                if (canHit3.HasValue)
                {
                    canHit = canHit3;
                }
            }
            Rectangle swordBox = new Rectangle((int)npc.position.X, (int)npc.Center.Y - 14, 60, 28);
            if(npc.direction == 1)
            {
                swordBox.X += npc.width;
            }
            if(npc.direction == -1)
            {
                swordBox.X -= swordBox.Width;
            }
            if (player.Hitbox.Intersects(swordBox) && (!canHit.HasValue || canHit.Value))
            {
                int hitDir = (npc.Center.X < player.Center.X) ? 1 : -1;
                int damage = npc.damage;
                bool crit = (float)Main.rand.Next(1, 101) <= npc.critChance;
                float critMult = npc.critMult;
                npc.DamagePlayer(player, hitDir, ref damage, ref crit, ref critMult);
                BuffDef.RunBuffMethod(npc, delegate(ModBuff modbuff)
                {
                    modbuff.DamagePlayer(npc, player, hitDir, ref damage, ref crit, ref critMult);
                });
                player.NPCDamagePlayer(npc, hitDir, ref damage, ref crit, ref critMult);
                BuffDef.RunBuffMethod(player, delegate(ModBuff modbuff)
                {
                    modbuff.DamagePlayer(player, npc, hitDir, ref damage, ref crit, ref critMult);
                });
                ItemDef.RunEquipMethod(player, delegate(Item item)
                {
                    item.DamagePlayer(npc, player, hitDir, ref damage, ref crit, ref critMult);
                }, true, true, false, true, false);
                damage = Main.DamageVar((float)damage);
                if (player.whoAmI == Main.myPlayer && player.thorns != 0f && !player.immune)
                {
                    int num174 = (int)((float)damage * player.thorns);
                    int num175 = 10;
                    npc.StrikeNPC(num174, (float)num175, -hitDir, false, false, 2f);
                    if (Main.netMode != 0)
                    {
                        NetMessage.SendData(28, -1, -1, "", npc.whoAmI, (float)num174, (float)num175, -(float)hitDir, 1f);
                    }
                }
                if (!player.immune)
                {
                    player.StatusPlayer(npc);
                }
                int dmgDealt = (int)player.Hurt(damage, hitDir, false, false, Lang.deathMsg(-1, npc.whoAmI, -1, -1), crit, critMult);
                npc.DealtPlayer(player, hitDir, dmgDealt, crit);
                BuffDef.RunBuffMethod(npc, delegate(ModBuff modbuff)
                {
                    modbuff.DealtPlayer(npc, player, hitDir, damage, crit);
                });
                player.NPCDealtPlayer(npc, hitDir, dmgDealt, crit);
                BuffDef.RunBuffMethod(player, delegate(ModBuff modbuff)
                {
                    modbuff.DealtPlayer(player, npc, hitDir, damage, crit);
                });
                ItemDef.RunEquipMethod(player, delegate(Item item)
                {
                    item.DealtPlayer(npc, player, hitDir, damage, crit);
                }, true, true, false, true, false);
            }
        }
    }

    public override bool CanSpawn(int x, int y, int type, Player spawnedOn)
    {
        int tile = (int)Main.tile[x, y].type;
        int wall = (int)Main.tile[x, y].wall;
        return Bluemagic.NoBiomeNormalSpawn(spawnedOn, tile, wall, y) && y <= Main.worldSurface && !Main.dayTime && Bluemagic.downedAbomination > 0 && Main.rand.Next(2) == 0;
    }

    public override void HitEffect(int hitDirection, double damage, bool isDead)
    {
        if(isDead)
        {
            for(int k = 0; k < 20; k++)
            {
                int dust = Dust.NewDust(npc.position, npc.width, npc.height, 54, 0f, 0f, 50, default(Color), 1.5f);
                Main.dust[dust].velocity *= 2f;
                Main.dust[dust].noGravity = true;
            }
            int gore = Gore.NewGore(new Vector2(npc.position.X, npc.position.Y - 10f), new Vector2((float)hitDirection, 0f), 99, npc.scale);
            Main.gore[gore].velocity *= 0.3f;
            gore = Gore.NewGore(new Vector2(npc.position.X, npc.position.Y + (float)(npc.height / 2) - 15f), new Vector2((float)hitDirection, 0f), 99, npc.scale);
            Main.gore[gore].velocity *= 0.3f;
            gore = Gore.NewGore(new Vector2(npc.position.X, npc.position.Y + (float)npc.height - 20f), new Vector2((float)hitDirection, 0f), 99, npc.scale);
            Main.gore[gore].velocity *= 0.3f;
        }
    }

    public override void SelectFrame(int frameSize)
    {
        glowFrameCounter++;
        glowFrameCounter %= 120;

        if(npc.ai[1] > 0f)
        {
            npc.frame.Y = frameSize * 2;
        }
        else if (npc.velocity.Y == 0f)
        {
            if (npc.direction == 1)
            {
                npc.spriteDirection = 1;
            }
            if (npc.direction == -1)
            {
                npc.spriteDirection = -1;
            }
            if (npc.velocity.X == 0f)
            {
                npc.frame.Y = 0;
                npc.frameCounter = 0.0;
            }
            else
            {
                if(npc.frame.Y < frameSize * 3)
                {
                     npc.frame.Y = frameSize * 3;
                }
                npc.frameCounter += (double)System.Math.Abs(npc.velocity.X) * 2.0;
                if (npc.frameCounter > 12.0)
                {
                    npc.frame.Y += frameSize;
                    npc.frameCounter = 0.0;
                }
                if (npc.frame.Y >= 9 * frameSize)
                {
                    npc.frame.Y = frameSize * 3;
                }
            }
        }
        else
        {
            npc.frameCounter = 0.0;
            npc.frame.Y = frameSize;
        }
    }

    public override void SetupLootRules(NPC unused)
    {
        bool flag = LootRule.settingUp;
        LootRule.settingUp = true;
        LootRule[] rules = new LootRule[2];
        rules[0] = new LootRule(null).Chance(0.05).Item("Bluemagic:FlashSword");
        rules[1] = new LootRule(null).Chance(0.005).Item("Bluemagic:FuryNightBanner");
        LootRule.AddFor("Bluemagic:FuryNight", rules);
        LootRule.settingUp = flag;
    }

    public override void PostDraw(SpriteBatch sb)
    {
        SpriteEffects effects = SpriteEffects.None;
        if(npc.spriteDirection == 1)
        {
            effects = SpriteEffects.FlipHorizontally;
        }
        float alpha = (float)Math.Abs(glowFrameCounter - 60) / 60f;
        Vector2 textureSize = new Vector2((float)modBase.textures["NPCs/Night/FuryNightGlow"].Width, modBase.textures["NPCs/Night/FuryNightGlow"].Height / 9);
        sb.Draw(modBase.textures["NPCs/Night/FuryNightFlash"], new Vector2(npc.position.X + (float)(npc.width / 2) - Main.screenPosition.X, npc.position.Y + (float)(npc.height / 2) - Main.screenPosition.Y + 2f + npc.gfxOffY), npc.frame, Color.White * alpha, npc.rotation, textureSize / 2f, 1f, effects, 0f);
        sb.Draw(modBase.textures["NPCs/Night/FuryNightGlow"], new Vector2(npc.position.X + (float)(npc.width / 2) - Main.screenPosition.X, npc.position.Y + (float)(npc.height / 2) - Main.screenPosition.Y + 2f + npc.gfxOffY), npc.frame, Color.White, npc.rotation, textureSize / 2f, 1f, effects, 0f);
        if(npc.ai[1] > 0f)
        {
            Rectangle swordFrame = new Rectangle(0, 0, modBase.textures["NPCs/Night/FuryNightSword"].Width, modBase.textures["NPCs/Night/FuryNightSword"].Height / 3);
            swordFrame.Y += swordFrame.Height * swordRand.Next(3);
            float offset = (float)textureSize.X / 2f;
            if(npc.spriteDirection == -1)
            {
                offset -= textureSize.X + (float)swordFrame.Width;
            }
            sb.Draw(modBase.textures["NPCs/Night/FuryNightSword"], new Vector2(npc.position.X + (float)(npc.width / 2) - Main.screenPosition.X + offset, npc.position.Y + (float)(npc.height / 2) - Main.screenPosition.Y + 2f + npc.gfxOffY), swordFrame, Color.White, 0f, new Vector2(0f, (float)swordFrame.Height / 2f), 1f, effects, 0f);
        }
    }
}}