using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class Phantom : ModNPC
{
    private static int threshold = 25000;
    //ai[0] = phase
    //ai[1] = attack
    //ai[2] = attackCool
    //ai[3] = attack timer
    //localAI[0] = left hand
    //localAI[1] = right hand
    //localAI[2] = display timer
    //localAI[3] = setup

    public override void AI()
    {
        if(npc.ai[0] < 0f)
        {
            return;
        }

        //target
        if(!Main.player[npc.target].active || Main.player[npc.target].dead)
        {
            npc.TargetClosest();
            if(!Main.player[npc.target].active || Main.player[npc.target].dead)
            {
                npc.velocity = new Vector2(0f, 10f);
                npc.ai[0] = -1f;
                if(npc.timeLeft > 10)
                {
                    npc.timeLeft = 10;
                }
                return;
            }
        }

        //setup
        if(npc.localAI[3] == 0f)
        {
            for(int k = 0; k < 140; k++)
            {
                npc.buffImmune[k] = true;
            }
            npc.localAI[3] = 1f;
        }
        if(npc.localAI[0] < 0f)
        {
            if(Main.netMode == 1)
            {
                return;
            }
            BluemagicNet.PlaySound(15, (int)npc.position.X, (int)npc.position.Y, 0);
            BluemagicNet.NewText(npc.displayName + " " + Lang.misc[16], 50, 150, 200);
            npc.ai[2] = 200f + Main.rand.Next(101);
            npc.localAI[0] = NPC.NewNPC(npc.Center, "Bluemagic:PhantomHand", 0);
            Main.npc[(int)npc.localAI[0]].localAI[0] = npc.whoAmI;
            npc.localAI[1] = NPC.NewNPC(npc.Center, "Bluemagic:PhantomHand", 0);
            Main.npc[(int)npc.localAI[1]].localAI[0] = npc.whoAmI;
            npc.timeLeft = 750 * 30;
            if(Main.netMode == 2)
            {
                BluemagicNet.SendNPCAllData(npc.whoAmI);
                BluemagicNet.SendNPCAllData((int)npc.localAI[0]);
                BluemagicNet.SendNPCAllData((int)npc.localAI[1]);
            }
        }
        Main.npc[(int)npc.localAI[0]].ai[0] = 1;
        Main.npc[(int)npc.localAI[1]].ai[0] = -1;
        Player player = Main.player[npc.target];

        //follow player
        Vector2 move = player.Center - npc.Center;
        move.Y -= 250f;
        if(npc.ai[3] <= 0f && npc.ai[1] != 0f)
        {
            if(npc.ai[1] == -1f || npc.ai[1] % 4f == 0f)
            {
                move.X += 200f;
                move.Y += 200f;
            }
            else if(npc.ai[1] == -2f || npc.ai[1] % 4f == 1f)
            {
                move.X -= 200f;
                move.Y += 200f;
            }
            else
            {
                move.Y += 450f;
            }
        }
        if(move != Vector2.Zero)
        {
            move.Normalize();
        }
        move *= 10f;
        npc.velocity = (29f * npc.velocity + move) / 30f;
        float magnitude = (float)Math.Sqrt(npc.velocity.X * npc.velocity.X + npc.velocity.Y * npc.velocity.Y);
        if(magnitude > 10f)
        {
            npc.velocity *= 10f / magnitude;
        }

        //phase change
        if(npc.ai[0] < 1f && npc.life <= threshold)
        {
            npc.ai[0] = 1f;
            BluemagicNet.PlaySound(15, (int)npc.position.X, (int)npc.position.Y, 0);
            NPC left = Main.npc[(int)npc.localAI[0]];
            NPC right = Main.npc[(int)npc.localAI[1]];
            left.ai[3] = 200f + Main.rand.Next(201);
            right.ai[3] = 200f + Main.rand.Next(201);
            npc.defense = 60;
            npc.netUpdate = true;
            left.netUpdate = true;
            right.netUpdate = true;
        }
        if(npc.ai[0] < 2f && !player.zoneDungeon)
        {
            npc.ai[0] = 2f;
            BluemagicNet.PlaySound(15, (int)npc.position.X, (int)npc.position.Y, 0);
            BluemagicNet.NewText("<" + npc.displayName + "> You thought you could escape...", 50, 150, 200);
            npc.damage = 200;
            Main.npc[(int)npc.localAI[0]].damage = 200;
            Main.npc[(int)npc.localAI[1]].damage = 200;
            npc.defense = 100;
            npc.netUpdate = true;
        }

        //attack
        if(npc.ai[3] <= 0f)
        {
            npc.ai[2] -= 1f;
        }
        else
        {
            npc.ai[3] -= 1f;
        }
        if(Main.netMode != 1 && npc.ai[2] <= 0f)
        {
            npc.TargetClosest();
            if(npc.ai[0] == 0f)
            {
                npc.ai[2] = 120f + Main.rand.Next(61);
            }
            else if(npc.ai[0] == 1f)
            {
                npc.ai[2] = 360f + Main.rand.Next(121);
            }
            else
            {
                npc.ai[2] = 1f;
            }
            if(npc.ai[0] == 0f)
            {
                int which = Main.rand.Next(3);
                if(which == 2)
                {
                    npc.ai[1] = 1f;
                }
                else
                {
                    npc.ai[1] = 0f;
                    NPC hand = Main.npc[(int)npc.localAI[which]];
                    if(Main.rand.Next(2) == 0)
                    {
                        hand.ai[2] = 250f;
                        npc.ai[2] += 250f;
                    }
                    else
                    {
                        hand.ai[2] = -120f;
                        npc.ai[2] += 120f;
                    }
                    hand.netUpdate = true;
                }
            }
            else if(npc.ai[0] == 1f)
            {
                npc.ai[1] = Main.rand.Next(2) * 2 - 1;
            }
            else
            {
                npc.ai[1] = 1f;
            }
            if(npc.ai[1] > 0f)
            {
                npc.ai[1] = Main.rand.Next(480) + 1;
                npc.ai[3] = 250f;
            }
            else if(npc.ai[1] < 0f)
            {
                npc.ai[1] *= Main.rand.Next(2) + 1;
                npc.ai[3] = 120f;
            }
            npc.netUpdate = true;
        }
        if(npc.ai[3] > 0f)
        {
            if(Main.netMode != 1 && npc.ai[1] > 0f && (int)npc.ai[3] % 50 == 0)
            {
                int attackDir = (int)((npc.ai[1] - 1) % 4);
                int num = (int)((300 - npc.ai[3]) / 50);
                int mult = 1;
                int used = 1;
                int pattern = (int)((npc.ai[1] - 1) / 4);
                int realPos = 0;
                for(int x = 0; x < num; x++)
                {
                     int remaining = 5 - x;
                     int pos = (pattern / mult) % remaining;
                     pos++;
                     realPos = 0;
                     for(int k = 1; k <= pos; k++)
                     {
                         if(used % toPrime(k) == 0)
                         {
                             pos++;
                         }
                         realPos++;
                     }
                     mult *= remaining;
                     used *= toPrime(realPos);
                }
                realPos -= 3;
                realPos *= 200;
                Vector2 projPos = player.Center;
                if(attackDir == 0)
                {
                    projPos.X -= 400f;
                    projPos.Y += realPos;
                }
                else if(attackDir == 1)
                {
                    projPos.X += 400f;
                    projPos.Y += realPos;
                }
                else if(attackDir == 2)
                {
                    projPos.Y -= 400f;
                    projPos.X += realPos;
                }
                else
                {
                    projPos.Y += 400f;
                    projPos.X += realPos;
                }
                int proj = Projectile.NewProjectile(projPos, Vector2.Zero, "Bluemagic:PhantomOrb", npc.damage / 2, 0, Main.myPlayer, attackDir, npc.whoAmI);
            }
            else if(Main.netMode != 1 && npc.ai[1] < 0 && npc.ai[3] == 120f)
            {
                int orb = NPC.NewNPC((int)npc.Center.X, (int)npc.position.Y + npc.height, "Bluemagic:PhantomOrb", 0);
                if(npc.ai[1] == -1)
                {
                    Main.npc[orb].ai[0] = -2;
                }
                else
                {
                    Main.npc[orb].ai[0] = 2;
                }
                Main.npc[orb].localAI[0] = npc.whoAmI;
                Main.npc[orb].localAI[1] = npc.whoAmI;
                Main.npc[orb].damage = npc.damage;
                if(Main.netMode == 2)
                {
                    BluemagicNet.SendNPCData(orb);
                }
            }
        }
        

        //display timer
        npc.localAI[2] += 1f;
        if(npc.localAI[2] >= 100f)
        {
            npc.localAI[2] = 0f;
        }

        //create dust
        for(int k = 0; k < 10; k++)
        {
            int x = Main.rand.Next(npc.width * 3 / 2 - 4) + Main.rand.Next(npc.width * 3 / 2 - 3);
            int dust = BluemagicDust.CreatePhantomDust(npc.position.X - npc.width + x, npc.position.Y + 2 * npc.height - Math.Abs(npc.width * 3f / 2f - x) / 2f);
            Main.dust[dust].velocity /= 2f;
            Main.dust[dust].velocity.Y += 5f;
            Main.dust[dust].velocity += npc.velocity;
        }
        if(npc.ai[0] > 0f)
        {
            for(int k = 0; k < 5; k++)
            {
                int dust = BluemagicDust.CreatePhantomDust(npc.Center.X - 4f, npc.Center.Y - 4f);
                Main.dust[dust].velocity *= 3f;
                Main.dust[dust].velocity += npc.velocity;
            }
        }
    }

    private static int toPrime(int k)
    {
        switch(k)
        {
            case 1:
                return 2;
            case 2:
                return 3;
            case 3:
                return 5;
            case 4:
                return 7;
            default:
                return 11;
        }
    }

    public override void HitEffect(int hitDirection, double damage, bool isDead)
    {
        if(isDead)
        {
            int cloud = Gore.NewGore(npc.position, Vector2.Zero, Main.rand.Next(11, 14), 1f);
            Main.gore[cloud].velocity /= 2f;
            cloud = Gore.NewGore(npc.position + new Vector2(40f, 0f), Vector2.Zero, Main.rand.Next(11, 14), 1f);
            Main.gore[cloud].velocity /= 2f;
            cloud = Gore.NewGore(npc.position + new Vector2(0f, 40f), Vector2.Zero, Main.rand.Next(11, 14), 1f);
            Main.gore[cloud].velocity /= 2f;
            cloud = Gore.NewGore(npc.position + new Vector2(40f, 40f), Vector2.Zero, Main.rand.Next(11, 14), 1f);
            Main.gore[cloud].velocity /= 2f;
            cloud = Gore.NewGore(npc.position + new Vector2(20f, 20f), Vector2.Zero, Main.rand.Next(11, 14), 1f);
            Main.gore[cloud].velocity /= 2f;
        }
    }

    public override void SetupLootRules(NPC unused)
    {
        bool flag = LootRule.settingUp;
        LootRule.settingUp = true;
        LootRule[] rules = new LootRule[8];
        rules[0] = new LootRule(null).Item("Greater Healing Potion").Stack(5, 15);
        rules[1] = new LootRule(null).Times((NPC npc) => 5 + Main.rand.Next(5)).Item("Heart");
        rules[2] = new LootRule(null).Chance(0.14285714285714285).Item("Bluemagic:PhantomMask");
        rules[3] = new LootRule(null).Chance(0.1).Item("Bluemagic:PhantomTrophy");
        rules[4] = new LootRule(null).Item("Bluemagic:PhantomPlate").Stack(5, 7);
        rules[5] = new LootRule(null).Weighted(true).LootRules(new LootRule[]
        {
            new LootRule(null).Item("Bluemagic:PhantomBlade"),
            new LootRule(null).Item("Bluemagic:PhantomSphere"),
            new LootRule(null).Item("Bluemagic:SpectreGun"),
            new LootRule(null).Item("Bluemagic:PaladinStaff")
        });
        rules[6] = new LootRule(null).Code(delegate(NPC npc)
        {
            LootRule.DownedBoss(ref Bluemagic.downedPhantom);
        });
        rules[7] = new LootRule("Message").Code(delegate(NPC npc)
        {
            LootRule.DownedBossMessage(npc.displayName + " " + Lang.misc[17], 50, 150, 200);
        });
        LootRule.AddFor("Bluemagic:Phantom", rules);
        LootRule.settingUp = flag;
    }

    public override bool PreDraw(SpriteBatch sb)
    {
        SpriteEffects flip = SpriteEffects.None;
        if(npc.localAI[2] >= 50f)
        {
            flip = SpriteEffects.FlipHorizontally;
        }
        sb.Draw(modBase.textures["NPCs/Phantom/PhantomBody"], npc.position - Main.screenPosition, null, Color.White * (155f / 255f), 0f, new Vector2(npc.width, 0), 1f, flip, 0f);
        sb.Draw(Main.npcTexture[npc.type], npc.position - Main.screenPosition, null, Color.White * ((255 - npc.alpha) / 255f), npc.rotation, Vector2.Zero, 1f, SpriteEffects.None, 0f);
        return false;
    }
}}