using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class PhantomHand : ModNPC
{
    //ai[0] = side
    //ai[1] = movement
    //ai[2] = attack
    //ai[3] = attackCool
    //localAI[0] = phantom

    public override void OnSpawn()
    {
        for(int x = 0; x < 140; x++)
        {
            npc.buffImmune[x] = true;
        }
        npc.localAI[0] = -1f;
    }

    public override void AI()
    {
        //setup
        if(npc.localAI[0] < 0f)
        {
            return;
        }
        NPC phantom = Main.npc[(int)npc.localAI[0]];
        npc.direction = (int)npc.ai[0];
        if(!phantom.active || phantom.type != NPCDef.byName["Bluemagic:Phantom"].type)
        {
            npc.life = -1;
            npc.active = false;
            return;
        }
        else if(npc.timeLeft < 750)
        {
            npc.timeLeft = 750;
        }

        //follow phantom
        npc.position = phantom.Center;
        npc.position.X -= (float)npc.width / 2f;
        npc.position.X -= npc.direction * phantom.width * 2.5f;
        npc.position.Y += phantom.height * 0.75f;

        //movement
        npc.ai[1] += 1f;
        if(npc.ai[1] >= 200f)
        {
            npc.ai[1] = 0f;
        }
        npc.position.Y += npc.direction * (50f - Math.Abs(npc.ai[1] - 100f)) / 5f;

        //attack
        if(Main.netMode != 1 && npc.ai[2] <= 0f && npc.ai[3] <= 0f && phantom.ai[0] > 0f)
        {
            if(Main.rand.Next(2) == 0)
            {
                npc.ai[2] = 250f;
            }
            else
            {
                npc.ai[2] = -120f;
            }
            npc.ai[3] = 360f + Main.rand.Next(121);
            npc.netUpdate = true;
        }
        if(npc.ai[2] > 0f)
        {
            if(Main.netMode != 1 && npc.ai[2] >= 150f && (int)npc.ai[2] % 25 == 0)
            {
                int proj = Projectile.NewProjectile(npc.Center, Vector2.Zero, "Bluemagic:PhantomHammer", npc.damage / 2, 0, Main.myPlayer, npc.whoAmI, phantom.target);
            }
            npc.ai[2] -= 1f;
        }
        else if(npc.ai[2] < 0f)
        {
            if(Main.netMode != 1 && npc.ai[2] == -120f)
            {
                int orb = NPC.NewNPC((int)npc.Center.X, (int)npc.position.Y + npc.height, "Bluemagic:PhantomOrb", 0);
                Main.npc[orb].ai[0] = npc.ai[0];
                Main.npc[orb].localAI[0] = npc.whoAmI;
                Main.npc[orb].localAI[1] = npc.localAI[0];
                Main.npc[orb].damage = npc.damage;
                if(Main.netMode == 2)
                {
                    BluemagicNet.SendNPCAllData(orb);
                }
            }
            npc.ai[2] += 1f;
        }
        if(npc.ai[2] == 0f && npc.ai[3] > 0f)
        {
            npc.ai[3] -= 1f;
        }
    }

    public override bool PreDraw(SpriteBatch sb)
    {
        SpriteEffects flip = SpriteEffects.None;
        if(npc.direction == -1)
        {
            flip = SpriteEffects.FlipHorizontally;
        }
        sb.Draw(Main.npcTexture[npc.type], npc.position - Main.screenPosition, null, Color.White * ((255 - npc.alpha) / 255f), npc.rotation, Vector2.Zero, 1f, flip, 0f);
        return false;
    }
}}