using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class PhantomSoul : ModNPC
{
    private static Random rng = new Random();

    public override void OnSpawn()
    {
        npc.ai[0] = 900;
    }

    public override void AI()
    {
        Player player = Main.player[npc.target];
        if(npc.ai[0] > 700)
        {
            npc.position = new Vector2(player.Center.X - (float)npc.width / 2f, player.Center.Y - (float)npc.height / 2f);
        }
        else if(npc.ai[0] > 300)
        {
            npc.position = new Vector2(player.Center.X - (float)npc.width / 2f, player.Center.Y - (float)npc.height / 2f - (700 - npc.ai[0]) * 0.625f);
        }
        else
        {
            npc.position = new Vector2(player.Center.X - (float)npc.width / 2f, player.Center.Y - (float)npc.height / 2f - 250f);
        }
        int num = 3;
        bool flag = npc.ai[0] == 1;
        if(npc.ai[0] < 120)
        {
            num = 1;
        }
        if(flag)
        {
            num = 200;
        }
        for(int k = 0; k < num; k++)
        {
            int dust = BluemagicDust.CreatePhantomDust(npc.position.X + 16f + rng.Next(9), npc.position.Y + 16f + rng.Next(9));
            if(flag)
            {
                Main.dust[dust].velocity *= (rng.Next(3) + 1);
            }
        }
        npc.ai[0]--;
        if(npc.ai[0] == 100 && Main.netMode == 2)
        {
            npc.netUpdate = true;
        }
        if(npc.ai[0] <= 0)
        {
            npc.active = false;
            if(Main.netMode != 1)
            {
                int boss = NPC.NewNPC((int)npc.Center.X, (int)npc.Center.Y + 40, "Bluemagic:Phantom", 0);
                Main.npc[boss].target = npc.target;
                Main.npc[boss].localAI[0] = -1f;
                if(Main.netMode == 2)
                {
                    BluemagicNet.SendNPCAllData(boss);
                }
            }
        }
    }

    public override void SelectFrame(int frameSize)
    {
        if(npc.ai[0] > 100)
        {
            npc.frame.Y = 0;
        }
        else if(npc.ai[0] > 90)
        {
            npc.frame.Y = frameSize;
        }
        else if(npc.ai[0] > 80)
        {
            npc.frame.Y = 0;
        }
        else if(npc.ai[0] > 70)
        {
            npc.frame.Y = 2 * frameSize;
        }
        else if(npc.ai[0] > 60)
        {
            npc.frame.Y = 0;
        }
        else if(npc.ai[0] > 50)
        {
            npc.frame.Y = 3 * frameSize;
        }
        else if(npc.ai[0] > 40)
        {
            npc.frame.Y = 0;
        }
        else if(npc.ai[0] > 30)
        {
            npc.frame.Y = 4 * frameSize;
        }
        else if(npc.ai[0] > 20)
        {
            npc.frame.Y = 0;
        }
        else
        {
            npc.frame.Y = 5 * frameSize;
            npc.rotation += 0.1f;
        }
    }
}}