using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.NPCs {
public class Shooter : ModNPC
{
    private int shoot;
    private string shootCustom;
    private float shootSpeed;
    private int shootTime;
    private int shootDamage;
    int shootSoundType;
    int shootSoundStyle;
    public Shooter(int proj, float projSpeed, int time = 70, int damage = 0, int projSoundType = -1, int projSoundStyle = -1)
    {
        shoot = proj;
        shootCustom = "";
        shootSpeed = projSpeed;
        shootTime = time;
        shootDamage = damage;
        shootSoundType = projSoundType;
        shootSoundStyle = projSoundStyle;
    }
    public Shooter(string proj, float projSpeed, int time = 70, int damage = 0, int projSoundType = -1, int projSoundStyle = -1)
    {
        shoot = -1;
        shootCustom = proj;
        shootSpeed = projSpeed;
        shootTime = time;
        shootDamage = damage;
        shootSoundType = projSoundType;
        shootSoundStyle = projSoundStyle;
    }

    public override void AI()
    {
        bool flag3 = false;
        if (npc.velocity.X == 0f)
        {
            flag3 = true;
        }
        if (npc.justHit)
        {
            flag3 = false;
        }
        int num22 = 60;
        bool flag4 = false;
        if (npc.ai[2] <= 0f)
        {
            if (npc.velocity.Y == 0f && ((npc.velocity.X > 0f && npc.direction < 0) || (npc.velocity.X < 0f && npc.direction > 0)))
            {
                flag4 = true;
            }
            if (npc.position.X == npc.oldPosition.X || npc.ai[3] >= (float)num22 || flag4)
            {
                npc.ai[3] += 1f;
            }
            else if ((double)System.Math.Abs(npc.velocity.X) > 0.9 && npc.ai[3] > 0f)
            {
                npc.ai[3] -= 1f;
            }
            if (npc.ai[3] > (float)(num22 * 10))
            {
                npc.ai[3] = 0f;
            }
            if (npc.justHit)
            {
                npc.ai[3] = 0f;
            }
            if (npc.ai[3] == (float)num22)
            {
                npc.netUpdate = true;
            }
        }
        if (npc.ai[3] < (float)num22)
        {
            npc.TargetClosest(true);
        }
        else if (npc.ai[2] <= 0f)
        {
            if (Main.dayTime && (double)(npc.position.Y / 16f) < Main.worldSurface && npc.timeLeft > 10)
            {
                npc.timeLeft = 10;
            }
            if (npc.velocity.X == 0f)
            {
                if (npc.velocity.Y == 0f)
                {
                    npc.ai[0] += 1f;
                    if (npc.ai[0] >= 2f)
                    {
                        npc.direction *= -1;
                        npc.spriteDirection = npc.direction;
                        npc.ai[0] = 0f;
                    }
                }
            }
            else
            {
                npc.ai[0] = 0f;
            }
            if (npc.direction == 0)
            {
                npc.direction = 1;
            }
        }

        if (npc.confused)
        {
            npc.ai[2] = 0f;
        }
        else
        {
            if (npc.ai[1] > 0f)
            {
                npc.ai[1] -= 1f;
            }
            if (npc.justHit)
            {
                npc.ai[1] = shootTime / 2 - 1f;
                npc.ai[2] = 0f;
            }
            int num73 = shootTime;
            if (npc.ai[2] > 0f)
            {
                npc.TargetClosest(true);
                if (npc.ai[1] == (float)(num73 / 2))
                {
                    float num74 = shootSpeed;
                    Vector2 vector7 = new Vector2(npc.position.X + (float)npc.width * 0.5f, npc.position.Y + (float)npc.height * 0.5f);
                    float num75 = Main.player[npc.target].position.X + (float)Main.player[npc.target].width * 0.5f - vector7.X;
                    float num76 = 0f;
                    float num77 = Main.player[npc.target].position.Y + (float)Main.player[npc.target].height * 0.5f - vector7.Y - num76;
                    float num78 = (float)System.Math.Sqrt((double)(num75 * num75 + num77 * num77));
                    npc.netUpdate = true;
                    num78 = num74 / num78;
                    num75 *= num78;
                    num77 *= num78;
                    vector7.X += num75;
                    vector7.Y += num77;
                    vector7 += ShootOffset();
                    int shootID = shootCustom == "" ? shoot : ProjDef.byName[shootCustom].type;
                    int damage = shootDamage;
                    if(damage <= 0)
                    {
                        damage = npc.damage / 2;
                    }
                    if(Main.netMode != 1 && shootSoundStyle >= 0)
                    {
                        BluemagicNet.PlaySound(2, (int)npc.position.X, (int)npc.position.Y, 17);
                    }
                    if (Main.netMode != 1)
                    {
                        Projectile.NewProjectile(vector7.X, vector7.Y, num75, num77, shootID, damage, 0f, Main.myPlayer, 0f, 0f);
                    }
                    if (System.Math.Abs(num77) > System.Math.Abs(num75) * 2f)
                    {
                        if (num77 > 0f)
                        {
                            npc.ai[2] = 1f;
                        }
                        else
                        {
                            npc.ai[2] = 5f;
                        }
                    }
                    else
                    {
                        if (System.Math.Abs(num75) > System.Math.Abs(num77) * 2f)
                        {
                            npc.ai[2] = 3f;
                        }
                        else if (num77 > 0f)
                        {
                            npc.ai[2] = 2f;
                        }
                        else
                        {
                            npc.ai[2] = 4f;
                        }
                    }
                }
                if (npc.velocity.Y != 0f || npc.ai[1] <= 0f)
                {
                    npc.ai[2] = 0f;
                    npc.ai[1] = 0f;
                }
                else
                {
                    npc.velocity.X = npc.velocity.X * 0.9f;
                    npc.spriteDirection = npc.direction;
                }
            }
            if (npc.ai[2] <= 0f && npc.velocity.Y == 0f && npc.ai[1] <= 0f && !Main.player[npc.target].dead && Collision.CanHit(npc.position, npc.width, npc.height, Main.player[npc.target].position, Main.player[npc.target].width, Main.player[npc.target].height))
            {
                float num82 = 10f;
                Vector2 vector8 = new Vector2(npc.position.X + (float)npc.width * 0.5f, npc.position.Y + (float)npc.height * 0.5f);
                float num83 = Main.player[npc.target].position.X + (float)Main.player[npc.target].width * 0.5f - vector8.X;
                float num84 = System.Math.Abs(num83) * 0.1f;
                float num85 = Main.player[npc.target].position.Y + (float)Main.player[npc.target].height * 0.5f - vector8.Y - num84;
                num83 += (float)Main.rand.Next(-40, 41);
                num85 += (float)Main.rand.Next(-40, 41);
                float num86 = (float)System.Math.Sqrt((double)(num83 * num83 + num85 * num85));
                float num87 = 700f;
                if (num86 < num87)
                {
                    npc.netUpdate = true;
                    npc.velocity.X *= 0.5f;
                    num86 = num82 / num86;
                    num83 *= num86;
                    num85 *= num86;
                    npc.ai[2] = 3f;
                    npc.ai[1] = (float)num73;
                    if (System.Math.Abs(num85) > System.Math.Abs(num83) * 2f)
                    {
                        if (num85 > 0f)
                        {
                            npc.ai[2] = 1f;
                        }
                        else
                        {
                            npc.ai[2] = 5f;
                        }
                    }
                    else if (System.Math.Abs(num83) > System.Math.Abs(num85) * 2f)
                    {
                        npc.ai[2] = 3f;
                    }
                    else if (num85 > 0f)
                    {
                        npc.ai[2] = 2f;
                    }
                    else
                    {
                        npc.ai[2] = 4f;
                    }
                }
            }
            if (npc.ai[2] <= 0f)
            {
                float num88 = 1f;
                float num89 = 0.07f;
                if (npc.velocity.X < -num88 || npc.velocity.X > num88)
                {
                    if (npc.velocity.Y == 0f)
                    {
                        npc.velocity *= 0.8f;
                    }
                }
                else
                {
                    if (npc.velocity.X < num88 && npc.direction == 1)
                    {
                        npc.velocity.X += num89;
                        if (npc.velocity.X > num88)
                        {
                            npc.velocity.X = num88;
                        }
                    }
                    else if (npc.velocity.X > -1f && npc.direction == -1)
                    {
                        npc.velocity.X -= num89;
                        if (npc.velocity.X < -num88)
                        {
                            npc.velocity.X = -num88;
                        }
                    }
                }
            }
        }

        bool flag11 = false;
        if (npc.velocity.Y == 0f)
        {
            int num93 = (int)(npc.position.Y + (float)npc.height + 7f) / 16;
            int num94 = (int)npc.position.X / 16;
            int num95 = (int)(npc.position.X + (float)npc.width) / 16;
            for (int num96 = num94; num96 <= num95; num96++)
            {
                if (Main.tile[num96, num93] == null)
                {
                    return;
                }
                if (Main.tile[num96, num93].nactive() && TileDef.solid[(int)Main.tile[num96, num93].type])
                {
                    flag11 = true;
                    break;
                }
            }
        }
        if (npc.velocity.Y >= 0f)
        {
            int num97 = 0;
            if (npc.velocity.X < 0f)
            {
                num97 = -1;
            }
            if (npc.velocity.X > 0f)
            {
                num97 = 1;
            }
            Vector2 position = npc.position;
            position.X += npc.velocity.X;
            int num98 = (int)((position.X + (float)(npc.width / 2) + (float)((npc.width / 2 + 1) * num97)) / 16f);
            int num99 = (int)((position.Y + (float)npc.height - 1f) / 16f);
            if (Main.tile[num98, num99] == null)
            {
                Main.tile[num98, num99] = new Tile();
            }
            if (Main.tile[num98, num99 - 1] == null)
            {
                Main.tile[num98, num99 - 1] = new Tile();
            }
            if (Main.tile[num98, num99 - 2] == null)
            {
                Main.tile[num98, num99 - 2] = new Tile();
            }
            if (Main.tile[num98, num99 - 3] == null)
            {
                Main.tile[num98, num99 - 3] = new Tile();
            }
            if (Main.tile[num98, num99 + 1] == null)
            {
                Main.tile[num98, num99 + 1] = new Tile();
            }
            if (Main.tile[num98 - num97, num99 - 3] == null)
            {
                Main.tile[num98 - num97, num99 - 3] = new Tile();
            }
            if ((float)(num98 * 16) < position.X + (float)npc.width && (float)(num98 * 16 + 16) > position.X && ((Main.tile[num98, num99].nactive() && !Main.tile[num98, num99].topSlope() && !Main.tile[num98, num99 - 1].topSlope() && TileDef.solid[(int)Main.tile[num98, num99].type] && !TileDef.solidTop[(int)Main.tile[num98, num99].type]) || (Main.tile[num98, num99 - 1].halfBrick() && Main.tile[num98, num99 - 1].nactive())) && (!Main.tile[num98, num99 - 1].nactive() || !TileDef.solid[(int)Main.tile[num98, num99 - 1].type] || TileDef.solidTop[(int)Main.tile[num98, num99 - 1].type] || (Main.tile[num98, num99 - 1].halfBrick() && (!Main.tile[num98, num99 - 4].nactive() || !TileDef.solid[(int)Main.tile[num98, num99 - 4].type] || TileDef.solidTop[(int)Main.tile[num98, num99 - 4].type]))) && (!Main.tile[num98, num99 - 2].nactive() || !TileDef.solid[(int)Main.tile[num98, num99 - 2].type] || TileDef.solidTop[(int)Main.tile[num98, num99 - 2].type]) && (!Main.tile[num98, num99 - 3].nactive() || !TileDef.solid[(int)Main.tile[num98, num99 - 3].type] || TileDef.solidTop[(int)Main.tile[num98, num99 - 3].type]) && (!Main.tile[num98 - num97, num99 - 3].nactive() || !TileDef.solid[(int)Main.tile[num98 - num97, num99 - 3].type]))
            {
                float num100 = (float)(num99 * 16);
                if (Main.tile[num98, num99].halfBrick())
                {
                    num100 += 8f;
                }
                if (Main.tile[num98, num99 - 1].halfBrick())
                {
                    num100 -= 8f;
                }
                if (num100 < position.Y + (float)npc.height)
                {
                    float num101 = position.Y + (float)npc.height - num100;
                    float num102 = 16.1f;
                    if (num101 <= num102)
                    {
                        npc.gfxOffY += npc.position.Y + (float)npc.height - num100;
                        npc.position.Y = num100 - (float)npc.height;
                        if (num101 < 9f)
                        {
                            npc.stepSpeed = 1f;
                        }
                        else
                        {
                            npc.stepSpeed = 2f;
                        }
                    }
                }
            }
        }
        if (flag11)
        {
            int num103 = (int)((npc.position.X + (float)(npc.width / 2) + (float)(15 * npc.direction)) / 16f);
            int num104 = (int)((npc.position.Y + (float)npc.height - 15f) / 16f);
            if (Main.tile[num103, num104] == null)
            {
                Main.tile[num103, num104] = new Tile();
            }
            if (Main.tile[num103, num104 - 1] == null)
            {
                Main.tile[num103, num104 - 1] = new Tile();
            }
            if (Main.tile[num103, num104 - 2] == null)
            {
                Main.tile[num103, num104 - 2] = new Tile();
            }
            if (Main.tile[num103, num104 - 3] == null)
            {
                Main.tile[num103, num104 - 3] = new Tile();
            }
            if (Main.tile[num103, num104 + 1] == null)
            {
                Main.tile[num103, num104 + 1] = new Tile();
            }
            if (Main.tile[num103 + npc.direction, num104 - 1] == null)
            {
                Main.tile[num103 + npc.direction, num104 - 1] = new Tile();
            }
            if (Main.tile[num103 + npc.direction, num104 + 1] == null)
            {
                Main.tile[num103 + npc.direction, num104 + 1] = new Tile();
            }
            if (Main.tile[num103 - npc.direction, num104 + 1] == null)
            {
                Main.tile[num103 - npc.direction, num104 + 1] = new Tile();
            }
            Main.tile[num103, num104 + 1].halfBrick();
            if ((npc.velocity.X < 0f && npc.spriteDirection == -1) || (npc.velocity.X > 0f && npc.spriteDirection == 1))
            {
                if (Main.tile[num103, num104 - 2].nactive() && TileDef.solid[(int)Main.tile[num103, num104 - 2].type])
                {
                    if (Main.tile[num103, num104 - 3].nactive() && TileDef.solid[(int)Main.tile[num103, num104 - 3].type])
                    {
                        npc.velocity.Y = -8f;
                        npc.netUpdate = true;
                    }
                    else
                    {
                        npc.velocity.Y = -7f;
                        npc.netUpdate = true;
                    }
                }
                else if (Main.tile[num103, num104 - 1].nactive() && TileDef.solid[(int)Main.tile[num103, num104 - 1].type])
                {
                    npc.velocity.Y = -6f;
                    npc.netUpdate = true;
                }
                else if (npc.position.Y + (float)npc.height - (float)(num104 * 16) > 20f && Main.tile[num103, num104].nactive() && !Main.tile[num103, num104].topSlope() && TileDef.solid[(int)Main.tile[num103, num104].type])
                {
                    npc.velocity.Y = -5f;
                    npc.netUpdate = true;
                }
                else if (npc.directionY < 0 && npc.type != 67 && (!Main.tile[num103, num104 + 1].nactive() || !TileDef.solid[(int)Main.tile[num103, num104 + 1].type]) && (!Main.tile[num103 + npc.direction, num104 + 1].nactive() || !TileDef.solid[(int)Main.tile[num103 + npc.direction, num104 + 1].type]))
                {
                    npc.velocity.Y = -8f;
                    npc.velocity.X = npc.velocity.X * 1.5f;
                    npc.netUpdate = true;
                }
                if (npc.velocity.Y == 0f && flag3 && npc.ai[3] == 1f)
                {
                    npc.velocity.Y = -5f;
                }
            }
        }
    }

    public virtual Vector2 ShootOffset()
    {
        return Vector2.Zero;
    }
}}