using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class ElementBall : ModProjectile
{
    public override void AI()
    {
        if(projectile.localAI[0] == 0f)
        {
            PlaySound();
            if(projectile.ai[0] < 0f)
            {
                projectile.alpha = 0;
            }
            if(projectile.ai[0] == 44f)
            {
                projectile.coldDamage = true;
            }
            projectile.displayName = GetName();
            projectile.localAI[0] = 1f;
        }
        CreateDust();
    }

    public virtual void PlaySound()
    {
        Main.PlaySound(2, (int)projectile.position.X, (int)projectile.position.Y, 20);
    }

    public virtual void CreateDust()
    {
        Color? color = GetColor();
        if(color.HasValue)
        {
            int dust = BluemagicDust.CreateFlame(projectile.position, projectile.width, projectile.height, color.Value);
            Main.dust[dust].velocity *= 0.4f;
            Main.dust[dust].velocity += projectile.velocity;
        }
    }

    public virtual string GetName()
    {
        if(projectile.ai[0] == 24f)
        {
            return "Fireball";
        }
        if(projectile.ai[0] == 44f)
        {
            return "Frost Ball";
        }
        if(projectile.ai[0] == BuffDef.byName["Bluemagic:EtherealFlames"])
        {
            return "Ethereal Fireball";
        }
        if(projectile.ai[0] == 70f)
        {
            return "Venom Ball";
        }
        if(projectile.ai[0] == 69f)
        {
            return "Ichor Ball";
        }
        return "Death Bubble";
    }

    public Color? GetColor()
    {
        if(projectile.ai[0] == 24f)
        {
            return new Color(250, 127, 10);
        }
        if(projectile.ai[0] == 44f)
        {
            return new Color(40, 250, 250);
        }
        if(projectile.ai[0] == BuffDef.byName["Bluemagic:EtherealFlames"])
        {
            return new Color(50, 150, 200);
        }
        if(projectile.ai[0] == 70f)
        {
            return new Color(60, 170, 25);
        }
        if(projectile.ai[0] == 69f)
        {
            return new Color(225, 200, 50);
        }
        return null;
    }

    public override void DealtPlayer(Player p, int hitDir, int dmgDealt, bool crit)
    {
        if(Main.rand.Next(2) == 0 && projectile.ai[0] >= 0f)
        {
            p.AddBuff((int)projectile.ai[0], (int)projectile.ai[1], true);
        }
    }
}}