using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class CustomHitbox : ModProjectile
{
    public override void PostAI()
    {
        Damage();
    }

    public void Damage()
    {
        if (projectile.owner == Main.myPlayer && projectile.damage > 0)
        {
            Player player = Main.player[projectile.owner];
            for (int k = 0; k < 200; k++)
            {
                NPC curNPC = Main.npc[k];
                if (curNPC.active && !curNPC.dontTakeDamage && (((!curNPC.friendly || (curNPC.type == 22 && projectile.owner < 255 && player.killGuide) || (curNPC.type == 54 && projectile.owner < 255 && player.killClothier)) && projectile.friendly) || (curNPC.friendly && projectile.hostile)) && (projectile.owner < 0 || curNPC.immune[projectile.owner] == 0 || projectile.maxPenetrate == 1) && Collides(curNPC))
                {
                    bool? flag = projectile.CanHitNPC(curNPC);
                    if(!flag.HasValue)
                    {
                        flag = player.ProjectileCanHitNPC(projectile, curNPC);
                    }
                    if((!flag.HasValue || flag.Value) && ((flag.HasValue && flag.Value) || curNPC.noTileCollide || !projectile.ownerHitCheck || Collision.CanHit(player.position, player.width, player.height, curNPC.position, curNPC.width, curNPC.height)))
                    {
                        if(!DamageNPC(curNPC))
                        {
                            break;
                        }
                    }
                }
            }
            if (Main.localPlayer.hostile)
            {
                for (int l = 0; l < 255; l++)
                {
                    Player subPlayer = Main.player[l];
                    if (l != projectile.owner && subPlayer.active && !subPlayer.dead && !subPlayer.immune && subPlayer.hostile && projectile.playerImmune[l] <= 0 && (Main.localPlayer.team == 0 || Main.localPlayer.team != subPlayer.team) && Collides(subPlayer))
                    {
                        bool? flag = projectile.CanHitPVP(subPlayer);
                        if(!flag.HasValue)
                        {
                            flag = player.ProjectileCanHitPVP(projectile, subPlayer);
                        }
                        if((!flag.HasValue || flag.Value) && ((flag.HasValue && flag.Value) || !projectile.ownerHitCheck || Collision.CanHit(player.position, player.width, player.height, subPlayer.position, subPlayer.width, subPlayer.height)))
                        {
                            if(!DamagePVP(subPlayer))
                            {
                                break;
                            }
                        }
                    }
                }
            }
        }
        if (Main.netMode != 2 && projectile.hostile && Main.myPlayer < 255 && projectile.damage > 0 && Main.localPlayer.active && !Main.localPlayer.dead && !Main.localPlayer.immune && Collides(Main.localPlayer))
        {
            bool? flag = projectile.CanHitPlayer(Main.localPlayer);
            if (flag.HasValue && !flag.Value)
            {
                return;
            }
            DamageMyPlayer();
        }
    }

    public bool DamageNPC(NPC curNPC)
    {
        Player player = Main.player[projectile.owner];
        projectile.direction = AttackDirection(curNPC);
        bool crit = false;
        if (projectile.melee && Main.rand.Next(1, 101) <= player.meleeCrit)
        {
            crit = true;
        }
        if (projectile.ranged && Main.rand.Next(1, 101) <= player.rangedCrit)
        {
            crit = true;
        }
        if (projectile.magic && Main.rand.Next(1, 101) <= player.magicCrit)
        {
            crit = true;
        }
        int Damage = projectile.damage;
        projectile.StatusNPC(curNPC.whoAmI);
        player.OnHit(curNPC.center().X, curNPC.center().Y, curNPC);
        float mult = 2f;
        if (projectile.melee)
        {
            mult = Main.player[projectile.owner].meleeCritMult;
        }
        else if (projectile.ranged)
        {
            mult = Main.player[projectile.owner].rangedCritMult;
        }
        else if (projectile.magic)
        {
            mult = Main.player[projectile.owner].magicCritMult;
        }
        float knockback = projectile.knockBack;
        curNPC.ProjectileDamageNPC(projectile, projectile.direction, ref Damage, ref knockback, ref crit, ref mult);
        BuffDef.RunBuffMethod(curNPC, delegate(ModBuff modbuff)
        {
            modbuff.DamageNPC(curNPC, projectile, projectile.direction, ref Damage, ref knockback, ref crit, ref mult);
        });
        player.ProjectileDamageNPC(projectile, curNPC, projectile.direction, ref Damage, ref knockback, ref crit, ref mult);
        BuffDef.RunBuffMethod(player, delegate(ModBuff modbuff)
        {
            modbuff.DamageNPC(projectile, curNPC, projectile.direction, ref Damage, ref knockback, ref crit, ref mult);
        });
        projectile.DamageNPC(curNPC, projectile.direction, ref Damage, ref knockback, ref crit, ref mult);
        Damage = Main.DamageVar((float)Damage, projectile.player);
        int dmg = (int)curNPC.StrikeNPC(Damage, knockback, projectile.direction, crit, false, mult);
        curNPC.ProjectileDealtNPC(projectile, projectile.direction, dmg, knockback, crit);
        BuffDef.RunBuffMethod(curNPC, delegate(ModBuff modbuff)
        {
            modbuff.DealtNPC(curNPC, projectile, projectile.direction, dmg, knockback, crit);
        });
        player.ProjectileDealtNPC(projectile, curNPC, projectile.direction, dmg, knockback, crit);
        BuffDef.RunBuffMethod(player, delegate(ModBuff modbuff)
        {
            modbuff.DealtNPC(projectile, curNPC, projectile.direction, dmg, knockback, crit);
        });
        projectile.DealtNPC(curNPC, projectile.direction, dmg, knockback, crit);
        if (dmg > 0 && curNPC.lifeMax > 5 && projectile.friendly && !projectile.hostile)
        {
            if (player.ghostHeal)
            {
                projectile.ghostHeal(dmg, new Vector2(curNPC.center().X, curNPC.center().Y));
            }
            if (player.ghostHurt)
            {
                projectile.ghostHurt(dmg, new Vector2(curNPC.center().X, curNPC.center().Y));
            }
            if (projectile.melee && player.beetleOffense)
            {
                if (player.beetleOrbs == 0)
                {
                    player.beetleCounter += (float)(dmg * 3);
                }
                else if (player.beetleOrbs == 1)
                {
                    player.beetleCounter += (float)(dmg * 2);
                }
                else
                {
                    player.beetleCounter += (float)dmg;
                }
                player.beetleCountdown = 0;
            }
        }
        if (projectile.melee && player.meleeEnchant == 7)
        {
            Projectile.NewProjectile(curNPC.center().X, curNPC.center().Y, curNPC.velocity.X, curNPC.velocity.Y, 289, 0, 0f, projectile.owner, 0f, 0f);
        }
        if (curNPC.value > 0f && player.coins && Main.rand.Next(5) == 0)
        {
            int num10 = 71;
            if (Main.rand.Next(10) == 0)
            {
                num10 = 72;
            }
            if (Main.rand.Next(100) == 0)
            {
                num10 = 73;
            }
            int num11 = Item.NewItem((int)curNPC.position.X, (int)curNPC.position.Y, curNPC.width, curNPC.height, num10, 1, false, 0, false);
            Main.item[num11].stack = Main.rand.Next(1, 11);
            Main.item[num11].velocity.Y = (float)Main.rand.Next(-20, 1) * 0.2f;
            Main.item[num11].velocity.X = (float)Main.rand.Next(10, 31) * 0.2f * (float)projectile.direction;
            if (Main.netMode == 1)
            {
                NetMessage.SendData(21, -1, -1, "", num11, 0f, 0f, 0f, 0f);
            }
        }
        if (Main.netMode != 0)
        {
            if (crit)
            {
                NetMessage.SendData(28, -1, -1, "", curNPC.whoAmI, (float)Damage, knockback, (float)projectile.direction, mult);
            }
            else
            {
                NetMessage.SendData(28, -1, -1, "", curNPC.whoAmI, (float)Damage, knockback, (float)projectile.direction, 1f);
            }
        }
        curNPC.immune[projectile.owner] = projectile.penetrateImmuneTime;
        if (projectile.penetrate > 0)
        {
            projectile.penetrate--;
            if (projectile.penetrate == 0)
            {
                return false;
            }
        }
        projectile.numHits++;
        return true;
    }

    public bool DamagePVP(Player subPlayer)
    {
        Player player = Main.player[projectile.owner];
        projectile.direction = AttackDirection(subPlayer);
        bool crit = false;
        if (projectile.melee && Main.rand.Next(1, 101) <= player.meleeCrit)
        {
            crit = true;
        }
        int Damage = projectile.damage;
        if (!subPlayer.immune)
        {
            projectile.StatusPvP(subPlayer.whoAmI);
        }
        player.OnHit(subPlayer.Center.X, subPlayer.Center.Y, subPlayer);
        float mult = 2f;
        if (projectile.melee)
        {
            mult = player.meleeCritMult;
        }
        else if (projectile.ranged)
        {
            mult = player.rangedCritMult;
        }
        else if (projectile.magic)
        {
            mult = player.magicCritMult;
        }
        player.ProjectileDamagePVP(projectile, subPlayer, projectile.direction, ref Damage, ref crit, ref mult);
        BuffDef.RunBuffMethod(player, delegate(ModBuff modbuff)
        {
            modbuff.DamagePVP(projectile, subPlayer, projectile.direction, ref Damage, ref crit, ref mult);
        });
        projectile.DamagePVP(subPlayer, projectile.direction, ref Damage, ref crit, ref mult);
        Damage = Main.DamageVar((float)Damage, projectile.player);
        int num12 = (int)subPlayer.Hurt(Damage, projectile.direction, true, false, Lang.deathMsg(projectile.owner, -1, projectile.whoAmI, -1), crit, 2f);
        player.ProjectileDealtPVP(projectile, subPlayer, projectile.direction, num12, crit);
        BuffDef.RunBuffMethod(player, delegate(ModBuff modbuff)
        {
            modbuff.DealtPVP(projectile, subPlayer, projectile.direction, Damage, crit);
        });
        projectile.DealtPVP(subPlayer, projectile.direction, num12, crit);
        if (num12 > 0 && player.ghostHeal && projectile.friendly && !projectile.hostile)
        {
            projectile.ghostHeal(num12, new Vector2(subPlayer.Center.X, subPlayer.Center.Y));
        }
        if (projectile.melee && player.meleeEnchant == 7)
        {
            Projectile.NewProjectile(subPlayer.Center.X, subPlayer.Center.Y, subPlayer.velocity.X, subPlayer.velocity.Y, 289, 0, 0f, projectile.owner, 0f, 0f);
        }
        if (Main.netMode != 0)
        {
            if (crit)
            {
                NetMessage.SendData(26, -1, -1, Lang.deathMsg(projectile.owner, -1, projectile.whoAmI, -1), subPlayer.whoAmI, (float)projectile.direction, (float)Damage, 1f, mult);
            }
            else
            {
                NetMessage.SendData(26, -1, -1, Lang.deathMsg(projectile.owner, -1, projectile.whoAmI, -1), subPlayer.whoAmI, (float)projectile.direction, (float)Damage, 1f, 1f);
            }
        }
        projectile.playerImmune[subPlayer.whoAmI] = 40;
        if (projectile.penetrate > 0)
        {
            projectile.penetrate--;
            if (projectile.penetrate == 0)
            {
                return false;
            }
        }
        return true;
    }

    public void DamageMyPlayer()
    {
        int num13 = AttackDirection(Main.localPlayer);
        int num14 = projectile.damage;
        if (Main.localPlayer.resistCold && projectile.coldDamage)
        {
            num14 = (int)((float)num14 * 0.7f);
        }
        int num15 = projectile.npcCritChance;
        bool crit2 = Main.rand.Next(1, 101) <= num15;
        float critMult = projectile.npcCritMult;
        Main.localPlayer.ProjectileDamagePlayer(projectile, num13, ref num14, ref crit2, ref critMult);
        projectile.DamagePlayer(Main.localPlayer, num13, ref num14, ref crit2, ref critMult);
        num14 = Main.DamageVar((float)num14, projectile.player);
        int dmgDealt = (int)Main.localPlayer.Hurt(num14 * 2, num13, false, false, Lang.deathMsg(-1, -1, projectile.whoAmI, -1), crit2, critMult);
        Main.localPlayer.ProjectileDealtPlayer(projectile, num13, dmgDealt, crit2);
        projectile.DealtPlayer(Main.localPlayer, num13, dmgDealt, crit2);
    }

    public virtual bool Collides(CodableEntity entity)
    {
        return projectile.Hitbox.Intersects(entity.Hitbox);
    }

    public virtual int AttackDirection(CodableEntity target)
    {
        return projectile.direction;
    }
}}