using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class RottingSpit : ModProjectile
{
    public override void AI()
    {
        int dust;
        if(projectile.localAI[0] < 2f)
        {
            projectile.localAI[0] += 1f;
            if(projectile.localAI[0] == 2f)
            {
                projectile.position += projectile.velocity;
                Main.PlaySound(4, (int)projectile.position.X, (int)projectile.position.Y, 9);
            }
            for(int k = 0; k < 20; k++)
            {
                dust = Dust.NewDust(new Vector2(projectile.position.X, projectile.position.Y + 2f), projectile.width, projectile.height, 18, 0f, 0f, 100, default(Color), 1.8f);
                Main.dust[dust].velocity *= 1.3f;
                Main.dust[dust].velocity += projectile.velocity;
                Main.dust[dust].noGravity = true;
            }
        }
        dust = Dust.NewDust(new Vector2(projectile.position.X, projectile.position.Y + 2f), projectile.width, projectile.height, 18, projectile.velocity.X * 0.1f, projectile.velocity.Y * 0.1f, 80, default(Color), 1.3f);
        Main.dust[dust].velocity *= 0.3f;
        Main.dust[dust].noGravity = true;
    }

    public override void DealtPlayer(Player p, int hitDir, int dmgDealt, bool crit)
    {
        if(Main.rand.Next(8) == 0)
        {
            p.AddBuff("Bluemagic:Rotting", 360, true);
            BluemagicNet.SendTransform(p.whoAmI, 2, 360);
        }
    }

    public override void Kill()
    {
        for(int k = 0; k < 20; k++)
        {
            int dust = Dust.NewDust(new Vector2(projectile.position.X, projectile.position.Y + 2f), projectile.width, projectile.height, 18, 0f, 0f, 100, default(Color), 2f);
            if(Main.rand.Next(2) == 0)
            {
                Main.dust[dust].scale *= 0.6f;
            }
            else
            {
                Main.dust[dust].velocity *= 1.4f;
                Main.dust[dust].noGravity = true;
            }
        }
        Main.PlaySound(4, (int)projectile.position.X, (int)projectile.position.Y, 9);
    }
}}