using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class ShadowArm : TrailHitbox
{
    public Vector2 last2 = Vector2.Zero;
    public Vector2 last = Vector2.Zero;
    public Vector2 target = Vector2.Zero;
    private const float increment = 16f;

    public override void CustomBehavior()
    {
        if(Vector2.Distance(last, target) <= increment)
        {
            projectile.localAI[0] = 1f;
        }
        if(projectile.localAI[0] > 0f)
        {
            if(projectile.localAI[0] < 25f)
            {
                Vector2 offset = last - last2;
                Add(last + offset);
                projectile.localAI[0] += 1f;
            }
        }
        else
        {
            Vector2 offset = last - last2;
            Vector2 goal = target - last;
            int triesLeft = (int)(goal.Length() / increment);
            double offsetAngle = Math.Atan2(offset.Y, offset.X);
            double goalAngle = Math.Atan2(goal.Y, goal.X);
            double angleDistance = Math.PI - Math.Abs(Math.PI - Math.Abs(offsetAngle - goalAngle));
            double angleIncrement = angleDistance / triesLeft;
            if(angleDistance >= Math.PI / 8 && angleIncrement < Math.PI / 16)
            {
                angleIncrement = Math.PI / 16;
            }
            double targetAngle1 = offsetAngle + angleIncrement;
            double targetAngle2 = offsetAngle - angleIncrement;
            double error1 = Math.PI - Math.Abs(Math.PI - Math.Abs(targetAngle1 - goalAngle));
            double error2 = Math.PI - Math.Abs(Math.PI - Math.Abs(targetAngle2 - goalAngle));
            Vector2 targetOffset = Vector2.Zero;
            if(error1 < error2)
            {
                targetOffset = increment * new Vector2((float)Math.Cos(targetAngle1), (float)Math.Sin(targetAngle1));
            }
            else
            {
                targetOffset = increment * new Vector2((float)Math.Cos(targetAngle2), (float)Math.Sin(targetAngle2));
            }
            Add(last + targetOffset);
        }
    }

    public override void PostAdd(Vector2 pos)
    {
        last2 = last;
        last = pos;
    }

    public override void CreateDust(Vector2 pos)
    {
        if(Main.rand.Next(5) == 0)
        {
            int dust = BluemagicDust.CreateSmoke(pos - new Vector2(8f, 8f), 16, 16, Color.Black);
            Main.dust[dust].scale = 2f;
            Main.dust[dust].velocity *= 0.5f;
        }
    }
}}