using System;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
[GlobalMod]
public class GlobalProj : ModProjectile
{
    public override bool PreAI()
    {
        if(projectile.type != 344 && projectile.melee && !projectile.noEnchantments && Main.player[projectile.owner].active)
        {
            int meleeEnchant = Main.player[projectile.owner].GetSubClass<BluemagicPlayer>().customMeleeEnchant;
            if(meleeEnchant == 1)
            {
                if(Main.rand.Next(2) == 0)
                {
                    int dust = BluemagicDust.CreateEFlameDust(projectile.position.X, projectile.position.Y, projectile.width, projectile.height, projectile.velocity, projectile.direction);
                    Main.dust[dust].velocity *= 0.7f;
                    Main.dust[dust].velocity.Y -= 0.5f;
                }
            }
        }

        if(projectile.owner == Main.myPlayer && projectile.type >= 145 && projectile.type <= 149)
        {
            int i = (int)(projectile.position.X + (float)(projectile.width / 2)) / 16;
            int j = (int)(projectile.position.Y + (float)(projectile.height / 2)) / 16;
            int size = 2;
            int type = projectile.type - 145;
            int[] stoneIDs = {1, 25, 117, TileDef.byName["Bluemagic:Shroomstone"], 203};
            int[] sandIDs = {53, 112, 116, TileDef.byName["Bluemagic:Shroomsand"], 234};
            int[] iceIDs = {161, 163, 164, TileDef.byName["Bluemagic:DarkBlueIce"], 200};
            int[][] tileIDs = {stoneIDs, sandIDs, iceIDs};
            int[] wallIDs = {1, 3, 28, TileDef.wallByName["Bluemagic:ShroomstoneWall"], 83};
            if(type != 3)
            {
                for(int x = i - size; x <= i + size; x++)
                {
                    for(int y = j - size; y <= j + size; y++)
                    {
                        bool tileChanged = false;
                        for(int k = 0; k < tileIDs.Length; k++)
                        {
                            if(Main.tile[x, y].type == tileIDs[k][3])
                            {
                                Main.tile[x, y].type = (ushort)tileIDs[k][type];
                                tileChanged = true;
                                break;
                            }
                        }
                        bool wallChanged = false;
                        if(Main.tile[x, y].wall == wallIDs[3])
                        {
                            Main.tile[x, y].wall = (ushort)wallIDs[type];
                            wallChanged = true;
                        }
                        if(tileChanged)
                        {
                            WorldGen.SquareTileFrame(x, y, true);
                        }
                        if(wallChanged)
                        {
                            WorldGen.SquareWallFrame(x, y, true);
                        }
                        if(tileChanged || wallChanged)
                        {
                            NetMessage.SendTileSquare(-1, x, y, 1);
                        }
                    }
                }
            }
            else
            {
                for(int x = i - size; x <= i + size; x++)
                {
                    for(int y = j - size; y <= j + size; y++)
                    {
                        bool tileChanged = false;
                        for(int k = 0; k < tileIDs.Length && !tileChanged; k++)
                        {
                            for(int l = 0; l < 5; l++)
                            {
                                if(l != 3 && Main.tile[x, y].type == tileIDs[k][l])
                                {
                                    Main.tile[x, y].type = (ushort)tileIDs[k][3];
                                    tileChanged = true;
                                    break;
                                }
                            }
                        }
                        bool wallChanged = false;
                        for(int k = 0; k < 5; k++)
                        {
                            if(k != 3 && Main.tile[x, y].wall == wallIDs[k])
                            {
                                Main.tile[x, y].wall = (ushort)wallIDs[3];
                                wallChanged = true;
                                break;
                            }
                        }
                        if(tileChanged)
                        {
                            WorldGen.SquareTileFrame(x, y, true);
                        }
                        if(wallChanged)
                        {
                            WorldGen.SquareWallFrame(x, y, true);
                        }
                        if(tileChanged || wallChanged)
                        {
                            NetMessage.SendTileSquare(-1, x, y, 1);
                        }
                    }
                }
            }
        }
        return true;
    }
}}