using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class NightmareDrop : ModProjectile
{
    public override void AI()
    {
        if(projectile.ai[0] > 0f)
        {
            for(int k = 0; k < 200; k++)
            {
                NPC npc = Main.npc[k];
                if(npc.active && npc.type == NPCDef.byName["Bluemagic:NightmareFuel"].type && projectile.Hitbox.Intersects(npc.Hitbox))
                {
                    if(Main.netMode != 1)
                    {
                        int healAmount = (int)projectile.ai[0];
                        if(healAmount > npc.lifeMax - npc.life)
                        {
                            healAmount = npc.lifeMax - npc.life;
                        }
                        npc.life += healAmount;
                        BluemagicNet.SendNPCHeal(npc.whoAmI, healAmount);
                    }
                    projectile.Kill();
                }
            }
        }
    }

    public override void DealtPlayer(Player p, int hitDir, int dmgDealt, bool crit)
    {
        LeechLife(dmgDealt);
        if(Main.netMode != 0)
        {
            BluemagicNet.SendNightmareDropData(projectile.whoAmI, dmgDealt);
        }
    }

    public void LeechLife(int amount)
    {
        projectile.ai[0] += amount;
        if(projectile.velocity.Y > 0f)
        {
            projectile.velocity.Y *= -1f;
        }
    }
}}