using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class Minion : ModProjectile
{
    public override void OnSpawn()
    {
        projectile.netImportant = true;
    }

    public override bool PreAI()
    {
        Player player = Main.player[projectile.owner];
        if(!player.active)
        {
            projectile.active = false;
            return false;
        }
        CheckActive(player, player.GetSubClass<BluemagicPlayer>());
        return true;
    }

    public virtual void CheckActive(Player player, BluemagicPlayer modPlayer) {}

    public void CheckActive(Player player, ref bool minionVar)
    {
        if(player.dead)
        {
            minionVar = false;
        }
        if(minionVar)
        {
            projectile.timeLeft = 2;
        }
    }

    public override void PostAI()
    {
        Damage();
    }

    private void Damage()
    {
        Player player = Main.player[projectile.owner];
        Rectangle rectangle = new Rectangle((int)projectile.position.X, (int)projectile.position.Y, projectile.width, projectile.height);
        if(projectile.friendly && projectile.owner == Main.myPlayer)
        {
            if(projectile.hurtsTiles)
            {
                int num5 = (int)(projectile.position.X / 16f);
                int num6 = (int)((projectile.position.X + (float)projectile.width) / 16f) + 1;
                int num7 = (int)(projectile.position.Y / 16f);
                int num8 = (int)((projectile.position.Y + (float)projectile.height) / 16f) + 1;
                if(num5 < 0)
                {
                    num5 = 0;
                }
                if(num6 > Main.maxTilesX)
                {
                    num6 = Main.maxTilesX;
                }
                if(num7 < 0)
                {
                    num7 = 0;
                }
                if(num8 > Main.maxTilesY)
                {
                    num8 = Main.maxTilesY;
                }
                for(int i = num5; i < num6; i++)
                {
                    for(int j = num7; j < num8; j++)
                    {
                        if(Main.tile[i, j] != null && TileDef.breaksByCut[(int)Main.tile[i, j].type] && Main.tile[i, j + 1] != null && Main.tile[i, j + 1].type != 78)
                        {
                            WorldGen.KillTile(i, j, false, false, false);
                            if(Main.netMode != 0)
                            {
                                NetMessage.SendData(17, -1, -1, "", 0, (float)i, (float)j, 0f, 0f);
                            }
                        }
                    }
                }
            }
        }
        if(projectile.owner == Main.myPlayer)
        {
            if(projectile.damage > 0)
            {
                for(int k = 0; k < 200; k++)
                {
                    NPC curNPC = Main.npc[k];
                    if(curNPC.active && !curNPC.dontTakeDamage && (((!curNPC.friendly || (curNPC.type == 22 && projectile.owner < 255 && player.killGuide) || (curNPC.type == 54 && projectile.owner < 255 && player.killClothier)) && projectile.friendly) || (curNPC.friendly && projectile.hostile)) && (projectile.owner < 0 || curNPC.immune[projectile.owner] == 0 || projectile.maxPenetrate == 1))
                    {
                        Rectangle value2 = new Rectangle((int)curNPC.position.X, (int)curNPC.position.Y, curNPC.width, curNPC.height);
                        if(rectangle.Intersects(value2))
                        {
                            bool? flag2 = player.ProjectileCanHitNPC(projectile, curNPC);
                            bool? flag3 = projectile.CanHitNPC(curNPC);
                            if(!flag3.HasValue)
                            {
                                flag3 = flag2;
                            }
                            if(!flag3.HasValue || flag3.Value)
                            {
                                bool flag4 = (flag3.HasValue && flag3.Value) || curNPC.noTileCollide || !projectile.ownerHitCheck || Collision.CanHit(player.position, player.width, player.height, curNPC.position, curNPC.width, curNPC.height);
                                if(flag4)
                                {
                                    bool crit = false;
                                    int Damage = projectile.damage;
                                    projectile.StatusNPC(k);
                                    player.OnHit(curNPC.center().X, curNPC.center().Y, curNPC);
                                    float mult = 2f;
                                    float knockback = projectile.knockBack;
                                    curNPC.ProjectileDamageNPC(projectile, projectile.direction, ref Damage, ref knockback, ref crit, ref mult);
                                    BuffDef.RunBuffMethod(curNPC, delegate(ModBuff modbuff)
                                    {
                                        modbuff.DamageNPC(curNPC, projectile, projectile.direction, ref Damage, ref knockback, ref crit, ref mult);
                                    });
                                    player.ProjectileDamageNPC(projectile, curNPC, projectile.direction, ref Damage, ref knockback, ref crit, ref mult);
                                    BuffDef.RunBuffMethod(player, delegate(ModBuff modbuff)
                                    {
                                        modbuff.DamageNPC(projectile, curNPC, projectile.direction, ref Damage, ref knockback, ref crit, ref mult);
                                    });
                                    projectile.DamageNPC(curNPC, projectile.direction, ref Damage, ref knockback, ref crit, ref mult);
                                    Damage = Main.DamageVar((float)Damage, projectile.player);
                                    int dmg = (int)curNPC.StrikeNPC(Damage, knockback, projectile.direction, crit, false, mult);
                                    curNPC.ProjectileDealtNPC(projectile, projectile.direction, dmg, knockback, crit);
                                    BuffDef.RunBuffMethod(curNPC, delegate(ModBuff modbuff)
                                    {
                                        modbuff.DealtNPC(curNPC, projectile, projectile.direction, dmg, knockback, crit);
                                    });
                                    player.ProjectileDealtNPC(projectile, curNPC, projectile.direction, dmg, knockback, crit);
                                    BuffDef.RunBuffMethod(player, delegate(ModBuff modbuff)
                                    {
                                        modbuff.DealtNPC(projectile, curNPC, projectile.direction, dmg, knockback, crit);
                                    });
                                    projectile.DealtNPC(curNPC, projectile.direction, dmg, knockback, crit);
                                    if(dmg > 0 && curNPC.lifeMax > 5 && projectile.friendly && !projectile.hostile)
                                    {
                                        if(player.ghostHeal)
                                        {
                                            projectile.ghostHeal(dmg, new Vector2(curNPC.center().X, curNPC.center().Y));
                                        }
                                        if(player.ghostHurt)
                                        {
                                            projectile.ghostHurt(dmg, new Vector2(curNPC.center().X, curNPC.center().Y));
                                        }
                                    }
                                    if(curNPC.value > 0f && player.coins && Main.rand.Next(5) == 0)
                                    {
                                        int num10 = 71;
                                        if(Main.rand.Next(10) == 0)
                                        {
                                            num10 = 72;
                                        }
                                        if(Main.rand.Next(100) == 0)
                                        {
                                            num10 = 73;
                                        }
                                        int num11 = Item.NewItem((int)curNPC.position.X, (int)curNPC.position.Y, curNPC.width, curNPC.height, num10, 1, false, 0, false);
                                        Main.item[num11].stack = Main.rand.Next(1, 11);
                                        Main.item[num11].velocity.Y = (float)Main.rand.Next(-20, 1) * 0.2f;
                                        Main.item[num11].velocity.X = (float)Main.rand.Next(10, 31) * 0.2f * (float)projectile.direction;
                                        if(Main.netMode == 1)
                                        {
                                            NetMessage.SendData(21, -1, -1, "", num11, 0f, 0f, 0f, 0f);
                                        }
                                    }
                                    if(Main.netMode != 0)
                                    {
                                        if(crit)
                                        {
                                            NetMessage.SendData(28, -1, -1, "", k, (float)Damage, knockback, (float)projectile.direction, mult);
                                        }
                                        else
                                        {
                                            NetMessage.SendData(28, -1, -1, "", k, (float)Damage, knockback, (float)projectile.direction, 1f);
                                        }
                                    }
                                    curNPC.immune[projectile.owner] = projectile.penetrateImmuneTime;
                                    projectile.numHits++;
                                }
                            }
                        }
                    }
                }
            }
            if(projectile.damage > 0 && Main.localPlayer.hostile)
            {
                for(int l = 0; l < 255; l++)
                {
                    Player subPlayer = Main.player[l];
                    if(l != projectile.owner && subPlayer.active && !subPlayer.dead && !subPlayer.immune && subPlayer.hostile && projectile.playerImmune[l] <= 0 && (Main.localPlayer.team == 0 || Main.localPlayer.team != subPlayer.team))
                    {
                        Rectangle value3 = new Rectangle((int)subPlayer.position.X, (int)subPlayer.position.Y, subPlayer.width, subPlayer.height);
                        if(rectangle.Intersects(value3))
                        {
                            bool? flag5 = player.ProjectileCanHitPVP(projectile, subPlayer);
                            bool? flag6 = projectile.CanHitPVP(subPlayer);
                            if(!flag6.HasValue)
                            {
                                flag6 = flag5;
                            }
                            if(!flag6.HasValue || flag6.Value)
                            {
                                bool flag7 = (flag6.HasValue && flag6.Value) || !projectile.ownerHitCheck || Collision.CanHit(player.position, player.width, player.height, subPlayer.position, subPlayer.width, subPlayer.height);
                                if(flag7)
                                {
                                    bool crit = false;
                                    int Damage = projectile.damage;
                                    if(!subPlayer.immune)
                                    {
                                        projectile.StatusPvP(l);
                                    }
                                    player.OnHit(subPlayer.Center.X, subPlayer.Center.Y, subPlayer);
                                    float mult = 2f;
                                    player.ProjectileDamagePVP(projectile, subPlayer, projectile.direction, ref Damage, ref crit, ref mult);
                                    BuffDef.RunBuffMethod(player, delegate(ModBuff modbuff)
                                    {
                                        modbuff.DamagePVP(projectile, subPlayer, projectile.direction, ref Damage, ref crit, ref mult);
                                    });
                                    projectile.DamagePVP(subPlayer, projectile.direction, ref Damage, ref crit, ref mult);
                                    Damage = Main.DamageVar((float)Damage, projectile.player);
                                    int num12 = (int)subPlayer.Hurt(Damage, projectile.direction, true, false, Lang.deathMsg(projectile.owner, -1, projectile.whoAmI, -1), crit, 2f);
                                    player.ProjectileDealtPVP(projectile, subPlayer, projectile.direction, num12, crit);
                                    BuffDef.RunBuffMethod(player, delegate(ModBuff modbuff)
                                    {
                                        modbuff.DealtPVP(projectile, subPlayer, projectile.direction, Damage, crit);
                                    });
                                    projectile.DealtPVP(subPlayer, projectile.direction, num12, crit);
                                    if(num12 > 0 && player.ghostHeal && projectile.friendly && !projectile.hostile)
                                    {
                                        projectile.ghostHeal(num12, new Vector2(subPlayer.Center.X, subPlayer.Center.Y));
                                    }
                                    if(Main.netMode != 0)
                                    {
                                        if(crit)
                                        {
                                            NetMessage.SendData(26, -1, -1, Lang.deathMsg(projectile.owner, -1, projectile.whoAmI, -1), l, (float)projectile.direction, (float)Damage, 1f, mult);
                                        }
                                        else
                                        {
                                            NetMessage.SendData(26, -1, -1, Lang.deathMsg(projectile.owner, -1, projectile.whoAmI, -1), l, (float)projectile.direction, (float)Damage, 1f, 1f);
                                        }
                                    }
                                    projectile.playerImmune[l] = 40;
                                }
                            }
                        }
                    }
                }
            }
        }
        if(Main.netMode != 2 && projectile.hostile && Main.myPlayer < 255 && projectile.damage > 0)
        {
            int myPlayer2 = Main.myPlayer;
            if(Main.localPlayer.active && !Main.localPlayer.dead && !Main.localPlayer.immune && rectangle.Intersects(Main.localPlayer.Hitbox))
            {
                bool? flag8 = projectile.CanHitPlayer(Main.localPlayer);
                if(flag8.HasValue && !flag8.Value)
                {
                    return;
                }
                int num13 = (Main.localPlayer.Center.X < projectile.Center.X) ? -1 : 1;
                int num14 = projectile.damage;
                if(!Main.localPlayer.immune)
                {
                    projectile.StatusPlayer(myPlayer2);
                }
                if(Main.localPlayer.resistCold && projectile.coldDamage)
                {
                    num14 = (int)((float)num14 * 0.7f);
                }
                int num15 = projectile.npcCritChance;
                bool crit2 = Main.rand.Next(1, 101) <= num15;
                float critMult = projectile.npcCritMult;
                Main.localPlayer.ProjectileDamagePlayer(projectile, num13, ref num14, ref crit2, ref critMult);
                projectile.DamagePlayer(Main.localPlayer, num13, ref num14, ref crit2, ref critMult);
                num14 = Main.DamageVar((float)num14, projectile.player);
                int dmgDealt = (int)Main.localPlayer.Hurt(num14 * 2, num13, false, false, Lang.deathMsg(-1, -1, projectile.whoAmI, -1), crit2, critMult);
                Main.localPlayer.ProjectileDealtPlayer(projectile, num13, dmgDealt, crit2);
                projectile.DealtPlayer(Main.localPlayer, num13, dmgDealt, crit2);
            }
        }
    }
}}