using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class DirtGel : ModProjectile
{
    public override void AI()
    {
        if(projectile.localAI[0] == 0f)
        {
            Main.PlaySound(2, (int)projectile.position.X, (int)projectile.position.Y, 3);
            projectile.localAI[0] = 1f;
        }
        if(Main.rand.Next(2) == 0)
        {
            Dust.NewDust(projectile.position, projectile.width, projectile.height, 4, (Main.rand.NextFloat() - 0.5f) * 4f, (Main.rand.NextFloat() - 1f) * 2f, 120, new Color(178, 152, 71), 1f);
        }
        projectile.rotation += 0.1f;
        if(projectile.rotation > 2f * (float)Math.PI)
        {
            projectile.rotation -= 2f * (float)Math.PI;
        }
    }

    public override void DealtPlayer(Player p, int hitDir, int dmgDealt, bool crit)
    {
        if(Main.rand.Next(9) == 0)
        {
            p.AddBuff("Bluemagic:Liquified", 360, true);
            BluemagicNet.SendTransform(p.whoAmI, 1, 360);
        }
    }

    public override void Kill()
    {
        for(int k = 0; k < 3; k++)
        {
            Dust.NewDust(projectile.position, projectile.width, projectile.height, 4, (Main.rand.NextFloat() - 0.5f) * 4f, (Main.rand.NextFloat() - 1f) * 2f, 120, new Color(178, 152, 71), 1f);
        }
        Main.PlaySound(4, (int)projectile.position.X, (int)projectile.position.Y, 1);
    }
}}