using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class Ghoul : Minion
{
    public override void CheckActive(Player player, BluemagicPlayer modPlayer)
    {
        CheckActive(player, ref modPlayer.ghoulMinion);
    }

    public override void AI()
    {
        Player player = Main.player[projectile.owner];
        if(projectile.owner == Main.myPlayer)
        {
            int myNum = 0;
            for(int k = 0; k < projectile.whoAmI; k++)
            {
                Projectile otherProj = Main.projectile[k];
                if(otherProj.active && otherProj.owner == projectile.owner && otherProj.type == projectile.type)
                {
                    myNum++;
                }
            }
            BluemagicPlayer modPlayer = player.GetSubClass<BluemagicPlayer>();
            float angleSpace = 2f * (float)Math.PI / modPlayer.numGhouls;
            float angle = modPlayer.ghoulRotate + angleSpace * myNum;
            Vector2 direction = new Vector2((float)Math.Cos(angle), (float)Math.Sin(angle));
            projectile.Center = player.Center + direction * 128;
            projectile.netUpdate = true;
        }
        projectile.direction = projectile.Center.X < player.Center.X ? -1 : 1;

        bool flag = false;
        for(int k = 0; k < 200; k++)
        {
            if(Main.npc[k].active && !Main.npc[k].friendly && Main.npc[k].Hitbox.Intersects(projectile.Hitbox))
            {
                flag = true;
                break;
            }
        }
        projectile.friendly = flag;

        Lighting.AddLight((int)(projectile.Center.X / 16f), (int)(projectile.Center.Y / 16f), 0.15f, 0.15f, 0.15f);
    }
}}