using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class RuneShot : ModProjectile
{
    public override void AI()
    {
        if(projectile.localAI[0] == 0f)
        {
            projectile.rotation = (float)Math.Atan2(projectile.velocity.Y, projectile.velocity.X);
            projectile.localAI[0] = 1f;
        }
        if(Main.rand.Next(2) == 0)
        {
            BluemagicDust.CreateRuneDust(projectile.position + projectile.velocity, projectile.width, projectile.height);
        }
    }

    public override void Kill()
    {
        if(projectile.friendly)
        {
            Main.PlaySound(2, (int)projectile.position.X, (int)projectile.position.Y, 10);
            for(int k = 0; k < 10; k++)
            {
                Dust.NewDust(projectile.position, projectile.width, projectile.height, 6, 0f, -2f, 0, default(Color), 1f);
            }
        }
    }

    public override void DealtPlayer(Player player, int hitDir, int dmgDealt, bool crit)
    {
        if(Main.rand.Next(5) == 0)
        {
            player.AddBuff(36, 600, true);
        }
        if(Main.rand.Next(5) == 0)
        {
            switch(Main.rand.Next(5))
            {
                case 0:
                    player.AddBuff(39, 400, true);
                    break;
                case 1:
                    player.AddBuff(69, 600, true);
                    break;
                case 2:
                    player.AddBuff(70, 400, true);
                    break;
                case 3:
                    player.AddBuff(24, 600, true);
                    break;
                default:
                    player.AddBuff(44, 400, true);
                    break;
            }
        }
    }

    public override void DealtPVP(Player player, int hitDir, int dmgDealt, bool crit)
    {
        DealtPlayer(player, hitDir, dmgDealt, crit);
    }

    public override void DealtNPC(NPC npc, int hitDir, int dmgDealt, float knockback, bool crit)
    {
        if(Main.rand.Next(5) == 0)
        {
            switch(Main.rand.Next(5))
            {
                case 0:
                    npc.AddBuff(39, 400, false);
                    break;
                case 1:
                    npc.AddBuff(69, 600, false);
                    break;
                case 2:
                    npc.AddBuff(70, 400, false);
                    break;
                case 3:
                    npc.AddBuff(24, 600, false);
                    break;
                default:
                    npc.AddBuff(44, 400, false);
                    break;
            }
        }
    }
}}