using System;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class StarGel : ModProjectile
{
    public override void AI()
    {
        if(projectile.localAI[0] == 0f)
        {
            Main.PlaySound(2, (int)projectile.position.X, (int)projectile.position.Y, 28);
            projectile.localAI[0] = 1f;
        }
        if(Main.rand.Next(2) == 0)
        {
            BluemagicDust.CreateSparkle(projectile.position + projectile.velocity, projectile.width, projectile.height);
        }
        projectile.rotation += 0.02f;
        if(projectile.rotation > 2f * (float)Math.PI)
        {
            projectile.rotation -= 2f * (float)Math.PI;
        }
    }

    public override void DealtPlayer(Player p, int hitDir, int dmgDealt, bool crit)
    {
        if(Main.rand.Next(10) == 0)
        {
            p.AddBuff("Bluemagic:Liquified", 300, true);
            BluemagicNet.SendTransform(p.whoAmI, 1, 300);
        }
    }

    public override void Kill()
    {
        for(int k = 0; k < 3; k++)
        {
            BluemagicDust.CreateSparkle(projectile.position + projectile.velocity, projectile.width, projectile.height);
        }
        Main.PlaySound(2, (int)projectile.position.X, (int)projectile.position.Y, 28);
    }
}}