using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class PhantomBladeBoss : DiagonalHitbox
{
    public override void AI()
    {
        NPC center = Main.npc[(int)projectile.localAI[1]];
        projectile.Center = center.Center;
        base.angle -= (float)Math.PI * 1.5f / 60f;
        projectile.position.X += (float)Math.Cos(base.angle);
        projectile.position.Y += (float)Math.Sin(base.angle);
        projectile.spriteDirection = -1;

        int y = Main.rand.Next((int)base.width) - (int)(base.width / 2f);
        int x = Main.rand.Next((int)base.length);
        float rotatedX = x * (float)Math.Cos(base.angle) - y * (float)Math.Sin(base.angle);
        float rotatedY = x * (float)Math.Sin(base.angle) + y * (float)Math.Cos(base.angle);
        BluemagicDust.CreatePhantomDust(projectile.position.X + rotatedX, projectile.position.Y + rotatedY);
    }

    public override void DealtPlayer(Player p, int hitDir, int dmgDealt, bool crit)
    {
        if(Main.rand.Next(2) == 0)
        {
            p.AddBuff("Bluemagic:EtherealFlames", 300, true);
        }
        float angle = (float)Main.rand.Next(16) * 2f * (float)Math.PI / 16f;
        Projectile.NewProjectile(p.Center.X, p.Center.Y, 15f * (float)Math.Cos(angle), 15f * (float)Math.Sin(angle), "Bluemagic:PhantomWrath", dmgDealt, 0, Main.myPlayer, 0f, 0f);
    }

    public override Color GetAlpha(Color color)
    {
        return Color.White * ((255 - projectile.alpha) / 255f);
    }
}}