using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class PhantomHammer : ModProjectile
{
    public override void AI()
    {
        projectile.rotation += 0.5f;
        if(projectile.timeLeft > 150)
        {
            projectile.position = Main.npc[(int)projectile.ai[0]].Center - new Vector2(projectile.width / 2, projectile.height / 2);
        }
        else if(projectile.timeLeft == 150)
        {
            Vector2 move = Main.player[(int)projectile.ai[1]].Center - projectile.Center;
            float magnitude = (float)Math.Sqrt(move.X * move.X + move.Y * move.Y);
            if(magnitude > 7f)
            {
                move *= 7f / magnitude;
            }
            projectile.velocity = move;
            Main.PlaySound(2, (int)projectile.position.X, (int)projectile.position.Y, 1);
        }
    }

    public override bool PreDraw(SpriteBatch sb)
    {
        sb.Draw(Main.projectileTexture[projectile.type], projectile.Center - Main.screenPosition, null, Color.White * ((255 - projectile.alpha) / 255f), projectile.rotation, new Vector2(projectile.width / 2, projectile.height / 2), 1f, SpriteEffects.None, 0f);
        return false;
    }
}}