using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class PhantomHeal : ModProjectile
{
    public override void AI()
    {
        NPC phantom = Main.npc[(int)projectile.ai[0]];
        if(projectile.Hitbox.Intersects(phantom.Hitbox))
        {
            if(Main.netMode != 1)
            {
                int healAmount = (int)projectile.ai[1];
                if(healAmount > phantom.lifeMax - phantom.life)
                {
                    healAmount = phantom.lifeMax - phantom.life;
                }
                phantom.life += healAmount;
                BluemagicNet.SendNPCHeal(phantom.whoAmI, healAmount);
            }
            projectile.Kill();
        }
        else
        {
            Vector2 move = phantom.Center - projectile.Center;
            float magnitude = (float)Math.Sqrt(move.X * move.X + move.Y * move.Y);
            if(magnitude > 15f)
            {
                move *= 15f / magnitude;
            }
            move = (50f * projectile.velocity + move) / 51f;
            magnitude = (float)Math.Sqrt(move.X * move.X + move.Y * move.Y);
            if(magnitude > 15f)
            {
                move *= 15f / magnitude;
            }
            projectile.velocity = move;
        }
        for(int x = 0; x < 3; x++)
        {
            int dust = BluemagicDust.CreatePhantomDust(projectile.position.X + Main.rand.Next(9), projectile.position.Y + Main.rand.Next(9));
            Main.dust[dust].velocity /= 2f;
        }
    }
}}