using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class PhantomWrath : ModProjectile
{
    public override void AI()
    {
        Player target = null;
        double distance = 1000f;
        for(int k = 0; k < 255; k++)
        {
            if (Main.player[k].active && !Main.player[k].dead)
            {
                Vector2 newMove = Main.player[k].Center - projectile.Center;
                float distanceTo = (float)Math.Sqrt(newMove.X * newMove.X + newMove.Y * newMove.Y);
                if(distanceTo < distance)
                {
                    distance = distanceTo;
                    target = Main.player[k];
                }
            }
        }
        if(projectile.ai[0] >= 5 && target != null)
        {
            Vector2 move = target.Center - projectile.Center;
            float magnitude = (float)Math.Sqrt(move.X * move.X + move.Y * move.Y);
            if(magnitude > 15f)
            {
                move *= 15f / magnitude;
            }
            move = (50f * projectile.velocity + move) / 51f;
            magnitude = (float)Math.Sqrt(move.X * move.X + move.Y * move.Y);
            if(magnitude > 15f)
            {
                move *= 15f / magnitude;
            }
            projectile.velocity = move;
        }
        else
        {
            projectile.ai[0] += 1f;
        }
        for(int x = 0; x < 3; x++)
        {
            int dust = BluemagicDust.CreatePhantomDust(projectile.position.X + Main.rand.Next(9), projectile.position.Y + Main.rand.Next(9));
            Main.dust[dust].velocity /= 2f;
        }
    }

    public override bool? CanHitPlayer(Player p)
    {
        return projectile.ai[0] >= 5f;
    }

    public override void DealtPlayer(Player p, int hitDir, int dmgDealt, bool crit)
    {
        projectile.Kill();
        if(Main.netMode != 0 && projectile.owner != Main.myPlayer)
        {
            BluemagicNet.SendProjKill(projectile.whoAmI);
        }
    }
}}