using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class WispBoss : ModProjectile
{
    private bool sentLocal = false;

    public override void OnSpawn()
    {
        projectile.netImportant = true;
    }

    public override void AI()
    {
        if(Main.netMode == 2 && !sentLocal)
        {
            BluemagicNet.SendProjAllData(projectile.whoAmI);
            sentLocal = true;
        }
        if(projectile.ai[0] > 0f)
        {
            projectile.position = Main.npc[(int)projectile.localAI[0]].Center - new Vector2(projectile.width / 2f, projectile.height / 2f);
            projectile.ai[0] -= 1f;
            return;
        }
        Vector2 move = new Vector2(0f, 0f);
        float distance = 400f;
        Player target = null;
        for(int k = 0; k < 255; k++)
        {
            if (Main.player[k].active && !Main.player[k].dead)
            {
                Vector2 newMove = Main.player[k].Center - projectile.Center;
                float distanceTo = (float)Math.Sqrt(newMove.X * newMove.X + newMove.Y * newMove.Y);
                if(distanceTo < distance)
                {
                    move = newMove;
                    distance = distanceTo;
                    target = Main.player[k];
                }
            }
        }
        if(target != null)
        {
            AdjustMagnitude(ref move);
            projectile.velocity = (5 * projectile.velocity + move) / 6f;
            AdjustMagnitude(ref projectile.velocity);
            bool? flag = projectile.CanHitPlayer(target);
            if(Main.netMode != 2 && target.Hitbox.Intersects(projectile.Hitbox))
            {
                projectile.Damage();
                if(Main.rand.Next(4) == 0)
                {
                    target.AddBuff("Bluemagic:EtherealFlames", 300, true);
                }
                projectile.Kill();
            }
        }

        for(int k2 = 0; k2 < 3; k2++)
        {
            int dust = BluemagicDust.CreatePhantomDust(projectile.position.X + projectile.velocity.X + Main.rand.Next(3), projectile.position.Y + projectile.velocity.Y + Main.rand.Next(3));
            Main.dust[dust].velocity /= 2f;
        }
    }

    private void AdjustMagnitude(ref Vector2 vector)
    {
        float magnitude = (float)Math.Sqrt(vector.X * vector.X + vector.Y * vector.Y);
        if(magnitude > 7f)
        {
            vector *= 7f / magnitude;
        }
    }

    public override void DealtPlayer(Player p, int hitDir, int dmgDealt, bool crit)
    {
        if(Main.npc[(int)projectile.localAI[1]].active)
        {
            float angle = (float)Main.rand.Next(16) * 2f * (float)Math.PI / 16f;
            Projectile.NewProjectile(p.Center.X, p.Center.Y, 15f * (float)Math.Cos(angle), 15f * (float)Math.Sin(angle), "Bluemagic:PhantomHeal", 0, 0, Main.myPlayer, projectile.localAI[1], dmgDealt);
        }
    }
}}