using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class PhantomBlade : DiagonalHitbox
{
    public override void AI()
    {
        Player player = Main.player[projectile.owner];
        if(player.itemAnimation == 0)
        {
            projectile.active = false;
            return;
        }
        if(player.direction + player.gravDir == 0)
        {
            projectile.spriteDirection = -1;
        }
        else
        {
            projectile.spriteDirection = 1;
        }
        projectile.position = player.itemLocation;

        base.angle = player.itemRotation;
        base.angle -= (float)Math.PI / 4f;
        if(player.direction == -1)
        {
            base.angle -= (float)Math.PI / 2f;
        }
        if(player.gravDir == -1)
        {
            if(player.direction == 1)
            {
                base.angle += (float)Math.PI / 2f;
            }
            else
            {
                base.angle -= (float)Math.PI / 2f;
            }
        }
        projectile.position.X += 2 * 14f * (float)Math.Cos(base.angle);
        projectile.position.Y += 2 * 14f * (float)Math.Sin(base.angle);

        int y = Main.rand.Next((int)base.width) - (int)(base.width / 2f);
        int x = Main.rand.Next((int)base.length);
        float rotatedX = x * (float)Math.Cos(base.angle) - y * (float)Math.Sin(base.angle);
        float rotatedY = x * (float)Math.Sin(base.angle) + y * (float)Math.Cos(base.angle);
        BluemagicDust.CreateSpectreDust(base.origin.X + rotatedX, base.origin.Y + rotatedY);
    }

    public override Color GetAlpha(Color color)
    {
        return Color.White * ((255 - projectile.alpha) / 255f);
    }
}}