using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class Wisp : ModProjectile
{
    private static Random rng = new Random();

    public override void OnSpawn()
    {
        AdjustMagnitude(ref projectile.velocity);
    }

    public override void AI()
    {
        Vector2 move = new Vector2(0f, 0f);
        float distance = 400f;
        bool target = false;
        for(int k = 0; k < 200; k++)
        {
            if (Main.npc[k].active && !Main.npc[k].dontTakeDamage && !Main.npc[k].friendly && Main.npc[k].lifeMax > 5)
            {
                Vector2 newMove = Main.npc[k].Center - projectile.Center;
                float distanceTo = (float)Math.Sqrt(newMove.X * newMove.X + newMove.Y * newMove.Y);
                if(distanceTo < distance)
                {
                    move = newMove;
                    distance = distanceTo;
                    target = true;
                }
            }
        }
        if(target)
        {
            AdjustMagnitude(ref move);
            projectile.velocity = (10 * projectile.velocity + move) / 11f;
            AdjustMagnitude(ref projectile.velocity);
        }

        for(int k2 = 0; k2 < 3; k2++)
        {
            int dust = BluemagicDust.CreateSpectreDust(projectile.position.X + projectile.velocity.X + rng.Next(3), projectile.position.Y + projectile.velocity.Y + rng.Next(3));
            Main.dust[dust].velocity /= 2f;
        }
    }

    private void AdjustMagnitude(ref Vector2 vector)
    {
        float magnitude = (float)Math.Sqrt(vector.X * vector.X + vector.Y * vector.Y);
        if(magnitude > 4f)
        {
            vector *= 4f / magnitude;
        }
    }

    public override void DealtNPC(NPC npc, int hitDir, int dmgDealt, float knockback, bool crit)
    {
        if(rng.Next(2) == 0)
        {
            npc.AddBuff("Bluemagic:EtherealFlames", 300, false);
        }
    }
}}