using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class PurityWisp : HoverShooter
{
    public override void CheckActive(Player player, BluemagicPlayer modPlayer)
    {
        CheckActive(player, ref modPlayer.purityMinion);
    }

    public override void CreateDust()
    {
        if(projectile.ai[0] == 0f)
        {
            if(Main.rand.Next(5) == 0)
            {
                BluemagicDust.CreatePuriumFlameDust(projectile.position, new Vector2(0, -1.2f), projectile.width, projectile.height / 2);
            }
        }
        else
        {
            if(Main.rand.Next(3) == 0)
            {
                Vector2 dustVel = projectile.velocity;
                dustVel.Normalize();
                BluemagicDust.CreatePuriumFlameDust(projectile.position, -1.2f * dustVel, projectile.width, projectile.height);
            }
        }
        Lighting.AddLight((int)(projectile.Center.X / 16f), (int)(projectile.Center.Y / 16f), 0.6f, 0.9f, 0.3f);
    }

    public override void SelectFrame()
    {
        projectile.frameCounter++;
        if(projectile.frameCounter >= 8)
        {
            projectile.frameCounter = 0;
            projectile.frame = (projectile.frame + 1) % 3;
        }
    }
}}