using System;
using Microsoft.Xna.Framework;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class PuriumBoom : ModProjectile
{
    public override void AI()
    {
        projectile.localAI[0] = (projectile.localAI[0] + 1f) % 4f;
        if(projectile.localAI[0] == 0f)
        {
            BluemagicDust.CreatePuriumBulletDust(projectile.position);
        }

        if(projectile.ai[0] <= 0f)
        {
            projectile.Kill();
        }
        projectile.ai[0] -= 1f;
    }

    public override void Kill()
    {
        projectile.position = projectile.Center;
        for(int k = 0; k < 4; k++)
        {
            float scale = 0.4f * k;
            CreateGore(scale, 1f, 1f);
            CreateGore(scale, -1f, 1f);
            CreateGore(scale, 1f, -1f);
            CreateGore(scale, -1f, -1f);
        }
        Main.PlaySound(2, (int)projectile.position.X, (int)projectile.position.Y, 14);

        projectile.width = 160;
        projectile.height = 160;
        projectile.position -= projectile.Size / 2f;
        projectile.friendly = true;
        projectile.Damage();
    }

    private void CreateGore(float scale, float offX, float offY)
    {
        int gore = Gore.NewGore(projectile.position, Vector2.Zero, Main.rand.Next(435, 438), 1f);
        Main.gore[gore].velocity *= scale;
        Main.gore[gore].velocity.X += offX;
        Main.gore[gore].velocity.Y += offY;
    }
}}