using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class PuriumSlice : ModProjectile
{
    public override void AI()
    {
        Lighting.AddLight((int)(projectile.position.X / 16f), (int)(projectile.position.Y / 16f), 0.3f, 0.6f, 0.2f);

        projectile.rotation += (float)projectile.direction * 0.6f;
        projectile.ai[0] += 1f;
        if(projectile.ai[0] >= 30f)
        {
            if(projectile.ai[0] < 100f)
            {
                projectile.velocity *= 1.06f;
            }
            else
            {
                projectile.ai[0] = 200f;
            }
        }

        if(Main.rand.Next(2) == 0)
        {
            int dust = BluemagicDust.CreatePuriumSliceDust(projectile.position, projectile.width, projectile.height);
            Main.dust[dust].noGravity = true;
        }

        int num37 = projectile.width - 36;
        int num38 = projectile.height - 36;
        Vector2 position8 = new Vector2(projectile.Center.X - (float)(num37 / 2), projectile.Center.Y - (float)(num38 / 2));
        projectile.velocity = Collision.TileCollision(position8, projectile.velocity, num37, num38, true, true, 1);
    }

    public override void Kill()
    {
        Main.PlaySound(2, (int)projectile.position.X, (int)projectile.position.Y, 10);
        for(int k = 0; k < 15; k++)
        {
            int dust = BluemagicDust.CreatePuriumSliceDust(projectile.position, projectile.width, projectile.height);
            Main.dust[dust].noGravity = true;
            BluemagicDust.CreatePuriumSliceDust(projectile.position, projectile.width, projectile.height);
        }
    }

    public override bool PreDraw(SpriteBatch sb)
    {
        SpriteEffects effects = SpriteEffects.None;
        if(projectile.spriteDirection == -1)
        {
            effects = SpriteEffects.FlipHorizontally;
        }
        sb.Draw(Main.projectileTexture[projectile.type], projectile.Center - Main.screenPosition, null, Color.White, projectile.rotation, new Vector2(projectile.width / 2, projectile.height / 2), projectile.scale, effects, 0f);
        return false;
    }
}}