using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace Bluemagic.Projectiles {
public class PuriumSpear : ModProjectile
{
    public override void AI()
    {
        Player player = Main.player[projectile.owner];
        projectile.direction = player.direction;
        player.heldProj = projectile.whoAmI;
        player.itemTime = player.itemAnimation;
        projectile.position = player.Center - projectile.Size / 2f;

        if(!player.frozen)
        {
            if(projectile.ai[0] == 0f)
            {
                projectile.ai[0] = 3f;
                projectile.netUpdate = true;
            }
            if(player.itemAnimation < player.itemAnimationMax / 3)
            {
                projectile.ai[0] -= 2.4f;
            }
            else
            {
                projectile.ai[0] += 2.1f;
            }
        }
        projectile.position += projectile.velocity * projectile.ai[0];

        float speed = (float)Math.Sqrt(projectile.velocity.X * projectile.velocity.X + projectile.velocity.Y * projectile.velocity.Y);
        Projectile.NewProjectile(projectile.Center, projectile.velocity * 2f / speed, "Bluemagic:PuriumLightbeam", projectile.damage, projectile.knockBack, projectile.owner, 0f, 0f);

        if(player.itemAnimation == 0)
        {
            projectile.Kill();
        }
        projectile.rotation = (float)Math.Atan2(projectile.velocity.Y, projectile.velocity.X) + 2.355f;
        if(projectile.spriteDirection == -1)
        {
            projectile.rotation -= 1.57f;
        }
    }

    public override bool PreDraw(SpriteBatch sb)
    {
        projectile.aiStyle = 19;
        return true;
    }

    public override void PostDraw(SpriteBatch sb)
    {
        projectile.aiStyle = 0;
    }
}}