using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace Bluemagic.Tiles {
public class Shroomsand : ModTileType
{
    public override bool TileFrame(int x, int y)
    {
        if(WorldGen.noTileActions)
        {
            return false;
        }
        Tile above = Main.tile[x, y - 1];
        Tile below = Main.tile[x, y + 1];
        if(below != null && !below.active() && (!above.active() || !(above.type == 21 || TileDef.chest[(int)above.type] || above.type == 323)))
        {
            Main.tile[x, y].active(false);
            if (Main.netMode == 0)
            {
                int proj = Projectile.NewProjectile((float)(x * 16 + 8), (float)(y * 16 + 8), 0f, 0.41f, "Bluemagic:ShroomsandBall", 10, 0f, Main.myPlayer, 1f, 0f);
                WorldGen.SquareTileFrame(x, y, true);
            }
            else if (Main.netMode == 2)
            {
                int proj = Projectile.NewProjectile((float)(x * 16 + 8), (float)(y * 16 + 8), 0f, 2.5f, "Bluemagic:ShroomsandBall", 10, 0f, Main.myPlayer, 1f, 0f);
                Main.projectile[proj].velocity.Y = 0.5f;
                Main.projectile[proj].position.Y += 2f;;
                Main.projectile[proj].netUpdate = true;
                NetMessage.SendTileSquare(-1, x, y, 1);
                WorldGen.SquareTileFrame(x, y, true);
            }
            return true;
        }
        return false;
    }

    public override void ModifyLight(int x, int y, ref float r, ref float g, ref float b)
    {
        float num = Main.rand.Next(28, 42) * 0.005f;
        num += (270f - Main.mouseTextColor) / 1000f;
        r = 0.1f;
        g = 0.2f + num / 2f;
        b = 0.7f + num;
    }
}}